// AIBehavior.cpp: implementation of the AIBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "AIBehavior.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AIBehavior::AIBehavior()
{

}

AIBehavior::~AIBehavior()
{

}


#define UP_AMT 0
#define DOWN_AMT 1
#define RIGHT_AMT 2
#define LEFT_AMT 3
#define FWD_AMT 4
#define BACK_AMT 5

void AIBehavior::steerTo(Targetable * object, Coordinate steeringvector)
{
  float amounts[6];
  float max;
  
  amounts[UP_AMT] = steeringvector.dot(object->getUp() );
  amounts[DOWN_AMT] = - amounts[UP_AMT] ;
  amounts[LEFT_AMT] = steeringvector.dot(object->getleft() );
  amounts[RIGHT_AMT] = -amounts[LEFT_AMT];
  amounts[FWD_AMT] = steeringvector.dot(object->getHeading() );
  amounts[BACK_AMT] = - amounts[FWD_AMT];

  max=maximum(amounts, 6);

  if(max < .07)
    return;

  if(amounts[BACK_AMT] == max)
  {
    max = maximum(amounts, 5); 
  }

  if(sameSign(amounts[UP_AMT], max) )
  {
     object->rotateDownPercent( amounts[UP_AMT] / max);
  }
  if(sameSign(amounts[DOWN_AMT], max) )
  {
     object->rotateUpPercent( amounts[DOWN_AMT] / max);
  }
  if(sameSign(amounts[LEFT_AMT], max) )
  {
     object->rotateLeftPercent( amounts[LEFT_AMT] / max);
  }
  if(sameSign(amounts[RIGHT_AMT], max) )
  {
     object->rotateRightPercent( amounts[RIGHT_AMT] / max);
  } 
}

float AIBehavior::maximum(float amounts [ ], int num)
{
  float mymax = amounts[0];
  int i;

  for(i=1; i < num; i++)
  {
     if(amounts[i] > mymax)
       mymax = amounts[i];
  }
  return mymax;
}

bool AIBehavior::sameSign(float a, float b)
{
  if(a < 0.0f && b < 0.0f)
    return true;
  if(a > 0.0f && b > 0.0f)
    return true;
  return false;  
}

Coordinate AIBehavior::getSteeringVector(Targetable * body, Targetable *  target)
{
  Coordinate c;

  return c;
}
