// AbstractBillboard.cpp: implementation of the AbstractBillboard class.
//
//////////////////////////////////////////////////////////////////////
#include <GL/glew.h>
#include "glut.h"
#include "AbstractBillboard.h"
#include "Texture.h"
#include "TextureFactory.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AbstractBillboard::AbstractBillboard(char filename[], float newwidth, float newheight)
{
	height = newheight;
	width = newwidth;	
	alpha = 1.0f;
	texture = TextureFactory::getTransparentTexture(filename, Color(0,0,0) );
//texture = TextureFactory::getTransparentTexture(filename );
}

AbstractBillboard::AbstractBillboard(Texture * newtexture, float newwidth, float newheight)
{
	height = newheight;
	width = newwidth;	
	texture = newtexture;
	alpha = 1.0f;
}

AbstractBillboard::~AbstractBillboard()
{

}


void AbstractBillboard::renderRect()
{
  float w_2 = width/2.0f;
  float h_2 = height/2.0f;
 

/*  glBegin(GL_LINE_LOOP );
    glVertex3f(-w_2,+h_2 ,0 );
    glVertex3f(+w_2,+h_2 ,0 );
    glVertex3f(+w_2,-h_2 ,0 );
    glVertex3f(-w_2,-h_2 ,0 );
  glEnd();
*/
  glColor4f(1.0f, 1.0f, 1.0f, alpha);
  glEnable(GL_COLOR_MATERIAL);
  glDisable(GL_LIGHTING);
  glEnable(GL_TEXTURE_2D);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glEnable(GL_BLEND);

  texture->render();
  glBegin(GL_QUADS);  
    glTexCoord2f(0.0f, 0.0f);
	glVertex3f(-w_2,-h_2 ,0 );
    glTexCoord2f(0.0f, 1.0f);
    glVertex3f(+w_2,-h_2 ,0 );
    glTexCoord2f(1.0f, 1.0f);
    glVertex3f(+w_2,+h_2 ,0 );
    glTexCoord2f(1.0f, 0.0f);
    glVertex3f(-w_2,+h_2 ,0 );
  glEnd();
  glDisable(GL_BLEND);
  glEnable(GL_LIGHTING);
}


void AbstractBillboard::setAlpha(float newalpha)
{
  alpha = newalpha;
}
