// AmbientLight.cpp: implementation of the AmbientLight class.
//
//////////////////////////////////////////////////////////////////////

#include "AmbientLight.h"
#include <glut.h>
#include "glerr.h"
#include <string.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AmbientLight::AmbientLight(Color newcolor)
{
  color = newcolor;
}

AmbientLight::~AmbientLight()
{
}

void AmbientLight::render()
{
  GLfloat ambientlight[] = { color.r, color.g, color.b, 1.0f};
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambientlight);
}

bool AmbientLight::instanceof(char name [ ])
{
  if(strcmp(name, "AmbientLight") == 0)
  {
    return true;
  }
  return Light::instanceof(name);
}
