// AsteroidField.cpp: implementation of the AsteroidField class.
//
//////////////////////////////////////////////////////////////////////

#include "AsteroidField.h"
#include "World.h"
#include "MeshFileFactory.h"
#include "mesh.h"
#include "Asteroid.h"
#include "BinaryMeshFile.h"
#include <stdlib.h>
#include <time.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AsteroidField::AsteroidField()
{
  collisionmodel = newCollisionModel3D(true);
}

AsteroidField::~AsteroidField()
{

}

void AsteroidField::generate(Coordinate center, int numasteroids, float radius)
{
  float volume = 4.0f / 3.0f * 3.14159f * radius * radius * radius;
  float invdensity = ((float)numasteroids) / volume; /* volume per asteroid */
  Coordinate location;
  int side = 9;


  int i, j, k;



  astmesh[0] = new mesh("asteroid_g_01.mesh.bin");
  astmesh[1] = new mesh("asteroid_g_02.mesh.bin");

  float aradius = astmesh[0]->getradius();


  float random;
  float separation = 1500.0f;
  float halfseparation = separation * .5f;
  
  int halfside = side/2;

  for(i=-halfside; i < halfside; i++)
  {
	  for(j=-halfside; j < halfside; j++)
	  {
		  for(k=-halfside; k < halfside; k++)
		  {

             float offsetx = randomv(-halfseparation + aradius, halfseparation - aradius);
			 float offsety = randomv(-halfseparation + aradius, halfseparation - aradius);
			 float offsetz = randomv(-halfseparation + aradius, halfseparation - aradius);
				
			 location.x = separation * i +  offsetx;
			 location.y = separation * j + offsety;
			 location.z = separation * k + offsetz;
             add(0, location + center);
		  }
	  }
  }  
//  collisionmodel->finalize();
//  World::getWorld().setAsteroidModel(collisionmodel);

}

void AsteroidField::add(int asteroidtype, Coordinate location)
{
	Asteroid * asteroid;
	int meshindex = rand() % 2;

	asteroid = new Asteroid(astmesh[meshindex], location, 0.0f, 0.0f, 0.0f, 0.0f);
	World::getWorld().addAsteroid(asteroid);
//	meshfile->addToCollisionModel(collisionmodel, location);
}

float AsteroidField::randomv(float min, float max)
{
  float myrandom;

  myrandom = rand();
  myrandom /= (float) RAND_MAX; // between 0 and 1
  return myrandom * min + (1.0f - myrandom) * max;
}
