// AviMovie.h: interface for the AviMovie class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AVIMOVIE_H__8E956202_4B3A_41C9_ABF0_AAFCAC582DA6__INCLUDED_)
#define AFX_AVIMOVIE_H__8E956202_4B3A_41C9_ABF0_AAFCAC582DA6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Movie.h"
#include "Time.h"
#include "BmpImage.h"
#ifdef WIN32
#include <windows.h>
#include <vfw.h>
#endif

class AviMovie : public Movie  
{
public:
	virtual bool isPlaying();
	static void staticClear();
	static void staticInit();
	virtual void stop();
	AviMovie(char filename[]);
	virtual ~AviMovie();
	virtual Image * getCurrentFrame();
	virtual void start();
private:
#ifdef WIN32
	char * grabFrame(BITMAPINFOHEADER * * bipp, int frame);
	AVISTREAMINFO		psi;										
	PAVISTREAM			pavi;	
	PGETFRAME			pgf;	
#endif
	TimeValue starttime;
	BmpImage * lastimage;
    int lastframe;
	int currentframe;
	float mpf;// milliseconds per frame
	bool playing;

};

#endif // !defined(AFX_AVIMOVIE_H__8E956202_4B3A_41C9_ABF0_AAFCAC582DA6__INCLUDED_)
