// AxisAlignedBillboard.cpp: implementation of the AxisAlignedBillboard class.
//
//////////////////////////////////////////////////////////////////////

#include "AxisAlignedBillboard.h"
#include "Camera.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AxisAlignedBillboard::AxisAlignedBillboard(char filename[], float newwidth, float newheight)
: AbstractBillboard(filename, newwidth, newheight)
{

}

AxisAlignedBillboard::~AxisAlignedBillboard()
{

}

void AxisAlignedBillboard::render()
{
   Coordinate cameraheading, minuscameraheading;
   Coordinate right;
   Coordinate up;
   Coordinate location;
   Coordinate myheading = getHeading();
   Coordinate desired_up;
   location = getLocation();


   Coordinate difference = location - Camera::getCamera()->getLocation();
   difference.normalize();

   desired_up = difference * -1.0f;

   right = desired_up.cross(myheading);
   right.normalize();
   up = myheading.cross(right);
   up.normalize();
   
   
   glNormal3f(up.x, up.y, up.z);
   glPushMatrix();
     glTranslatef(location.x, location.y, location.z);
     matchDOF(up, myheading);    
     renderRect();
   glPopMatrix();
   GLERRORCHECK

}
