// BMPFile.cpp: implementation of the BMPFile class.
//
//////////////////////////////////////////////////////////////////////

#include "BMPFile.h"
#include "Bitmap.h"
#include <iostream.h>
#include "FileNotFoundException.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BMPFile::BMPFile(char filename [ ])
{
  BITMAPINFO	*info;				/* Bitmap information */
  void		*bits;				/* Bitmap pixel bits */

  freeme = true;
 /*
  * Try loading the bitmap and converting it to RGB...
  */

  bits = LoadDIBitmap(filename, &info);
  if(bits == NULL)
  {
    throw FileNotFoundException(filename);
  }
  data = ConvertRGB(info, bits);
  width = info->bmiHeader.biWidth;
  height = info->bmiHeader.biHeight;
  if(freeme)
  {
    free(info);
    free(bits);
  }
}

BMPFile::~BMPFile()
{

}


int BMPFile::getWidth()
{
  return width;
}

int BMPFile::getHeight()
{
  return height;
}

GLubyte * BMPFile::getData()
{
  return data;
}

BMPFile::BMPFile(BITMAPINFO * info, void * bits)
{
  data = ConvertRGB(info, bits);
  width = info->bmiHeader.biWidth;
  height = info->bmiHeader.biHeight;
  freeme = true;
}

