// BackCamera.cpp: implementation of the BackCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "BackCamera.h"
#include "ship.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BackCamera BackCamera::me;

BackCamera::BackCamera()
{

}

BackCamera::~BackCamera()
{

}

Coordinate BackCamera::getHeading()
{
  Coordinate zero;


  return zero - Camera::getFocusObject()->getHeading();
}

void BackCamera::render()
{
  Coordinate lookat;
  Object3d * myfocus = Camera::getFocusObject();

  myfocus->setrenderingenabled(false);
  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  Coordinate heading = myship->getHeading();
  Coordinate up = myship->getUp();

  lookat = (heading * CAMERA_VIEW_RADIUS);

  gluLookAt((GLdouble) cockpit.x, (GLdouble) cockpit.y, (GLdouble) cockpit.z, 
            (GLdouble) (cockpit.x -lookat.x), 
            (GLdouble) (cockpit.y - lookat.y), 
            (GLdouble) (cockpit.z - lookat.z),             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);

  GLERRORCHECK
}

bool BackCamera::isVisibible(Coordinate point)
{
  return true;
}

Camera * BackCamera::getInstance()
{
  return & me;
}

Coordinate BackCamera::getLocation()
{
  Coordinate lookat;
  Object3d * myfocus = Camera::getFocusObject();

  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  return cockpit;
}

Coordinate BackCamera::getLeft()
{
  Object3d * myfocus = Camera::getFocusObject();
  Coordinate zero;
  return zero - myfocus->getleft();
}
