// BinaryMeshFile.h: interface for the BinaryMeshFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BINARYMESHFILE_H__B4921F00_13E9_4C7B_91B9_1BDF0A26EDB5__INCLUDED_)
#define AFX_BINARYMESHFILE_H__B4921F00_13E9_4C7B_91B9_1BDF0A26EDB5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "AbstractMeshFile.h"
#include "coord.h"
#include "Texel.h"
#include <iostream.h>
#include  <fstream.h>
#include <iomanip.h>
#include <string>
#include "Texture.h"
#include "Color.h"
#include "coldet.h"

using std::string;

class BinaryMeshFile : public AbstractMeshFile  
{
public:
	void addToCollisionModel(CollisionModel3D * model, Coordinate translation);
	void renderWireFrame(Color newcolor);
	CollisionModel3D * getCollisionModel();
	 BinaryMeshFile(char filename[], Color transparent);
	BinaryMeshFile(char filename[]);
	virtual ~BinaryMeshFile();
	virtual Coordinate getExtents();
	virtual Coordinate getcenter();
	virtual float getradius();
	virtual void render();
	virtual Coordinate getMins();
	virtual Coordinate getMaxs();
private:
	void initExtents();
	void maxminTriangle(float x, float y, float z);
	void setLess(float testvalue, float & storto);
	void setGreater(float testvalue, float & storto);
	void initCollisionDetection(CollisionModel3D * mycollision_detection, Coordinate translation);
	void readFace(int currentface);
	void readCoordinate(Coordinate & coord);
   class Face
   {
      public:
         Coordinate points[4];
         Coordinate normals[4];
         Texel texels[4];
         int numpoints;
   };
   Face * faces;
   float radius;
   Coordinate extents;
   Coordinate center;
   ifstream in;
   int numtextures;
   int numfaces;
   Texture * * textures;
   CollisionModel3D * mycollision_detection;
   float minx;
   float miny;
   float minz;
   float maxx;
   float maxy;
   float maxz;
};

#endif // !defined(AFX_BINARYMESHFILE_H__B4921F00_13E9_4C7B_91B9_1BDF0A26EDB5__INCLUDED_)
