// Image.cpp: implementation of the Image class.
//
//////////////////////////////////////////////////////////////////////

#include "BmpImage.h"
#include <stdlib.h>
#include <GL/glew.h>
#include <assert.h>
#include "TextureFactory.h"
#include "glerr.h"
#include "TextureImpl.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


BmpImage::BmpImage(char filename[])
{
  texture = TextureFactory::getTexture(filename);
  width = texture->getWidth();
  height = texture->getHeight();
}

BmpImage::~BmpImage()
{

}


void BmpImage::render(float x, float y)
{
   glEnable(GL_TEXTURE_2D);
   if(colorset)
   {
      color.render();
      glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
   }
   else
   {
      glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
   }
GLERRORCHECK
  texture->render();
GLERRORCHECK
  glNormal3f(0.0f, 0.0f, 1.0f);
GLERRORCHECK
  glBegin(GL_QUADS);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(x, y);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(x + getWidth(), y);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(x + getWidth(), y + getHeight() );
    glTexCoord2f(0.0f, 1.0f);
	glVertex2f(x , y + getHeight() );
  glEnd();
GLERRORCHECK
  glDisable(GL_TEXTURE_2D);


}

int BmpImage::getWidth()
{
  return width;
}

int BmpImage::getHeight()
{
  return height;
}


BmpImage::BmpImage(char filename [ ], int newwidth, int newheight)
{
  texture = TextureFactory::getTexture(filename);
GLERRORCHECK
  width = newwidth;
  height = newheight;
}

BmpImage::BmpImage(GLubyte * bits, int newwidth, int newheight)
{
  width = newwidth;
  height = newheight;
  GLERRORCHECK
  texture = new TextureImpl(bits, width, height);
  GLERRORCHECK
}

void BmpImage::recycle(GLubyte * bits, int width, int height)
{
  texture->recycle(bits, width, height);
  GLERRORCHECK
}
