// BorderingReticle.cpp: implementation of the BorderingReticle class.
//
//////////////////////////////////////////////////////////////////////

#include "BorderingReticle.h"
#include "ImageFactory.h"
#include "Color.h"
#include "Image.h"
#include "glut.h"
#include <string>

using std::string;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BorderingReticle::BorderingReticle(char imagename[])
{
  leftimage = ImageFactory::getTransparentImage((char *) (imagename + string("left.bmp")).c_str() , Color(0.0f,0.0f,0.0f) );
  rightimage = ImageFactory::getTransparentImage((char *) (imagename + string("right.bmp")).c_str() , Color(0.0f,0.0f,0.0f) );
  topimage = ImageFactory::getTransparentImage((char *) (imagename + string("top.bmp")).c_str() , Color(0.0f,0.0f,0.0f) );
  bottomimage = ImageFactory::getTransparentImage((char *) (imagename + string("bottom.bmp")).c_str() , Color(0.0f,0.0f,0.0f) );

}

BorderingReticle::~BorderingReticle()
{

}

void BorderingReticle::render(Rect & rectangle, float lock_percentage)
{
   float half_h = rectangle.height / 2.0f;
   float half_w = rectangle.width / 2.0f;
   float startx, starty;

   startx = rectangle.x - topimage->getWidth() /2;
   starty = rectangle.y - topimage->getHeight() /2;

   leftimage->render(startx, starty + half_h);
   bottomimage->render(startx + half_w, starty);
   rightimage->render(startx+ rectangle.width, starty + half_h);
   topimage->render(startx + half_w, starty + rectangle.height);


}
