// BriefingNavPoint.h: interface for the BriefingNavPoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BRIEFINGNAVPOINT_H__665A7975_69EE_4131_8331_12C5B6FAB410__INCLUDED_)
#define AFX_BRIEFINGNAVPOINT_H__665A7975_69EE_4131_8331_12C5B6FAB410__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "coord.h"
#include "Circle.h"
#include <vector>
#include <string>
#include "BriefingShip.h"
#include "SoundEffect.h"


#pragma warning( disable : 4786)

class BriefingNavPoint  
{
public:
	SoundEffect * getLeavingSpeech();
	SoundEffect * getAtSpeech();
	std::string getLeavingText();
	std::string getAtText();
	void render();
	Coordinate getLocation();
	BriefingNavPoint(int id, Coordinate newlocation, float newradius, 
		std::vector<BriefingShip *> * newfixedships,
		std::string newattext, std::string newleavingtext);
	virtual ~BriefingNavPoint();
private:
	Coordinate location;
	float radius;
	Circle * mycircle;
	std::vector<BriefingShip *> * fixedships;
	static Color green;
	std::string at_text;
	std::string leaving_text;
	SoundEffect * at_speech;
    SoundEffect * leaving_speech;
    
};

#endif // !defined(AFX_BRIEFINGNAVPOINT_H__665A7975_69EE_4131_8331_12C5B6FAB410__INCLUDED_)
