// BriefingPanel.cpp: implementation of the BriefingPanel class.
//
//////////////////////////////////////////////////////////////////////

#include "BriefingPanel.h"
#include "MissionXmlAdapter.h"
#include "TextToSpeech.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BriefingPanel::BriefingPanel()
{
  setTitle("Mission Briefing");
  setConfirmText("OK");
  start = false;
}

BriefingPanel::~BriefingPanel()
{

}


void BriefingPanel::onConfirm()
{
  start = true;
}

void BriefingPanel::onCancel()
{
  start = false;
}

bool BriefingPanel::getStart()
{
  return start;
}

void BriefingPanel::setMission(std::string missionname)
{
   MissionXmlAdapter adapter((char *) missionname.c_str() );
   missiontext = "";
   
   int i;
   int numlines;
   std::string * lines;

   lines = adapter.getBriefingText();
   numlines = adapter.getNumBriefingLines();
   setNumLines(numlines );
   for(i=0; i < numlines; i++)
   {
      setLine(lines[i], i);
	  missiontext += lines[i];
   }   


}

bool BriefingPanel::onKeyboard(unsigned char key, int x, int y)
{
   if(key == 27)
   {
     start = false;
   }
   else
   {
     start = true;
   }
   return true;
}

void BriefingPanel::update()
{
//   TextToSpeech::getInstance()->synthesizeAndPlay((char *) missiontext.c_str() );
}
