// BriefingXmlAdapter.h: interface for the BriefingXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BRIEFINGXMLADAPTER_H__0151DB12_431F_408D_A06A_D7016AD4FD7F__INCLUDED_)
#define AFX_BRIEFINGXMLADAPTER_H__0151DB12_431F_408D_A06A_D7016AD4FD7F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>
#include <vector>
#include "coord.h"
#include "BriefingShip.h"
#include "BriefingNavPoint.h"

using namespace SAX;
using std::string;


class BriefingXmlAdapter  : public HandlerBase
{
public:
	BriefingShip * getPlayer();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endDocument();
	virtual void startDocument();
    virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
	BriefingXmlAdapter(char filename[]);
	virtual ~BriefingXmlAdapter();
    std::vector<BriefingNavPoint *> * getNavPoints();
	std::vector<BriefingShip *> * getAutopilotShips();
private:
	std::string lasttext;
	std::string at_text;
	std::string leaving_text;
	std::string shipname;
	bool enemy;
	bool capship;
	bool autopilot;
	Coordinate currentpoint;
	float radius;
    std::vector<BriefingShip *> * fixedships;
    std::vector<BriefingShip *> * autopilotships;
    std::vector<BriefingNavPoint *> * navpoints;
	BriefingShip * player;
	float scale;
	int lastautopilotnav;
};

#endif // !defined(AFX_BRIEFINGXMLADAPTER_H__0151DB12_431F_408D_A06A_D7016AD4FD7F__INCLUDED_)
