// Camera.cpp: implementation of the Camera class.
//
//////////////////////////////////////////////////////////////////////

#include "Camera.h"
#include <glut.h>
#include "ship.h"
#include "CockpitCamera.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Object3d * Camera::myfocus = NULL;
Camera * Camera::currentcamera = CockpitCamera::getInstance();

Camera::Camera()
{

}

Camera::~Camera()
{

}

void Camera::setFocusObject(Object3d * object)
{
  myfocus = object;
}


Object3d * Camera::getFocusObject()
{
   return myfocus;
}

bool Camera::shouldRenderCockpit()
{
  return false;
}


bool Camera::showMovingStars()
{
  return true;
}

Camera * Camera::getCamera()
{
  return currentcamera;
}

void Camera::setCamera(Camera * newcamera)
{
  currentcamera = newcamera;
  currentcamera->onCameraChange();
}

void Camera::onCameraChange()
{

}

Coordinate Camera::getUp()
{
  if(myfocus == NULL)
    return Coordinate();
  return myfocus->getUp();
}

Coordinate Camera::getLeft()
{
  Coordinate zero;

  return zero - getHeading().cross( getUp() );
}

