// Camera.h: interface for the Camera class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CAMERA_H__84E484E4_7E59_4A4C_AFB0_DA7FB2C53150__INCLUDED_)
#define AFX_CAMERA_H__84E484E4_7E59_4A4C_AFB0_DA7FB2C53150__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Object3d.h"
#include "coord.h"	// Added by ClassView

#define CAMERA_VIEW_RADIUS 6.0f

class Camera  
{
public:
	virtual Coordinate getLocation()=0;
	virtual Coordinate getLeft();
	virtual Coordinate getUp();
	virtual void onCameraChange();
	static void setCamera(Camera * newcamera);
	static Camera * getCamera();
	virtual bool showMovingStars();
	virtual bool shouldRenderCockpit();
	static Object3d * getFocusObject();
	virtual Coordinate getHeading()=0;
	static void setFocusObject(Object3d * object);
	virtual void render()=0;
	virtual ~Camera();
protected:
	Camera();
private:
   static Object3d * myfocus;
   static Camera * currentcamera;

};

#endif // !defined(AFX_CAMERA_H__84E484E4_7E59_4A4C_AFB0_DA7FB2C53150__INCLUDED_)
