// CampaignXmlAdapater.cpp: implementation of the CampaignXmlAdapater class.
//
//////////////////////////////////////////////////////////////////////

#include "CampaignXmlAdapater.h"
#include "AttributeList.h"
#include <ctype.h>
#include "saxexpat.h"
#include "InputSource.h"
#include "ErrorHandlerE.h"
#include "OutOfBoundsException.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CampaignXmlAdapater::CampaignXmlAdapater(char filename[])
{
	expat myParser;

   ErrorHandlerE::checkFile(filename);
   currentmission = 0;
	myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse((*new SAX::InputSource(filename)));
}

CampaignXmlAdapater::~CampaignXmlAdapater()
{

}

void CampaignXmlAdapater::startDocument()
{

}

void CampaignXmlAdapater::endDocument()
{

}

void CampaignXmlAdapater::startElement(const std::string& name, const SAX::AttributeList* atts)
{
   int i;

   if(name == "campaign")
   {
      for(i=0; i < atts->getLength(); i++)
      {
        std::string  currentname = atts->getName(i);
        std::string  currentvalue = atts->getValue(i);

         if(currentname == "name")
         {
            title = currentvalue;
         }
         else if(currentname == "nummissions")
         {
            nummissions = atoi((char *) currentvalue.c_str() );
            win = new string[nummissions];
            lose = new string[nummissions];
            missions = new string[nummissions];
         }
      }
   }
   else if(name == "mission")
   {
      for(i=0; i < atts->getLength(); i++)
      {
        std::string  currentname = atts->getName(i);
        std::string  currentvalue = atts->getValue(i);

         if(currentname == "file")
         {
            if(currentmission >= nummissions)
            {
              throw OutOfBoundsException("");
            }
            missions[currentmission] = currentvalue;
         }
         else if(currentname == "win")
         {
            if(currentmission >= nummissions)
            {
              throw OutOfBoundsException("");
            }

            win[currentmission] = currentvalue;
         }
         else if(currentname == "lose")
         {
            if(currentmission >= nummissions)
            {
              throw OutOfBoundsException("");
            }

            lose[currentmission] = currentvalue;
         }
      }
   }

}

void CampaignXmlAdapater::endElement(const std::string& name)
{
  if(name == "mission")
    currentmission++;
}


void CampaignXmlAdapater::characters(const std::string& ch)
{


}


int CampaignXmlAdapater::getNumMissions()
{
  return nummissions;
}

string * CampaignXmlAdapater::getNames()
{
  return missions;
}

string * CampaignXmlAdapater::getWins()
{
  return win;
}

string * CampaignXmlAdapater::getLose()
{
  return lose;
}

string CampaignXmlAdapater::getTitle()
{
  return title;
}
