// CapitalShip.h: interface for the CapitalShip class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CAPITALSHIP_H__25762349_7EA1_4108_993C_DBFF5512928E__INCLUDED_)
#define AFX_CAPITALSHIP_H__25762349_7EA1_4108_993C_DBFF5512928E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <GL/glew.h>
#include "ship.h"
#include "Color.h"
#include "ReticleSquare.h"	// Added by ClassView
#include "coord.h"	// Added by ClassView

class Component;

class CapitalShip : public ship  
{
public:
	int getNumComponentsOnly();
	virtual Coordinate getVelocityVector();
	bool getLandOn();
	virtual bool instanceof(InstanceT it);
	virtual void advance();
	virtual float getradius();
	virtual Coordinate  getMeshCenter();
	virtual  Coordinate getExtents();
	Coordinate getComponentLocation(int index);
	ReticleSquare getComponentSquare();
	Component * getComponent(int index);
	int getNumComponents();
	virtual void render();
	virtual void damage(int amount, Coordinate fromlocation);
	void setLandOn(bool value);
   CapitalShip(mesh * newmesh, int nummounts, mount * mounts[], 
        Coordinate cockpit, shipareas newshields, shipareas newarmor,
        float newvelocity, float newroll, float newpitch, float newyaw, 
 	    float newacceleration, float newangularacceleration,
		float newafterburnervelocity, float newfterburneracceleration, float newfuel,
        int numthrusters, Thruster * thrusters[], Image * newimage, string newname, int totalenergy, int energyrecharge,
        float mass,
		std::vector<Turret *> * turrets,
		std::vector<Coordinate> newenginelocations,
        Component ** new_components, int new_num_components,
		std::vector<Coordinate> newexplosionlocations);	
   CapitalShip(CapitalShip & newship);
	virtual ~CapitalShip();
   virtual Color getRadarColor(ship * player);
   virtual bool instanceof(char classname [ ]);
	virtual void onCollisionWith(Object3d * otherobject);  
private:
	void computeFullExtents();
   bool land;// true if the player will land on this ship
   Component * * components;
   int num_components;
   ReticleSquare componentsquare;
   Coordinate fullextents; 
   Coordinate fullcenter; 
   float fullradius;
   std::vector<Coordinate> explosionlocations;
protected:
	virtual void destroy();
	virtual void calculateRectangle();
};

#endif // !defined(AFX_CAPITALSHIP_H__25762349_7EA1_4108_993C_DBFF5512928E__INCLUDED_)
