// ChaseCamera.cpp: implementation of the ChaseCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "ChaseCamera.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
ChaseCamera ChaseCamera::me;

ChaseCamera::ChaseCamera()
{

}

ChaseCamera::~ChaseCamera()
{

}

void ChaseCamera::render()
{
  Object3d * myfocus = Camera::getFocusObject();
  Coordinate position;
  Coordinate heading = myfocus->getHeading();
  Coordinate heightoffset;
  Coordinate up = myfocus->getUp();
  Coordinate lookat = myfocus->getLocation();
  float height = getHeightOffset();
  heightoffset = up * height;
   
  myfocus->setrenderingenabled(true);
  position =  lookat - (heading * getRadius() ) + heightoffset;
  lookat = lookat + heightoffset;

  gluLookAt((GLdouble) position.x, (GLdouble) position.y, (GLdouble) position.z, 
            (GLdouble) lookat.x, (GLdouble) lookat.y, (GLdouble) lookat.z,             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);
  GLERRORCHECK
}

Coordinate ChaseCamera::getHeading()
{
  return Camera::getFocusObject()->getHeading();
}

Camera * ChaseCamera::getInstance()
{
  return & me;
}

Coordinate ChaseCamera::getLocation()
{
  Object3d * myfocus = Camera::getFocusObject();
  Coordinate position;
  Coordinate heading = myfocus->getHeading();
  Coordinate lookat = myfocus->getLocation();
   
  myfocus->setrenderingenabled(true);
  position =  lookat - (heading * getRadius() );
  return position;
}

float ChaseCamera::getRadius()
{
   Object3d * myfocus = Camera::getFocusObject();
   Coordinate extents = myfocus->getExtents();

   return extents.z + 6.0f;
}

float ChaseCamera::getHeightOffset()
{
   Object3d * myfocus = Camera::getFocusObject();
   Coordinate extents = myfocus->getExtents();

   return extents.y / 2.0f + 2.0f;
}
