// Circle.cpp: implementation of the Circle class.
//
//////////////////////////////////////////////////////////////////////

#include "Circle.h"
#include <glut.h>
#include <math.h>
#include "coord.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Circle::Circle(float x, float y, float radius)
{
  float angle;
  float newx, newy;


  glNewList(mydisplaylist = glGenLists(1), GL_COMPILE);
  glBegin(GL_LINE_LOOP);
    for(angle = 0.0f; angle < 2 * 3.1415 + .05; angle+= .05)
    {
       newx = x + radius * (float) cos(angle);    
       newy = y + radius * (float) sin(angle);        
       glVertex2f(newx, newy);
    }  
  glEnd();
  glEndList();
  GLERRORCHECK
}

Circle::~Circle()
{
   glDeleteLists(mydisplaylist, 1); 
   GLERRORCHECK
}

void Circle::render()
{
 glCallList(mydisplaylist);
 GLERRORCHECK
}


// circle in the x z plane, 
Circle::Circle(float x, float y, float z, float radius)
{
  float angle;
  float newx, newz;

  const float twopi = 2 * 3.1416 + .05 ;

  glNewList(mydisplaylist = glGenLists(1), GL_COMPILE);
  glBegin(GL_LINE_LOOP);
    for(angle = -0.05f; angle < twopi + .05; angle+= .05)
    {
       newx = x + radius * (float) cos(angle);    
       newz = z + radius * (float) sin(angle);        
       glVertex3f(newx, y, newz);
    }  
  glEnd();
  glEndList();
  GLERRORCHECK
}

Circle::Circle(Coordinate center, float radius)
{
  float angle;
  float newx, newz;

  glNewList(mydisplaylist = glGenLists(1), GL_COMPILE);
  glBegin(GL_LINE_LOOP);
    for(angle = 0.0f; angle < 2 * 3.1415 + .05; angle+= .05)
    {
       newx = center.x + radius * (float) cos(angle);    
       newz = center.z + radius * (float) sin(angle);        
       glVertex3f(newx, center.y, newz);
    }  
  glEnd();
  glEndList();
  GLERRORCHECK
}
