// Cockpit.h: interface for the Cockpit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COCKPIT_H__FF648EE6_F5A1_4397_A53D_6CF58F05E8D3__INCLUDED_)
#define AFX_COCKPIT_H__FF648EE6_F5A1_4397_A53D_6CF58F05E8D3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <GL/glew.h>
#include "Color.h"
#include "Image.h"
#include "ship.h"
#include "Circle.h"
#include "WorldObjectWalker.h"
#include "Ellipse.h"
#include "Movie.h"
#include "ViewingCone.h"

class Targetable;
class Texture;
class Font;

class Cockpit : public WorldObjectWalker
{
public:
	void setShowDamage(bool damagereport);
	void toggleFPSEnabled();
	void setShowComm(bool showcomm);

	void render();
	Cockpit(ship * player);
	virtual ~Cockpit();
   // callback, don't call from the outside
   virtual void objectIs(Object3d * object)
   {
      renderShipProjection((ship *) object);
   }
private:
	void doEject();
	Color getDamageColor(float percent);
	void renderDamageReport();
	bool isTargetVisible(Targetable * targetable);
	void doLock();
	void renderRearView(float winWidth, float winHeight);
	void drawFuel(int max, int current);
	void renderComm();
	void doAutoPilot();
	void drawEnergy(int max, int current);
	void drawShipStatus(Targetable * ship, float centerx, float centery);
	void renderShipProjection(Targetable * newship);
	void drawCrossHair();
	void barHorizontalGraph(float value, float max, int numdivisions, float x1, float y1, float x2, float y2, Color basecolor, Color endcolor, bool rightoleft, bool taper=false);
	void barVerticalGraph(float value, float max, int numdivisions, float x1, float y1, float x2, float y2, Color basecolor, Color endcolor, bool updown, bool taper=false);
   float winWidth, winHeight;
//   Image * image;
   ship * player;
   Circle * circle1;
   Circle * circle2;
   Circle * circle3;
   float innerprojectionradius;
   float outerprojectionradius;
   float projectionx, projectiony;
   Image * autopilot;
   Image * eject;
   Image * lock;
   GLuint linesdisplaylist;
   bool show_comm;
   bool show_damage;
   Image * crosshair_fullguns;
   Image * crosshair_energy;
   Image * crosshair_ammo;
   Image * crosshair_charging;
   Image * oval;
   Image * greenarrow;
   Image * ittsarrow;
   Image * guns2dpic;
   Image * decoy2dpic;
   Font * font;
   Object3d * struts;
   bool fpsenables;
   bool simplecockpit;
   float sizemultiplier;
   EllipseE * ellipse;  
   EllipseE * commcircle;  
   ViewingCone viewcone;
};


#endif // !defined(AFX_COCKPIT_H__FF648EE6_F5A1_4397_A53D_6CF58F05E8D3__INCLUDED_)
