// CockpitCamera.cpp: implementation of the CockpitCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "CockpitCamera.h"
#include "ship.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CockpitCamera CockpitCamera::me;

CockpitCamera::CockpitCamera()
{

}

CockpitCamera::~CockpitCamera()
{

}

void CockpitCamera::render()
{
  Coordinate lookat;
  Object3d * myfocus = Camera::getFocusObject();


  myfocus->setrenderingenabled(false);
  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();
  Coordinate heading = myship->getHeading();
  Coordinate up = myship->getUp();

  lookat = (heading * CAMERA_VIEW_RADIUS) + cockpit;

  gluLookAt((GLdouble) cockpit.x, (GLdouble) cockpit.y, (GLdouble) cockpit.z, 
            (GLdouble) lookat.x, (GLdouble) lookat.y, (GLdouble) lookat.z,             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);
  GLERRORCHECK

}

Coordinate CockpitCamera::getHeading()
{
  return Camera::getFocusObject()->getHeading();
}

bool CockpitCamera::shouldRenderCockpit()
{
  return true;
}

Camera * CockpitCamera::getInstance()
{
  return & me;
}

Coordinate CockpitCamera::getLocation()
{
  Object3d * myfocus = Camera::getFocusObject();

  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation(); //+ myship->getLocation();
  return cockpit;
}
