// Color.cpp: implementation of the Color class.
//
//////////////////////////////////////////////////////////////////////


#include "Color.h"
#include "glut.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Color::Color(float red, float green, float blue)
{
  r = red;
  g = green;
  b = blue;
  a = 1.0f;
  alphaset = false;
}

Color::Color()
{
  r = 0.0f;
  g = 0.0f;
  b = 0.0f;
  a = 1.0f;
  alphaset = false;

}

void Color::render()
{
  if(alphaset)
  {
    glColor4f(r, g, b, a);
  }
  else
  {
    glColor3f(r, g, b);
  }

}

Color Color::interpolate(Color other, float s)
{
  return Color(r * s + other.r * (1.0f - s), 
	           g * s + other.g * (1.0f - s), 
			   b * s + other.b * (1.0f - s));
}

Color::Color(float red, float green, float blue, float alpha)
{
  r = red;
  g = green;
  b = blue;
  a = alpha;
  alphaset = true;

}

Color Color::operator *(float value)
{
  return Color(r * value, g * value, b * value, a);
}
