// Comm.h: interface for the Comm class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMM_H__BA347B6B_57A6_4627_9647_1F750C51E12D__INCLUDED_)
#define AFX_COMM_H__BA347B6B_57A6_4627_9647_1F750C51E12D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "SoundEffect.h"
#include <queue>
#include "Color.h"
#include <string>
#include "Time.h"

class Movie;
class Cockpit;

   // queued comms
   class CommState
   {
     public:
	   Movie * movie;
	   SoundEffect * sound;
	   bool friendly;
	   std::string label;
	   CommState(){}
   };


class Comm  
{
public:
	static bool isCurrentFriendly();
	Comm(Comm * that, std::string name, bool alignment);
	static void clear();
	static std::string getCurrentLabel();
	static Movie * getCurrentMovie();
	static void update();
	void insult();
/*	void gotKill();*/
	void dead();
	Comm(char name[], char videoname[],
				std::string newname, bool newalignment);
	virtual ~Comm();
private:
   Movie * deadmovie;
   SoundEffect * insultsound;
   SoundEffect * deadsound;
   /* these are for playing a delayed comm */

   static std::queue<CommState * > commqueue;
   static TimeValue pausetime;
protected:
	Movie * getMovie(char name[]);
	SoundEffect * getSound(char name[]);
    void playNow(SoundEffect * effect, Movie * mymove, 
		std::string label, bool friendly);
   Movie * mymovie; // generic comm movie
   std::string name;
   bool friendly;

};


#endif // !defined(AFX_COMM_H__BA347B6B_57A6_4627_9647_1F750C51E12D__INCLUDED_)
