// CommFactory.h: interface for the CommFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMFACTORY_H__9C1CDF63_E265_460B_B60A_5A92574B0B44__INCLUDED_)
#define AFX_COMMFACTORY_H__9C1CDF63_E265_460B_B60A_5A92574B0B44__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HashTable.h"
#include <vector>

class Comm;
class WingmanComm;
class PlayerComm;
class LandingComm;

class CommFactory  
{
public:
	void clear();
	LandingComm * getLandingComm(char sndname[], char videoname[], char label[]);
	static CommFactory * getInstance();
	CommFactory();
	virtual ~CommFactory();
	WingmanComm * getWingmanComm(char name[], char videoname[], char label[]);
    PlayerComm * getPlayerComm(char sndname [ ]);
	Comm * getComm(char sndname [ ], char videoname[], char label[], bool friendly);
private:
   static CommFactory instance;
   HashTable commtable;
   std::vector<Comm *> comms;
};

#endif // !defined(AFX_COMMFACTORY_H__9C1CDF63_E265_460B_B60A_5A92574B0B44__INCLUDED_)
