// CommHandler.cpp: implementation of the CommHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "CommHandler.h"
#include "WingmanComm.h"
#include "World.h"
#include "LandingComm.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CommHandler::CommHandler()
{
  wingmen = NULL;
}

CommHandler::~CommHandler()
{

}

void CommHandler::breakAndAttack()
{
  if(numwingmen == 0 || (! enemies_here) )
  {
	return;
  }

	int i;
	WingmanComm * wing_comm;

        comms->breakAndAttack();   
        if(enemies_here )
        {
          for(i=0; i< numwingmen; i++)
          {
             wingmen[i]->targetClosest();
			 wing_comm = (WingmanComm *) wingmen[i]->getComm();
             if(wing_comm != NULL)
               wing_comm->yes();             
  
          }
        }
        else
        {
          for(i=0; i < numwingmen; i++)
		  {
			wing_comm = (WingmanComm *) wingmen[i]->getComm();
			if(wing_comm != NULL)
				wing_comm->no();             
		  }
        }

}

void CommHandler::formOnMyWing()
{

}

void CommHandler::targetStatus()
{
   Targetable * target = player->getTarget();


   if(target != NULL && target->instanceof(INST_SHIP) )
   {
	 comms->askStatus();  
     doStatus((ship *) target);
   }
}

void CommHandler::wingStatus()
{
  int i;

  if(numwingmen == 0 )
  {
	return;
  }

  comms->askStatus();  
  for(i=0; i< numwingmen; i++)
  {
	  doStatus(wingmen[i] );
  }
}

void CommHandler::attackMyTarget()
{
  if(numwingmen == 0 || (! enemies_here))
  {
	return;
  }

	int i;
	WingmanComm * wing_comm;

        if(player->getTarget() != NULL)
        {          
          if(player->getTarget()->instanceof(INST_SHIP) )
          {
            comms->attackMyTarget();        
            ship * target = (ship *) player->getTarget();
            if(target->getIffCode() == ENEMY)
            {
              for(i=0; i< numwingmen; i++)
			  {
                 wingmen[i]->setTarget(player->getTarget() );
				 wing_comm = (WingmanComm *) wingmen[i]->getComm();
				 if(wing_comm != NULL)
				 {
					wing_comm->yes();
				 }

			  }

            }
            else
            {
	          for(i=0; i < numwingmen; i++)
			  {
				wing_comm = (WingmanComm *) wingmen[i]->getComm();
				if(wing_comm != NULL)
					wing_comm->no();             
			  }
            }
          }
        }


}

void CommHandler::help()
{

  if(numwingmen == 0 || (! enemies_here))
  {
	return;
  }

	int i;
	WingmanComm * wing_comm;

        comms->help();   
        if(enemies_here )
        {     
          for(i=0; i< numwingmen; i++)
		  {
             wingmen[i]->setTarget(World::getWorld().getNearestTargetDefender(wingmen[i], player) );
 			 wing_comm = (WingmanComm *) wingmen[i]->getComm();
 			 if(wing_comm != NULL)
			   wing_comm->yes();             

		  }
        }
        else
        {
	          for(i=0; i < numwingmen; i++)
			  {
				wing_comm = (WingmanComm *) wingmen[i]->getComm();
				if(wing_comm != NULL)
					wing_comm->no();             
			  }
        }

}

void CommHandler::requestLanding()
{
        if(mission->isComplete() )
        {
          comms->requestLanding();
          LandingComm * landingc = (LandingComm *) mission->getLandingShip()->getComm();
          landingc->landing();
        }

}

void CommHandler::taunt()
{
        Targetable * target = player->getTarget();
        if(target != NULL)
        {
           if(target->instanceof(INST_SHIP) )
           {    
              ship * enemy = (ship *) target;
              if(enemy->getIffCode() == ENEMY)
              {
                comms->insult();        
                enemy->getComm()->insult();
              }
           }
        }

}

void CommHandler::update()
{
  mission = Mission::getCurrentMission();
  player = mission->getPlayer();
  comms = (PlayerComm *) player->getComm();
  enemies_here = mission->enemiesAtCurrentNav();
  if(wingmen != NULL)
  {
	delete [] wingmen;
  }
  wingmen = Mission::getCurrentMission()->getFriendlyFighters(numwingmen);
}

/* defend my target code not used 
        if(enemies_here )
        {

          if(player->getTarget() != NULL)
          {
            if(player->getTarget()->instanceof(INST_SHIP) )
            {
              for(i=0; i< numwingmen; i++)
              {
                 wingmen[i]->setTarget(World::getWorld().getNearestTargetDefender(wingmen[i], (ship *) player->getTarget() ) );
 				 wing_comm = (WingmanComm *) wingmen[i]->getComm();
				 if(wing_comm != NULL)
					wing_comm->yes();             

              }
            }
          }
        }
        else
        {
             for(i=0; i< numwingmen; i++)
			 {
				wing_comm = (WingmanComm *) wingmen[i]->getComm();
				if(wing_comm != NULL)
					wing_comm->no();             
			 }

        }
*/

void CommHandler::doStatus(ship * target)
{

     ship * starget = (ship *) target;

	StatusComm * targetcomm = (StatusComm *) starget->getComm();
     if(target->instanceof(INST_CAPITALSHIP) )
	 {
		targetcomm->statusGood();

	 }
	 else 
	 {
		float damage = starget->getCoreDamagePercent() ;
		if(damage >= .5f)
		{
	        targetcomm->statusBad();
	        
		}
		else
		{
	        shipareas armor = target->getArmor();
	
			if(armor.lessThanPercent(.75f) )
			{
				targetcomm->statusMedium();
			}
			else
			{
				targetcomm->statusGood();
			}
		}
	 }
}
