// Component.h: interface for the Component class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPONENT_H__CF534168_10C6_4A40_8F0D_671A21AC26EA__INCLUDED_)
#define AFX_COMPONENT_H__CF534168_10C6_4A40_8F0D_671A21AC26EA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
#include "coord.h"	// Added by ClassView
#include "Object3d.h"
class mesh;
class CollisionModel3D;

class Component  : public Object3d
{
public:
	void renderDestroyed();
	virtual bool instanceof(InstanceT it);
	void setWorldLocation(Coordinate newlocation);
	bool hasDamagedMesh();
	virtual bool instanceof(char classname[]);
	virtual void advance();
	bool justDestroyed();
	virtual Coordinate getMeshMins();
	virtual Coordinate getMeshMaxs();
	float getDamagedPercent();
	virtual void damage(int amount, Coordinate fromlocation);
	virtual Coordinate getExtents();
	virtual Coordinate getMeshCenter();
	virtual CollisionModel3D * getCollisionModel();
	 Component(Component & copy);
	Component(std::string name, mesh * undamaged, mesh * damaged, int hitpoints);
	virtual ~Component();
	std::string getName();
	virtual bool isDestroyed();
	virtual void render();
    virtual void pushLocalTransform();
//    Coordinate debuglocation;
	void getMatrix(float newmatrix [ 16 ]);
	virtual void setMatrix(float newmatrix [ 16 ]);

protected:
	Coordinate getWorldLocation();
	float matrix[16];
private:
   std::string name;
   mesh * undamaged;
   mesh * damaged;
   int max_hitpoints;
   int current_hitpoints;
   bool justdestroyed;
   Coordinate worldlocation;
};

#endif // !defined(AFX_COMPONENT_H__CF534168_10C6_4A40_8F0D_671A21AC26EA__INCLUDED_)
