// ConstantXmlAdapter.cpp: implementation of the ConstantXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////


#include "ConstantXmlAdapter.h"
#include "saxexpat.h"
#include "InputSource.h"
#include "AttributeList.h"
#include "ErrorHandlerE.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ConstantXmlAdapter::ConstantXmlAdapter(char xmlfilename[] )
{
	expat myParser;

   ErrorHandlerE::checkFile(xmlfilename);
   myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse(*(new SAX::InputSource(xmlfilename)));

}

ConstantXmlAdapter::~ConstantXmlAdapter()
{

}

void ConstantXmlAdapter::startDocument()
{

}

void ConstantXmlAdapter::endDocument()
{

}

void ConstantXmlAdapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
  int i;

  if(name == "constants")
  {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "time_factor" )
         {
            time_factor = atof(currentvalue.c_str() );
         }
         else if(currentname == "distance_factor")
         {
            distance_factor = atof(currentvalue.c_str() );
         }
         else if(currentname == "angle_factor")
         {
            angle_factor = atof(currentvalue.c_str() );
         }
         else if(currentname == "good_eject")
         {
            good_eject = currentvalue.c_str() ;
         }
         else if(currentname == "bad_eject")
         {
            bad_eject = currentvalue.c_str() ;
         }


      }
  }

}


void ConstantXmlAdapter::endElement(const std::string& name)
{
}

void ConstantXmlAdapter::characters(const std::string& ch)
{

}


float ConstantXmlAdapter::getTimeFactor()
{
  return time_factor;
}

float ConstantXmlAdapter::getAngleFactor()
{
  return angle_factor;
}

float ConstantXmlAdapter::getDistanceFactor()
{
  return distance_factor;
}

string ConstantXmlAdapter::getGoodEject()
{
  return good_eject;
}

string ConstantXmlAdapter::getBadEject()
{
  return bad_eject;
}
