// ConstantXmlAdapter.h: interface for the ConstantXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONSTXMLADAPTER_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_)
#define AFX_CONSTXMLADAPTER_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>

using namespace SAX;
using std::string;


class ConstantXmlAdapter : public HandlerBase  
{
public:
	string getBadEject();
	string getGoodEject();
	float getDistanceFactor();
	float getAngleFactor();
	float getTimeFactor();
	ConstantXmlAdapter(char filename[]);
	virtual ~ConstantXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   float time_factor, distance_factor, angle_factor;
   std::string good_eject, bad_eject;
};

#endif // !defined(AFX_ConstantXmlAdapter_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_)
