// CubeMapTexture.cpp: implementation of the CubeMapTexture class.
//
//////////////////////////////////////////////////////////////////////

#include "CubeMapTexture.h"
#include "Settings.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CubeMapTexture::CubeMapTexture(GLubyte * bits, int newwidth, int newheight, int target)
: TextureImpl(newwidth, newheight)
{
    checkPowerOfTwo(newwidth);
	checkPowerOfTwo(newheight);

/*    glGenTextures(1, &mydisplaylist);
    glBindTexture(GL_TEXTURE_2D, mydisplaylist);
*/

    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);	/* Force 4-byte alignment */
    glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);
    glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);
    glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);

	GLenum format = selectInternalFormat(GL_RGB, 
	  GL_COMPRESSED_RGB_ARB, GL_COMPRESSED_RGB_S3TC_DXT1_EXT);

    if(Settings::getSettings()->getMipMap() )
    {
       if(GLEW_SGIS_generate_mipmap)
	   {
          glTexParameteri( GL_TEXTURE_CUBE_MAP_EXT, GL_GENERATE_MIPMAP_SGIS, GL_TRUE );
		  GLERRORCHECK
          glTexImage2D(target, 0, 3, getWidth(), getHeight(), 0,
                 format, GL_UNSIGNED_BYTE, bits);
          GLERRORCHECK
	   }
	   else
	   {
         gluBuild2DMipmaps(target, 3, getWidth(), getHeight(), format, GL_UNSIGNED_BYTE, bits); 
	   }
    }
    else
    {
       glTexImage2D(target, 0, 3, getWidth(), getHeight(), 0,
                 format, GL_UNSIGNED_BYTE, bits);
	   GLERRORCHECK

    }
    free(bits);
	GLERRORCHECK
	mydisplaylist = -1;

}

CubeMapTexture::~CubeMapTexture()
{

}
