// DebriefingPanel.cpp: implementation of the DebriefingPanel class.
//
//////////////////////////////////////////////////////////////////////

#include "DebriefingPanel.h"
#include <stdio.h>
#include "GameEngine.h" // for mission status

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DebriefingPanel::DebriefingPanel()
{
  setTitle("Debriefing");
  setConfirmText("OK");
  setNumLines(4);
}

DebriefingPanel::~DebriefingPanel()
{

}

void DebriefingPanel::setDebriefingInfo(int mission_status, DebriefingInfo * newinfo)
{
  char buffer[80];

  if(mission_status == MISSION_WON)
  {
    setTitle("Debriefing: Mission Successful");
  }
  else 
  {
    setTitle("Debriefing: Mission Failed");
  }

  if(newinfo->getNumShotsFired() == 0)
  {
    setLine("No bullets fired", 0);
  }
  else
  {
    sprintf(buffer, "Bullets :   Fired %5d   Hit Rate  %.1f %%", 
      newinfo->getNumShotsFired(), 100.0f * newinfo->getShotsHit() );
    setLine(buffer, 0);
  }
  if(newinfo->getNumMissilesFired() == 0)
  {
    setLine("No missiles fired", 1);
  }
  else
  {  
    sprintf(buffer, "Missiles:   Fired %5d   Hit Rate  %.1f %%", 
      newinfo->getNumMissilesFired(), 100.0f * newinfo->getMissileHits() );
    setLine(buffer, 1);
  }
  sprintf(buffer, "Kills : %d", newinfo->getPlayerKills() );
  setLine(buffer, 2);
  sprintf(buffer, "Friendly craft lost: %d", newinfo->getFriendlyCraftLost() );
  setLine(buffer, 3);
}
