// DiffuseLight.h: interface for the DiffuseLight class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIFFUSELIGHT_H__C534611D_80F1_493D_A0C4_EE98DF41D2AA__INCLUDED_)
#define AFX_DIFFUSELIGHT_H__C534611D_80F1_493D_A0C4_EE98DF41D2AA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Light.h"
#include "coord.h"
#include "Color.h"	// Added by ClassView

class DiffuseLight : public Light  
{
public:
	Color getDiffuse();
	int getPriority() const;
	void setPriority(int newpriority);
	virtual bool instanceof(char name[]);
	Coordinate getLocation() const;
	void disable();
	void enable();
	void setLightNumber(int index);
	void setLocation(Coordinate newlocation);
	void setAttenuation(float constant, float linear, float quadratic);
	void setDiffuse(Color newcolor);
	void setAmbient(Color newcolor);
	 DiffuseLight();
	virtual void render();
	DiffuseLight(int newnumber, Color newcolor, Coordinate newlocation);
	virtual ~DiffuseLight();
private:
   Coordinate location;
   Color diffusecolor;
   Color ambientcolor;
   int number;
   bool attenuation;
   float constant_attenuation;
   float linear_attenuation;
   float quadratic_attenuation;
   int priority;
};

#endif // !defined(AFX_DIFFUSELIGHT_H__C534611D_80F1_493D_A0C4_EE98DF41D2AA__INCLUDED_)
