// DirectionalForceEffect.cpp: implementation of the DirectionalForceEffect class.
//
//////////////////////////////////////////////////////////////////////

#include "DirectionalForceEffect.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DirectionalForceEffect::DirectionalForceEffect(IDirectInputEffect * newieffect)
: ForceEffect(newieffect)
{
  envelope.dwSize = sizeof(envelope);
  eff.lpEnvelope = &envelope;
  eff.rglDirection = &direction[0];
  envelope.dwAttackLevel = 0;
  envelope.dwAttackTime = 0;
  envelope.dwFadeLevel = 0;
  envelope.dwFadeTime = 0;
  direction[0] = 0;
  direction[1] = 0;

}

DirectionalForceEffect::~DirectionalForceEffect()
{

}

void DirectionalForceEffect::setEnvelope(int attacklevel, int attacktime, int decaylevel, int decaytime)
{
  envelope.dwAttackLevel = attacklevel;
  envelope.dwAttackTime = attacktime;
  envelope.dwFadeLevel = decaylevel;
  envelope.dwFadeTime = decaytime;
}


void DirectionalForceEffect::setDirection(int hundredths_of_degrees)
{
  direction[0] = hundredths_of_degrees;
}
