// EjectionPod.cpp: implementation of the EjectionPod class.
//
//////////////////////////////////////////////////////////////////////

#include "EjectionPod.h"
#include "ImageFactory.h"
#include "Constants.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

mesh * EjectionPod::ejectmesh = NULL;

EjectionPod::EjectionPod(std::string newname, Coordinate location, Coordinate heading, 
						 Coordinate up, Coordinate left)
  : Targetable(getEjectMesh(), location, heading, up, left, 
			   shipareas(0, 0, 0, 0), shipareas(0,0, 0,0), 
               50.0f * Constants::getDistanceFactor(), 0.0f, 0.0f, 0.0f, 
			   0.0f, 0.0f, 
			   ImageFactory::getImage("ejectpod2d.png"), newname)
{

}

EjectionPod::~EjectionPod()
{

}

mesh * EjectionPod::getEjectMesh()
{
  if(ejectmesh == NULL)
  {
     ejectmesh = new mesh("ejectpod.mesh.bin");
  }
  return ejectmesh;
}

Color EjectionPod::getRadarColor(ship * player)
{
  return Color(.65f, 0.0f, 0.65f);
}

bool EjectionPod::instanceof(InstanceT it)
{
  return it & (INST_OBJECT | INST_TARGETABLE | INST_EJECTEDPOD);
}

void EjectionPod::clear()
{
  ejectmesh = NULL;
}
