// Ellipse.cpp: implementation of the Ellipse class.
//
//////////////////////////////////////////////////////////////////////

#include <math.h>
#include "Ellipse.h"
#include "glerr.h"
#include "Math.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EllipseE::EllipseE(float xr, float yr, float x, float y)
{
  float angle;
  float newx, newy;

  glNewList(mydisplaylist = glGenLists(1), GL_COMPILE);
  glBegin(GL_LINE_LOOP);
    for(angle = 0.0f; angle < 2 * 3.1415; angle+= .025)
    {
       newx = xr * (float) cos(angle);    
       newy = yr * fastsqrt( 1 - (newx * newx) / (xr * xr) );        
       glVertex2f(x + newx, y + newy);
    }  
    for(angle = 2 * 3.1415; angle >= 0.0f ; angle-= .025)
    {
       newx = xr * (float) cos(angle);    
       newy = -yr * fastsqrt( 1 - (newx * newx) / (xr * xr) );        
       glVertex2f(x + newx, y + newy);
    }  

  glEnd();
  glEndList();
  GLERRORCHECK

}

EllipseE::~EllipseE()
{
   glDeleteLists(mydisplaylist, 1); 
   GLERRORCHECK
}

void EllipseE::render()
{
  glCallList(mydisplaylist);
  GLERRORCHECK
}
