// ErrorHandlerE.cpp: implementation of the ErrorHandlerE class.
//
//////////////////////////////////////////////////////////////////////

#include "ErrorHandlerE.h"
#include "SAXParseException.h"
#include <iostream.h>
#include <fstream.h>
#include "FileNotFoundException.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ErrorHandlerE ErrorHandlerE::instance;

ErrorHandlerE::ErrorHandlerE()
{

}

ErrorHandlerE::~ErrorHandlerE()
{

}


void ErrorHandlerE::warning(SAXParseException& exception)
{
  cout << exception.what() << endl;
  cout.flush();

}


void ErrorHandlerE::error(SAXParseException& exception)
{
  cout << (char *) exception.what() << endl;
  cout.flush();
  exit(0);
}


void ErrorHandlerE::fatalError(SAXParseException& exception)
{
  cout << exception.what() << endl;
  cout.flush();
  exit(0);
}

ErrorHandlerE & ErrorHandlerE::getInstance()
{
  return instance;
}

void ErrorHandlerE::checkFile(char filename [ ])
{
  ifstream file;

  file.open(filename, ios::in);
  if(! file)
  {
      file.close();
      throw FileNotFoundException(filename);
  }
  file.close();
}

bool ErrorHandlerE::fileExists(char filename [ ])
{
  ifstream file;
  bool exists = true;

  file.open(filename, ios::in);
  if(! file)
  {
      file.close();
	  exists = false;
  }
  file.close();
  return exists;
}
