// Explosion.h: interface for the Explosion class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPLOSION_H__7FEC0EB2_BD1C_4DC8_AA26_FD8713E42836__INCLUDED_)
#define AFX_EXPLOSION_H__7FEC0EB2_BD1C_4DC8_AA26_FD8713E42836__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "coord.h"
#include "Time.h"
#include "Object3d.h"
#include "DiffuseLight.h"

class Texture;

class Explosion  : public Object3d
{
public:
	virtual bool instanceof(InstanceT it);
	static void clear();
	 Explosion(Coordinate newcenter, float newmaxdistance);
	virtual bool instanceof(char classname[]);
	virtual void advance();
	virtual void render();
	Explosion(Coordinate  center);
	virtual ~Explosion();
private:
	void addParticles(int numparticles);
   float v0;
   float acceleration;
   Coordinate center;
   TimeValue starttime;
   TimeValue endbirths;
   Coordinate headings[860];
   bool * isdead;
   float v0s[860];
   Coordinate p0s[860];
   int totalparticles;
   int numparticles;
   float maxdistance;
   int endtime;
   static Texture * texture;
   float sizemultiplier;
   DiffuseLight light;
   Color lastcolor;
};

#endif // !defined(AFX_EXPLOSION_H__7FEC0EB2_BD1C_4DC8_AA26_FD8713E42836__INCLUDED_)
