// FixedCamera.cpp: implementation of the FixedCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "FixedCamera.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
FixedCamera FixedCamera::me;
FixedCamera::FixedCamera()
{

}

FixedCamera::~FixedCamera()
{

}

void FixedCamera::setLocation(Coordinate newlocation)
{
  location = newlocation;
}

void FixedCamera::setUp(Coordinate newup)
{
  up = newup;
}

void FixedCamera::setLookAt(Coordinate newlookat)
{
  lookat = newlookat;
}

void FixedCamera::render()
{
  gluLookAt((GLdouble) location.x, (GLdouble) location.y, (GLdouble) location.z, 
            (GLdouble) lookat.x, (GLdouble) lookat.y, (GLdouble) lookat.z,             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);
  GLERRORCHECK
}

Coordinate FixedCamera::getHeading()
{
  Coordinate diff;

  diff = lookat - location;
  diff.normalize() ;
  return diff;
}

bool FixedCamera::showMovingStars()
{
  return false;
}

Camera * FixedCamera::getInstance()
{
  return & me;
}

Coordinate FixedCamera::getUp()
{
  return up;
}

Coordinate FixedCamera::getLocation()
{
  return location;
}
