// FontFactory.cpp: implementation of the FontFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "FontFactory.h"
#include "GlutFont.h"
#include "TextureFont.h"
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

FontFactory * FontFactory::instance = NULL;

FontFactory::FontFactory()
#ifdef TEXTURE_FONTS
: font(new TextureFont("fontsans10.png", "fontsans10.dat" )),
  bigfont(new TextureFont("fontsans15.png", "fontsans15.dat" ))
#else
: font(new GlutFont() ),
  bigfont(new GlutFont() )
#endif
{
//  Font * tempfont = new TextureFont("fontsans15.png", "fontsans15.dat");
//	font = new GlutFont();
//	bigfont = new GlutFont();

}

FontFactory::~FontFactory()
{
	// this is a bug, we should be able to delete here.
//  delete font;
//  delete bigfont;
}

FontFactory & FontFactory::getInstance()
{
	if(instance == NULL)
	{
	  instance = new FontFactory();
	}
	return *instance;
}

Font * FontFactory::getFont()
{
//  return new GlutFont();
  return font;
}

void FontFactory::clear()
{
  if(instance != NULL)
  {
    delete instance;
  }
  instance = NULL;
}

Font * FontFactory::getLargeFont()
{
  return bigfont;
}

