// ForceEffectFactory.cpp: implementation of the ForceEffectFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "ForceEffectFactory.h"
#include <stdlib.h>
#include "JoystickFactory.h"
#include "ForceXmlAdapter.h"
#include "ForceEffect.h"
#include "ForceEffectSet.h"
#include <string>
using std::string;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ForceEffectFactory * ForceEffectFactory::instance = NULL;

ForceEffectFactory::ForceEffectFactory()
{
	joy = JoystickFactory::getInstance()->getForceFeedbackJoystick();
#ifdef WIN32 
	ForceXmlAdapter adapter(string("explode.force.xml"), joy);
	explode = adapter.getForce();

	ForceXmlAdapter adapter2(string("missile.force.xml"), joy);
	missile = adapter2.getForce();

	ForceXmlAdapter adapter3(string("collision.force.xml"), joy);
	collision = adapter3.getForce();

	ForceXmlAdapter adapter4(string("armorhit.force.xml"), joy);
	armor = adapter4.getForce();

	ForceXmlAdapter adapter5(string("shieldhit.force.xml"), joy);
	shield = adapter5.getForce();
#else
	explode = NULL;

	missile = NULL;

	collision = NULL;

	armor = NULL;

	shield = NULL;
#endif

}

ForceEffectFactory::~ForceEffectFactory()
{
#ifdef WIN32
  delete explode;
  delete missile;
  delete collision;
  delete shield;
  delete armor;
#endif
}

ForceEffectSet * ForceEffectFactory::getForceSet(char filename [ ])
{
  return NULL;
}

ForceEffectSet * ForceEffectFactory::getArmorForce()
{
return armor;
}

ForceEffectSet * ForceEffectFactory::getShieldForce()
{
return shield;
}

ForceEffectSet * ForceEffectFactory::getExplodeForce()
{
return explode;
}

ForceEffectSet * ForceEffectFactory::getMissileLaunchForce()
{
return missile;
}

ForceEffectSet * ForceEffectFactory::getCollisionForce()
{
  return collision;
}

ForceEffectFactory * ForceEffectFactory::getInstance()
{
  if(instance == NULL)
  {
   instance = new ForceEffectFactory();
  }
  return instance;
}

void ForceEffectFactory::clear()
{
  delete instance;
  instance = NULL;
}
