// ForceEffectFactory.h: interface for the ForceEffectFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FORCEEFFECTFACTORY_H__64E8DBA3_2E6E_4966_BA54_C61E9E0E634B__INCLUDED_)
#define AFX_FORCEEFFECTFACTORY_H__64E8DBA3_2E6E_4966_BA54_C61E9E0E634B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class ForceFeedbackJoystick;
class ForceEffectSet;

class ForceEffectFactory  
{
public:
	static void clear();
	static ForceEffectFactory * getInstance();
	ForceEffectSet * getCollisionForce();
	ForceEffectSet * getMissileLaunchForce();
	ForceEffectSet * getExplodeForce();
	ForceEffectSet * getShieldForce();
	ForceEffectSet * getArmorForce();
	ForceEffectSet * getForceSet(char filename[]);

	virtual ~ForceEffectFactory();
private:
	static ForceEffectFactory * instance;
	ForceEffectFactory();
    ForceFeedbackJoystick * joy;
	ForceEffectSet * explode;
	ForceEffectSet * missile;
	ForceEffectSet * collision;
	ForceEffectSet * shield;
	ForceEffectSet * armor;
};

#endif // !defined(AFX_FORCEEFFECTFACTORY_H__64E8DBA3_2E6E_4966_BA54_C61E9E0E634B__INCLUDED_)
