// ForceEffectSet.cpp: implementation of the ForceEffectSet class.
//
//////////////////////////////////////////////////////////////////////

#include "ForceEffectSet.h"
#ifdef WIN32
#include "DirectionalForceEffect.h"
#endif
#include <stdlib.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ForceEffectSet::ForceEffectSet()
{

}

ForceEffectSet::~ForceEffectSet()
{
#ifdef WIN32
  delete effect;
#endif
}

void ForceEffectSet::addForceEffect(ForceEffect * neweffect)
{
#ifdef WIN32
  effect = (DirectionalForceEffect *) neweffect;
#else
  effect = neweffect;
#endif
}

void ForceEffectSet::play()
{
#ifdef WIN32
  effect->play();
#endif
}

void ForceEffectSet::advance()
{

}

ForceEffect * ForceEffectSet::getForce(int index)
{
  return effect;
}

int ForceEffectSet::getNumForces()
{
  return 1;
}


void ForceEffectSet::stop()
{
#ifdef WIN32
  effect->stop();
#endif
}

void ForceEffectSet::setDirection(int direction)
{
#ifdef WIN32
  effect->setDirection(direction);
#endif
}
