// ForceXmlAdapter.h: interface for the ForceXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FORCEXMLADAPTER_H__7A5C68CD_5D1F_41C5_98C7_D283CC5AD3D6__INCLUDED_)
#define AFX_FORCEXMLADAPTER_H__7A5C68CD_5D1F_41C5_98C7_D283CC5AD3D6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>

using std::string;
using namespace SAX;

class ForceFeedbackJoystick;
class ForceEffectSet;
class ForceEffect;
class DirectionalForceEffect;

class ForceXmlAdapter : public HandlerBase 
{
public:
	ForceEffectSet * getForce();
	ForceXmlAdapter(std::string filename, ForceFeedbackJoystick * joystick);
	virtual ~ForceXmlAdapter();
	virtual void startDocument();
	virtual void endDocument();

	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
	void setDirectional(DirectionalForceEffect * directional);
	void setBasics(ForceEffect * fe);
	ForceFeedbackJoystick * joystick;
	int start_delay, duration, direction;
	int attack_level, attack_time, decay_level, decay_time;
	int constant_value, ramp_start, ramp_end;
	string periodic_type;
	int phase, period, offset, amplitude;
	ForceEffectSet * forceset;
};

#endif // !defined(AFX_FORCEXMLADAPTER_H__7A5C68CD_5D1F_41C5_98C7_D283CC5AD3D6__INCLUDED_)
