// GameEngine.h: interface for the GameEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEENGINE_H__6BC74723_093F_4A6A_93A6_A58CEE1B380C__INCLUDED_)
#define AFX_GAMEENGINE_H__6BC74723_093F_4A6A_93A6_A58CEE1B380C__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EventListener.h"
#include "CommHandler.h"
#include <GL/glew.h>
#include "glut.h"

class Billboard;
class Mission;
class StarField;
class Cockpit;
class GameFlow;
class Music;
class Joystick;
class Sector;
class ForceFeedbackJoystick;
class JoystickRange;
class ship;
class LensFlare;

#define MISSION_LOST 0
#define MISSION_WON  1
#define MISSION_RESTART 2

class GameEngine : public EventListener  
{
public:
	void setGameFlow(GameFlow * newgameflow);
	void setMission(char missionname[]);
	GameEngine();
	virtual ~GameEngine();
	virtual void onDisplay();
	virtual void onReshape(int w, int h);
	virtual void onKeyboardUp(unsigned char key, int x, int y);
	virtual void onKeyboard(unsigned char key, int x, int y);
	virtual void onSpecialUpKeyboard(int key, int x, int y);
	virtual void onSpecialKeyboard(int key, int x, int y);
	virtual void onIdle();
private:
	void fullGuns(ship * player);
	void createCubeMaps2();
	void createCubeMaps(int index);
	void nextTarget(ship * player);
	void nextMissile(ship * player);
	void nextGun(ship * player);
	void doTakeoffCutscene();
	void deleteJoystickVariables();
	void initJoystickVariables();
	void doCommSelection(char key);
	void clearInputState();
	void onLaunchDone();
	void exitEngine(int exittype);
   StarField * stars;
   Cockpit * cockpit;
   void * data;
   int width, height;
   bool upkeypressed, downkeypressed,leftkeypressed,rightkeypressed,firekeypressed, bankrightkeypressed, bankleftkeypressed;
//   Billboard * billboard;
   Sector * sector;
   Mission * mission;
   GameFlow * gameflow;
   Music * music;   
   bool show_comms;
   bool show_damage;
   Joystick * joystick;
   ForceFeedbackJoystick * forcejoystick;
   // joystick data;
   JoystickRange * xrange;
   JoystickRange * yrange;
   JoystickRange * rzrange;
   JoystickRange * throttlerange;
   bool missilecamenabled;
   bool isdoingbriefing;
   bool button2down;
   bool button3down;
   bool button4down;
   bool button5down;
   LensFlare * lensflare;
   bool cubemapcreated;
   CommHandler commhandler;
};

#endif // !defined(AFX_GAMEENGINE_H__6BC74723_093F_4A6A_93A6_A58CEE1B380C__INCLUDED_)
