// GameFlow.h: interface for the GameFlow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEFLOW_H__5080CFC3_C240_4E95_AC8F_B57606AAC87A__INCLUDED_)
#define AFX_GAMEFLOW_H__5080CFC3_C240_4E95_AC8F_B57606AAC87A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include <GL/glew.h>
#include "EventListener.h"
#include "Rect.h"
#include <string>
#include "DebriefingInfo.h"

using std::string;

class GameEngine;
class Music;
class Image;
class Campaign;
class SettingsPanel;
class CampaignPanel;
class LoadPanel;
class SavePanel;
class BriefingPanel;
class AbstractPanel;
class Panel;
class DebriefingPanel;
class Font;
class TextPanel;

class GameFlow : public EventListener  
{
public:
	virtual void onMouseMove(int x, int y);
   // could be won, lost or restart, constants defined in GameEngine.h
	void onEngineExit(int mission_status, DebriefingInfo debrifinginfo);
	void exit();
	virtual void onMouseDown(int button, int state, int x, int y);
	virtual void onReshape(int w, int h);
	virtual void onDisplay();
 	virtual void onKeyboard(unsigned char key, int x, int y);
	GameFlow();
	virtual ~GameFlow();
private:
	void clearMouseUnderState();
	void startMission();
	void createCursor();
	void loadGame(string mission, string campaign);
	void setCampaign(string name);
	void renderSelf();
   Image * shell;
   Rect exitrect;
   Rect missionrect;
   Rect settingsrect;
   Rect campaignrect;
   Rect loadrect;
   Rect saverect;
   Rect emailrect;
   GameEngine * engine;
   string background;
   int mouseoverstate;
   int exitx, exity, flyx, flyy, settingsx, settingsy, campaignx, campaigny;
   int loadx, loady, savex, savey;
   Music * music;
   Music * debriefingmusic;
   int x, y;
   AbstractPanel * currentpanel;
   bool panelactive;
   SettingsPanel * settingspanel;
   CampaignPanel * campaignpanel;
   LoadPanel * loadpanel;
   SavePanel * savepanel;
   BriefingPanel * briefingpanel;
   DebriefingPanel * debriefingpanel;
   TextPanel * emailpanel;
   Campaign * currentcampaign;
   string currentmission;
   Image * cursor;
   bool displayed;
   unsigned char * under_mouse_bits;
   unsigned char * text_background_bits;
   float prevx, prevy;
   int prev_mousover_state;
   int cursor_offset_x, cursor_offset_y;
   Font * font;
   bool startedmusic;

};

#endif // !defined(AFX_GAMEFLOW_H__5080CFC3_C240_4E95_AC8F_B57606AAC87A__INCLUDED_)
