// GameFlowXmlAdapter.h: interface for the GameFlowXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEFLOWXMLADAPTER_H__B0742C15_82A2_4A48_A23C_099D7261C74B__INCLUDED_)
#define AFX_GAMEFLOWXMLADAPTER_H__B0742C15_82A2_4A48_A23C_099D7261C74B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>
#include "Rect.h"

using std::string;
using namespace SAX;

class GameFlowXmlAdapter : public HandlerBase
{
public:
	Rect getEmailArea();
	Rect getSaveArea();
	Rect getLoadArea();
	Rect getCampaignArea();
	Rect getSettingsArea();
	Rect getStartMissionArea();
	Rect getExitArea();
	string getBackgroundImageName();
	GameFlowXmlAdapter(char filename[]);
	virtual ~GameFlowXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   string backgroundimagename; 
   Rect exitarea;
   Rect startmissionarea;
   Rect currentrectangle;
   Rect settingsrectangle;
   Rect campaignrectangle;
   Rect loadrectangle;
   Rect saverectangle;
   Rect emailrectangle;
};

#endif // !defined(AFX_GAMEFLOWXMLADAPTER_H__B0742C15_82A2_4A48_A23C_099D7261C74B__INCLUDED_)
