// GlutFont.cpp: implementation of the GlutFont class.
//
//////////////////////////////////////////////////////////////////////
#include <GL/glew.h>
#include "glut.h"
#include "GlutFont.h"
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "glerr.h"
#include "Settings.h"

#define MAX_STRING 200
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GlutFont::GlutFont()
{
  fontid = GLUT_BITMAP_HELVETICA_10;
}

GlutFont::~GlutFont()
{

}

void GlutFont::printf(float x, float y, char format[], ...)
{
  va_list	ap;			/* Argument pointer */
  char		s[MAX_STRING + 1];	/* Output string */


  if (format == NULL)
    return;

  va_start(ap, format);
  vsprintf(s, format, ap);
  va_end(ap);
  print(x, y, s);

}

void GlutFont::print(float x, float y, char text[])
{
	int len, i;

	glRasterPos2f(x, y);
	len = strlen (text);
	for (i=0; i<len; i++)
	{
      if(text[i] == ' ')
      {
         int width = glutBitmapWidth(fontid, 'c');
         float raster[4];

         // get the current raster position

         glGetFloatv(GL_CURRENT_RASTER_POSITION, raster);
         glRasterPos2f(raster[0], y);
      }
      glutBitmapCharacter (fontid, text[i]);
	}
    GLERRORCHECK
}

int GlutFont::getWidth(char text[])
{
  int width;

  int len, i;
  width = 0;
  len = strlen (text);
  for (i=0; i<len; i++)
  {
    if(text[i] == ' ')
    {
       width += glutBitmapWidth(fontid, 'c');
    }
    else
	{
       width += glutBitmapWidth(fontid, text[i]);
	}
  }
  return width;
}

int GlutFont::getHeight(char text[])
{
  return glutBitmapLength(fontid, (const unsigned char *) text);
}
