// GunDescription.cpp: implementation of the GunDescription class.
//
//////////////////////////////////////////////////////////////////////

#include "GunDescription.h"
#include "AxisAlignedBillboard.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GunDescription::GunDescription(float newrange, int newdamage, std::string newmesh,
   float newvelocity, float newroll, float newpitch, float newyaw, string newname, 
   int newenergy, int newdelay, int newsoundindex, 
      std::string newbillboard, float bbwidth, float bbheight, 
	  std::string icon,
	  bool newdamagecapships, bool newdamageturrets, Color newlightcolor,
	  int newchargetime)
   : weapondescription(newrange, newdamage, newmesh, newvelocity, 
       newroll, newpitch, newyaw,  newname, newdelay,0.0f /* no accel */, icon, true,
	   newdamagecapships, newdamageturrets, newsoundindex),
     energy(newenergy),
	 billboard(NULL),
	 billboardname(newbillboard), billboardwidth(bbwidth), billboardheight(bbheight),
	 lightcolor(newlightcolor),
	 chargetime(newchargetime)
{
	loaded = false;

}

GunDescription::~GunDescription()
{

}


int GunDescription::getEnergy()
{
   return energy;
}

AbstractBillboard * GunDescription::getBillboard()
{
  return billboard;
}

void GunDescription::load()
{
  if(loaded)
  {
    return;
  }
  weapondescription::load();
  if(billboardname != "")
  {
     billboard = new AxisAlignedBillboard((char *) billboardname.c_str(), billboardwidth, billboardheight);
  }   

  loaded = true;
}

Color GunDescription::getLightColor()
{
  return lightcolor;
}

int GunDescription::getChargeTime()
{
  return chargetime;
}

bool GunDescription::isChargeable()
{
  return chargetime != 0;
}
