// HashTable.cpp: implementation of the HashTable class.
//
//////////////////////////////////////////////////////////////////////


#include "HashTable.h"
//#include "InternalException.h"
#ifndef WIN32
#define WIN32 
#endif
// force to use windows impl always
#ifdef WIN32
#include <string.h>
#else
#include <search.h>
#endif

class InternalException{};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

HashTable::HashTable(int size)
{
#ifdef WIN32
  numentries = 0;
#else
   hcreate(10000);
#endif
}

HashTable::~HashTable()
{
#ifdef WIN32

#else
  hdestroy();
#endif

}

bool HashTable::hasKey(char key [ ])
{
#ifdef WIN32
  if(find(key) == -1)
    return false;
  return true;
#else
  ENTRY item;
  item.key = key;

  ENTRY *found;
  found = hsearch(item, FIND);
  if(found == NULL)
    return false;
  return true;
#endif
}

void HashTable::setItem(char key [ ], void * data)
{
#ifdef WIN32
  int index;

  if(! hasKey(key) )
//    throw InternalException("Have to add to hash table before setting");
    throw InternalException();
  index = find(key);
  entries[index].data = data;
#else
  ENTRY item;
  item.key = key;
  item.data = (char *)data; 
  hsearch(item, ENTER);
#endif 
}

void * HashTable::getItem(char key [ ])
{

#ifdef WIN32
  int index;

  index = find(key);
  if(index == -1)
//    throw InternalException("Could not find item in HashTable::getItem");
    throw InternalException();
  return entries[index].data;
#else
  ENTRY item;
  item.key = key;

  ENTRY *found;
  found = hsearch(item, FIND);
  if(found == NULL)
     return NULL;
  return (void *)(found->data);

#endif
}

void HashTable::addItem(char key [ ], void * data)
{

#ifdef WIN32
  entries[numentries].key = key;
  entries[numentries].data = data;
  numentries++;
#else
  setItem(key, data);
#endif
}

#ifdef WIN32
int HashTable::find(char key [ ])
{
  int i;

  for(i=0; i < numentries; i++)
  {
     if(0 == strcmp(key, entries[i].key.c_str() ) )
       return i;
  }
  return -1;
}

#endif

void HashTable::clear()
{
  numentries = 0;
}
