// Joystick.h: interface for the Joystick class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JOYSTICK_H__B9D72E68_5C8C_4A6A_95AA_225C48CDBC17__INCLUDED_)
#define AFX_JOYSTICK_H__B9D72E68_5C8C_4A6A_95AA_225C48CDBC17__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>

class JoystickRange;

class Joystick  
{
public:
   	virtual void printInfo()=0;
	virtual std::string getName()=0;
	virtual int getNumButtons()=0;
	virtual int getNumAxes()=0;
	virtual bool isButtonPressed(int button_index)=0;
	virtual JoystickRange * getXAxisRange()=0;
	virtual JoystickRange * getYAxisRange()=0;
	virtual JoystickRange * getRZAxisRange()=0;
	virtual JoystickRange * getThrottleRange()=0;
	virtual bool hasRZAxis()=0;
    virtual bool hasThrottle()=0;
	virtual int getXValue()=0;
	virtual int getYValue()=0;
	virtual int getRZValue()=0;
	virtual int getThrottleValue()=0;
	virtual void update()=0;
	virtual int getNumHats()=0;
	virtual int getHatDirection(int hat_index)=0;



};

#endif // !defined(AFX_JOYSTICK_H__B9D72E68_5C8C_4A6A_95AA_225C48CDBC17__INCLUDED_)
