// JoystickDirectX.h: interface for the JoystickDirectX class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JOYSTICKDIRECTX_H__0EB96245_FF20_470C_9BDE_9AD865DBBF4E__INCLUDED_)
#define AFX_JOYSTICKDIRECTX_H__0EB96245_FF20_470C_9BDE_9AD865DBBF4E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ForceFeedbackJoystick.h"
#include <string>

#include <windows.h>
#include "dinput.h"

class JoystickRange;

class JoystickDirectX : public ForceFeedbackJoystick  
{
public:
	virtual void printInfo();
	virtual std::string getName();
	bool hasForceFeedback();
	virtual PeriodicForceEffect *  getSawToothDownForce();
	virtual PeriodicForceEffect *     getSawToothUpForce();
	virtual PeriodicForceEffect *    getTriangleForce();
	virtual PeriodicForceEffect *   getSineForce();
	virtual PeriodicForceEffect *  getSquareForce();
	virtual RampForceEffect *  getRampForce();
	virtual ConstantForceEffect *  getConstantForce();
	JoystickDirectX();
	virtual ~JoystickDirectX();
	virtual int getNumButtons();
	virtual int getNumAxes();
	virtual bool isButtonPressed(int button_index);
	virtual JoystickRange * getXAxisRange();
	virtual JoystickRange * getYAxisRange();
	virtual JoystickRange * getRZAxisRange();
	virtual JoystickRange * getThrottleRange();
	virtual int getXValue();
	virtual int getYValue();
	virtual int getRZValue();
	virtual int getThrottleValue();
	virtual void update();
	virtual int getNumHats();
	virtual int getHatDirection(int hat_index);
	virtual bool hasRZAxis();
	virtual bool hasThrottle();
private:
	IDirectInputEffect * getEffect(REFGUID rguid);
	JoystickRange * getAxisRange(DIDEVICEOBJECTINSTANCE * deviceobject);
  LPDIRECTINPUT  directinput; 
  LPDIRECTINPUTDEVICE2 directinputdevice;
  DIDEVCAPS capabilities;
  bool hasthrottle;
  bool hasrzaxis;
  DIDEVICEOBJECTINSTANCE xaxisobject;
  DIDEVICEOBJECTINSTANCE yaxisobject;
  DIDEVICEOBJECTINSTANCE rzaxisobject;
  DIDEVICEOBJECTINSTANCE throttleobject;
  DIJOYSTATE joystickstate;
  bool hasforcefeedback;
};

#endif // !defined(AFX_JOYSTICKDIRECTX_H__0EB96245_FF20_470C_9BDE_9AD865DBBF4E__INCLUDED_)
