// JoystickFactory.h: interface for the JoystickFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JOYSTICKFACTORY_H__D551C74A_63A5_4A08_9EB2_388615C69CDE__INCLUDED_)
#define AFX_JOYSTICKFACTORY_H__D551C74A_63A5_4A08_9EB2_388615C69CDE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class Joystick;
class ForceFeedbackJoystick;
class JoystickDirectX;
class JoystickLinux;

class JoystickFactory  
{
public:
	void clear();
	ForceFeedbackJoystick * getForceFeedbackJoystick();
	Joystick * getJoystick();
	static JoystickFactory *  getInstance();
	virtual ~JoystickFactory();
private:
	JoystickFactory();
	static JoystickFactory instance;
#ifdef WIN32
	JoystickDirectX * joystick;
#else
	JoystickLinux * joystick;
#endif
	void initJoystick();
	bool nojoystick;
};

#endif // !defined(AFX_JOYSTICKFACTORY_H__D551C74A_63A5_4A08_9EB2_388615C69CDE__INCLUDED_)
