// JoystickDirectX.cpp: implementation of the JoystickDirectX class.
//
//////////////////////////////////////////////////////////////////////

#include "JoystickLinux.h"
#include <iostream.h>
#include "JoystickRange.h"
#include "JoystickException.h"
#include <GL/glut.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void joystick(unsigned int buttons, int xaxis, int yaxis, int zaxis)
{
  if(xaxis == 1000 && yaxis == 1000 && zaxis == 1000)
  { 
    // no joystick really , workaround for glut bug
  }
  else
  {
    
    JoystickLinux::xvalue = xaxis;
    JoystickLinux::yvalue = yaxis;
    JoystickLinux::zvalue = zaxis;
    JoystickLinux::buttonsmask = buttons;
  }
}

int JoystickLinux::xvalue = 0;
int JoystickLinux::yvalue =0 ;
int JoystickLinux::zvalue = 0;
int JoystickLinux::buttonsmask = 0;

JoystickLinux::JoystickLinux()
{
    glutJoystickFunc(joystick,50);

}

JoystickLinux::~JoystickLinux()
{

}



int JoystickLinux::getNumButtons()
{
  return 9;
}

int JoystickLinux::getNumAxes()
{
  return 2;
}

bool JoystickLinux::isButtonPressed(int button_index)
{
    return JoystickLinux::buttonsmask & (1 << button_index);
}

JoystickRange * JoystickLinux::getXAxisRange()
{
  return new JoystickRange(-1000, 1000);
}

JoystickRange * JoystickLinux::getYAxisRange()
{
  return new JoystickRange(-1000, 1000);
}

JoystickRange * JoystickLinux::getRZAxisRange()
{
   return new JoystickRange(-1000, 1000);
}

JoystickRange * JoystickLinux::getThrottleRange()
{
  return NULL;
}

int JoystickLinux::getXValue()
{
  return JoystickLinux::xvalue ;
}

int JoystickLinux::getYValue()
{
  return JoystickLinux::yvalue;
}


int JoystickLinux::getRZValue()
{
  return JoystickLinux::zvalue;
}

int JoystickLinux::getThrottleValue()
{
  return 0;
}

void JoystickLinux::update()
{

}

int JoystickLinux::getNumHats()
{
	return 0;
}

int JoystickLinux::getHatDirection(int hat_index)
{
	return 0;
}

bool JoystickLinux::hasThrottle()
{
  return false;
}

bool JoystickLinux::hasRZAxis()
{
  return true;
}


bool JoystickLinux::hasForceFeedback()
{
  return false;
}

std::string JoystickLinux::getName()
{  
  return "Joystick";

}

void JoystickLinux::printInfo()
{
//  if(glutDeviceGet(GLUT_HAS_JOYSTICK) )
  {
    cout << "Found joystick with "  << glutDeviceGet(GLUT_JOYSTICK_BUTTONS) << " buttons" << endl;
  }

}
