// LandingComm.cpp: implementation of the LandingComm class.
//
//////////////////////////////////////////////////////////////////////

#include <string>
#include "LandingComm.h"
#include "MovieFactory.h"
#include "Movie.h"

using std::string;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LandingComm::LandingComm(char name[], char videoname[], char label[])
  :Comm(name, videoname, label, true)
{
   string newname;
   MovieFactory * moviefactory;

   landing_sound   = getSound((char *) (string(name) + "_landing.wav").c_str());
   if(strlen(videoname) == 0)
   {
	 landing_movie = NULL;
   }
   else
   {    
 		moviefactory = MovieFactory::getInstance();
		newname = string(videoname) + "_landing.avi";
	    landing_movie = moviefactory->getMovie((char *) newname.c_str() );
   }

}

LandingComm::~LandingComm()
{

}

void LandingComm::landing()
{
  playNow(landing_sound, landing_movie, name, friendly);
}
