// LandingCutScene.h: interface for the LandingCutScene class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LANDINGCUTSCENE_H__98906DF1_99A3_4411_87DB_14B60586D5C6__INCLUDED_)
#define AFX_LANDINGCUTSCENE_H__98906DF1_99A3_4411_87DB_14B60586D5C6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <GL/glew.h>
#include "CutScene.h"
#include "Object3d.h"
#include "Time.h"
#include "DiffuseLight.h"
#include "AmbientLight.h"

class ship;

class LandingCutScene : public CutScene  
{
public:
	virtual void advance();
	virtual void render();
	void setPlayer(Object3d * newplayer);
	virtual void start();
	virtual bool isDone();
	LandingCutScene();
	virtual ~LandingCutScene();
private:
	ship * player;
   Object3d * hangar;
   TimeValue starttime;
   TimeValue duration;
   float starty;
   float endy;
   DiffuseLight light;
   AmbientLight ambient;
};

#endif // !defined(AFX_LANDINGCUTSCENE_H__98906DF1_99A3_4411_87DB_14B60586D5C6__INCLUDED_)
