// LeftCamera.cpp: implementation of the LeftCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "ship.h"
#include "LeftCamera.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LeftCamera LeftCamera::me;

LeftCamera::LeftCamera()
{

}

LeftCamera::~LeftCamera()
{

}

Coordinate LeftCamera::getHeading()
{
   return Camera::getFocusObject()->getleft();
}

void LeftCamera::render()
{
  Object3d * myfocus = Camera::getFocusObject();
  Coordinate lookat;

  myfocus->setrenderingenabled(false);
  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  Coordinate heading = myship->getleft();
  Coordinate up = myship->getUp();

  lookat = (heading * CAMERA_VIEW_RADIUS) + cockpit;

  gluLookAt((GLdouble) cockpit.x, (GLdouble) cockpit.y, (GLdouble) cockpit.z, 
            (GLdouble) lookat.x, (GLdouble) lookat.y, (GLdouble) lookat.z,             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);
  GLERRORCHECK

}

Camera * LeftCamera::getInstance()
{
  return & me;
}

Coordinate LeftCamera::getLocation()
{
  Object3d * myfocus = Camera::getFocusObject();
  Coordinate lookat;

  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  return cockpit;
}
