// LightManager.h: interface for the LightManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGHTMANAGER_H__FB92929E_ADC7_4031_AAC7_0EE39F5AA569__INCLUDED_)
#define AFX_LIGHTMANAGER_H__FB92929E_ADC7_4031_AAC7_0EE39F5AA569__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "coord.h"
#include <list>
#include "Light.h"
#include "DiffuseLight.h"
#include "AmbientLight.h"
#include "Color.h"	// Added by ClassView

class LightManager  
{
public:
	AmbientLight * getAmbientLight();
	void removeGlobalLight(DiffuseLight * light);
	Color getLensFlareColor();
	Coordinate getLensFlareSourceLocation();
	void setAmbientLight(AmbientLight * light);
	void printLightState();
	static LightManager * getInstance();
	void removeLocalLight(DiffuseLight * light);
	void addGlobalLight(DiffuseLight * light);
	void addLocalLight(DiffuseLight * light);
	void clear();
	void renderLocalLights(Coordinate position);
	void renderGlobalLights();

	virtual ~LightManager();
private:
	LightManager();
	static LightManager instance;
	DiffuseLight * lensflarelight;
	std::list<Light *> globallights;
	std::list<DiffuseLight *> locallights;
	int num_gl_lights;
	AmbientLight * ambient;
};

#endif // !defined(AFX_LIGHTMANAGER_H__FB92929E_ADC7_4031_AAC7_0EE39F5AA569__INCLUDED_)
