// MessageXmlAdapter.cpp: implementation of the MessageXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#include "MessageXmlAdapter.h"
#include "weaponsxmladapter.h"
#include "saxexpat.h"
#include "InputSource.h"
#include "Constants.h"
#include "AttributeList.h"
#include <ctype.h>
#include "ErrorHandlerE.h"
#include <iostream.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MessageXmlAdapter::MessageXmlAdapter(char xmlfilename[])
{
   expat myParser;

   bool exists = ErrorHandlerE::fileExists(xmlfilename);
   if(exists)
   {
     intextblock = false;
     myParser.setDocumentHandler(*this);
     myParser.setErrorHandler(ErrorHandlerE::getInstance() );
     myParser.parse(*(new SAX::InputSource(xmlfilename)));
   }

}

MessageXmlAdapter::~MessageXmlAdapter()
{

}


void MessageXmlAdapter::startDocument()
{

}

void MessageXmlAdapter::endDocument()
{

}


void MessageXmlAdapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
  if(name == "text")
  {
	colored = false;
	intextblock = true;
  }
  else if(name == "coloredtext")
  {
	colored = true;
	intextblock = true;
  }
}


void MessageXmlAdapter::endElement(const std::string& name)
{
  if(name == "message")
  {
	messages.push_back(currentmessage);
	currentmessage.clear();
  }
  else   if(name == "text")
  {
	intextblock = false;
  }
  else if(name == "coloredtext")
  {
	intextblock = false;
  }

}


void MessageXmlAdapter::characters(const std::string& ch)
{
  if(ch[0] == 9 || ch[0] == 10)
  {
	return;
  }
  if(! intextblock)
  {
	return;
  }
  currenttext = ch;
  currentmessage.lines.push_back(currenttext);
  currentmessage.colored.push_back(colored);
}
