// MessageXmlAdapter.h: interface for the MessageXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESSAGEXMLADAPTER_H__72FB93F2_303D_44BA_BB39_5AF942E633A0__INCLUDED_)
#define AFX_MESSAGEXMLADAPTER_H__72FB93F2_303D_44BA_BB39_5AF942E633A0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <vector>
#include "Message.h"
#include "HandlerBase.h"

using namespace SAX;

class MessageXmlAdapter : public HandlerBase
{
public:
	MessageXmlAdapter(char filename[]);
	virtual ~MessageXmlAdapter();
	virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
	std::vector<Message> messages;
private:

	std:: string currenttext;
	Message currentmessage;
	bool colored;
	bool intextblock;
};

#endif // !defined(AFX_MESSAGEXMLADAPTER_H__72FB93F2_303D_44BA_BB39_5AF942E633A0__INCLUDED_)
