// Missile.h: interface for the Missile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MISSILE_H__4E52F5F9_0F69_468B_A327_A51EA36C3364__INCLUDED_)
#define AFX_MISSILE_H__4E52F5F9_0F69_468B_A327_A51EA36C3364__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Targetable.h"
#include "mesh.h"
#include "shipareas.h"
#include "Image.h"
#include "Color.h"	// Added by ClassView
#include "SoundEffect3d.h"

class ship;
class Texture;
class WorldOrientedBillboard;

class Missile : public Targetable  
{
public:
	void attemptSpoof(Coordinate decoylocation);
	virtual bool instanceof(InstanceT it);
    virtual void setDestroyed();
	virtual bool instanceof(char classname [ ]);
	virtual void advance();
	void setFiredByPlayer();
   virtual void targetDestroyed();
	virtual void render();
	virtual Targetable * getTarget();
	virtual bool cantHit(Object3d * other);
	void setCantHit(Object3d * other);
	virtual void damage(int amount, Coordinate fromlocation);
	virtual void onCollisionWith(Object3d * newobject);
	virtual Color getRadarColor(ship * player);
	Missile(mesh * newmesh,  Coordinate position, Coordinate newheading, Coordinate newup, Coordinate newleft,
        shipareas newarmor,
        float newvelocity, float newroll, float newpitch, float newyaw, 
		float acceleration,
        Image * newimage, string newname, int damage, float range,
        bool tracking, bool torp, bool damage_turrets,
		SoundEffect3d * newsound,
		Texture * engine_texture, Texture * exhausttexture,
		float newspoofprob);
	virtual ~Missile();
private:
	void doSpoof(Coordinate decoylocation);
	void renderExhaust();
	bool canDamage(Object3d * other);
   int damageamount;
//   float range;
   Object3d * donthit;
   bool damage_capships;
   bool damage_turrets;
   bool fired_by_player;
   SoundEffect3d * sound;
   WorldOrientedBillboard * enginebillboard;
   WorldOrientedBillboard * exhaustbillboard;
   float spoofprobability;
   bool is_spoofed;
   float rangesquared;
};

#endif // !defined(AFX_MISSILE_H__4E52F5F9_0F69_468B_A327_A51EA36C3364__INCLUDED_)
