// MissileDescription.h: interface for the MissileDescription class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MISSILEDESCRIPTION_H__277B3464_0B8E_44E2_8FC0_0E47A90F545F__INCLUDED_)
#define AFX_MISSILEDESCRIPTION_H__277B3464_0B8E_44E2_8FC0_0E47A90F545F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "weapondescription.h"
#include "mesh.h"
#include "shipareas.h"	// Added by ClassView

class Reticle;
class Image;
class Texture;

class MissileDescription : public weapondescription  
{
public:
	float getSpoof();
	Texture * getExhaustTexture();
	virtual void  load();
	Reticle * getReticle();
	bool isTracking();
	int getLockTime();
	virtual bool isMissile();
	shipareas getArmor();
	Image * getImage();
	MissileDescription(int newrange, int newdamage, std::string newmesh,
     float newvelocity, float newroll, float newpitch, float newyaw, 
	 float newaccel, string name, 
	 std::string newimagename, shipareas newarmor, int locktime, bool newtracking, 
	 bool newdamagecapships, bool newdamage_turrets, int refire_delay, float newspoof,
	 int newsoundindex,
	 std::string reticlename="", 
	 std::string reticletype="", std::string icon="",  std::string exhaustname="");
	virtual ~MissileDescription();
private:
	std::string imagename;
	std::string reticlename;
	std::string reticletype;
   Image * image;
   Reticle * reticle;
   shipareas armor;
   int locktime;
   bool tracking;
   bool loaded;
   std::string exhaust;
   Texture * exhausttexture;
   float spoof;
};

#endif // !defined(AFX_MISSILEDESCRIPTION_H__277B3464_0B8E_44E2_8FC0_0E47A90F545F__INCLUDED_)
