// Mission.h: interface for the Mission class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MISSION_H__D43D94F1_733F_4B41_A5BC_D33F225388AC__INCLUDED_)
#define AFX_MISSION_H__D43D94F1_733F_4B41_A5BC_D33F225388AC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "NavPoint.h"
#include "ship.h"
#include "AutoPilotCutScene.h"
#include <string>
#include <vector>
#include "DebriefingInfo.h"	// Added by ClassView

using std::string;

class Mission  
{
public:
	bool canEjectToNextMission();
	bool hasFriendsAtCurrentNav();
	DebriefingInfo getDebriefingInfo();
	void incrementPlayerGunFired();
	void incrementPlayerMissileFired();
	void incrementPlayerMissileHits();
	void incrementPlayerGunHits();
	void incrementPlayerKills();
	ship * getLandingShip();
	ship * * getFriendlyFighters(int & num);
	bool enemiesAtCurrentNav();
	string getSectorName();
	void preloadShips();
	bool getFailed();
	void onLanding();
	bool isComplete();
	Object3d * preloadPlayer();
	void onAutoPilotDone();
	void onAutoPilot();
	void onDestroyed(ship * destroyedship, bool ejected=false);
	void nextNavPoint();
	void activateNavPoint();
	bool canAutoPilot();
	static Mission * getCurrentMission();
	ship * getPlayer();
	Mission(char filename[]);
	virtual ~Mission();
private:
	int countWingmen();
   int numnavpoints;
   NavPoint * * navpoints;
   string name;
   int currentnavpoint;
   ship * player;
   static Mission * currentmission;
   std::vector<ship *> shipsv;
   int numshipsdestroyed;
   int numenemyshipsdestroyed;
   int numenemyships;
   int friendly_ships_lost;
   AutoPilotCutScene * cutscene;
   bool failed;
   string sectorname;
   ship * landingship;
   int num_player_kills;
   int num_player_gun_hits;
   int num_player_gun_fired;
   int num_player_missile_hits;
   int num_player_missile_fired;
   bool can_eject;
};

#endif // !defined(AFX_MISSION_H__D43D94F1_733F_4B41_A5BC_D33F225388AC__INCLUDED_)
