// MissionXmlAdapter.h: interface for the MissionXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MISSIONXMLADAPTER_H__23B5CC8C_520E_4526_ADD6_4DA3443C4AF0__INCLUDED_)
#define AFX_MISSIONXMLADAPTER_H__23B5CC8C_520E_4526_ADD6_4DA3443C4AF0__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>
#include "coord.h"
#include "ShipInfo.h"
#include "NavPoint.h"
#include "AsteroidBeltInfo.h"

using namespace SAX;
using std::string;

class MissionXmlAdapter : public HandlerBase  
{
public:
	bool getCanEject();
	string * getBriefingText();
	int getNumBriefingLines();
	string getSectorName();
	NavPoint * * getNavPoints(int & numnavpoints);
	string getName();
	MissionXmlAdapter(char filename[]);
	virtual ~MissionXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
	ShipInfo * shipinfos;
   Coordinate currentpoint;
   Coordinate currentlocation;
   string missionname;
   int numnavpoints;
   int currentnavpoint;
   NavPoint * * navpoints;
   int numships;
   int currentship;
   string sectorname;
   bool briefing;
   string briefingtext[18];
   int briefingtextcount;
   bool landshipassigned;
   bool asteroidsvalid;
   AsteroidBeltInfo asteroidinfo;
   int lastautopilotnav;
   bool can_eject;
};

#endif // !defined(AFX_MISSIONXMLADAPTER_H__23B5CC8C_520E_4526_ADD6_4DA3443C4AF0__INCLUDED_)
