// MovieFactory.cpp: implementation of the MovieFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "MovieFactory.h"
#include "AviMovie.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MovieFactory MovieFactory::instance;

MovieFactory::MovieFactory()
: movieshash(15)
{
  inited = false;
}

MovieFactory::~MovieFactory()
{

}

MovieFactory * MovieFactory::getInstance()
{
  return & instance;
}

Movie * MovieFactory::getMovie(char filename [ ])
{
  Movie * newmovie;

  if(! inited)
  {
    inited = true;
	AviMovie::staticInit();
  }
  if(movieshash.hasKey(filename) )
  {
	return (Movie *) movieshash.getItem(filename);
  }
  
  newmovie = new AviMovie(filename);
  movieshash.addItem(filename, newmovie);
  movies.push_back(newmovie);
  return newmovie;
}

void MovieFactory::clear()
{
  inited = false;
  int i;

  for(i=0; i < movies.size(); i++)
  {
	Movie * movie = movies[i];
	delete movie;	
  }
  movies.clear();
  movieshash.clear();
  AviMovie::staticClear();
}
