// MovieFactory.h: interface for the MovieFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOVIEFACTORY_H__C9E82098_AE9D_44BA_A5CF_5E24AF4051ED__INCLUDED_)
#define AFX_MOVIEFACTORY_H__C9E82098_AE9D_44BA_A5CF_5E24AF4051ED__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <vector>
#include "HashTable.h"

class Movie;

class MovieFactory  
{
public:
	void clear();
	Movie * getMovie(char filename[] );
	static MovieFactory * getInstance();
	virtual ~MovieFactory();
private:
	MovieFactory();
	static MovieFactory instance;
    HashTable movieshash;
	std::vector<Movie *> movies;
	bool inited;
};

#endif // !defined(AFX_MOVIEFACTORY_H__C9E82098_AE9D_44BA_A5CF_5E24AF4051ED__INCLUDED_)
