// MusicFactory.cpp: implementation of the MusicFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "MusicFactory.h"
#include <stdlib.h>
#include <string.h>
#ifdef HAS_BASS
#include "TrackerMusic.h"
#include "MP3Music.h"
#elif defined(HAS_FMOD)
#include "MP3Music.h"
#else
#include "NullMusic.h"
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MusicFactory * MusicFactory::factory = NULL;

MusicFactory::MusicFactory()
{

}

MusicFactory::~MusicFactory()
{

}

Music * MusicFactory::getMusic(char filename [ ], bool repeat)
{
#ifdef HAS_BASS
   if(strstr(filename, "mp3") != NULL)
   {
	return new MP3Music(filename, repeat);
   }
   else
   {
     return new TrackerMusic(filename, repeat);
   }
#elif defined(HAS_FMOD)
   return new MP3Music(filename, repeat);
#else
   return new NullMusic(filename, repeat);
#endif
}

MusicFactory * MusicFactory::getMusicFactory()
{
  if(factory == NULL)
    factory = new MusicFactory();
  return factory;
}
