// MusicManager.h: interface for the MusicManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MUSICMANAGER_H__72946788_661C_487A_8F2F_93ECFE95EF59__INCLUDED_)
#define AFX_MUSICMANAGER_H__72946788_661C_487A_8F2F_93ECFE95EF59__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TrackerMusic.h"
#include "Mission.h"

class MusicManager  
{
public:
	void briefing();
	bool isPlaying();
	void onKillFriend();
	void onNewNavPoint();
	void advance();
	static void clear();
	static MusicManager * getInstance();
	void onMusicFinish();
	void setMission(Mission * mission);
	void landing();
	void takeoff();
	void onKillEnemy();
	void onPlayerDeath();
	void onPlayerEject();
	MusicManager();
	virtual ~MusicManager();
private:
	void stopCurrent();
   Music * currentmusic;
   Music * takeoffmusic;
   Music * no_enemies;
   Music * mission_complete;
   Music * landing_music;
   Music * dead;
   Music * eject;
   Music * kill_enemy;
   Music * kill_friend;
   Music * combat1;
   Music * combat2;
   Music * briefingmusic;
   static MusicManager * manager;
   bool musicfinished;
   Mission * mission;
};

#endif // !defined(AFX_MUSICMANAGER_H__72946788_661C_487A_8F2F_93ECFE95EF59__INCLUDED_)
