// NavPoint.cpp: implementation of the NavPoint class.
//
//////////////////////////////////////////////////////////////////////

#include "NavPoint.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

NavPoint::NavPoint(int newnumships, ShipInfo * newshipinfos, Coordinate newlocation)
  : numships(newnumships),
    shipinfos(newshipinfos),
    location(newlocation)    
{
  asteroidvalid = false;
}

NavPoint::NavPoint(int newnumships, ShipInfo * newshipinfos, Coordinate newlocation, 
				   AsteroidBeltInfo newastinfo)
  : numships(newnumships),
    shipinfos(newshipinfos),
    location(newlocation),
	asteroidinfo(newastinfo)    

{
  asteroidvalid = true;
}

NavPoint::~NavPoint()
{

}

ShipInfo NavPoint::getShipInfo(int index)
{
   return shipinfos[index];
}

int NavPoint::getNumShips()
{
  return numships;
}

bool NavPoint::hasAsteroidBelt()
{
  return asteroidvalid;
}

AsteroidBeltInfo NavPoint::getAsteroidInfo()
{
  return asteroidinfo;
}
