// Panel.h: interface for the Panel class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANEL_H__A12023A9_DFB3_4905_A33D_39BB80E4570B__INCLUDED_)
#define AFX_PANEL_H__A12023A9_DFB3_4905_A33D_39BB80E4570B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "Rect.h"
#include <string>
#include "AbstractPanel.h"

class Image;
class Font;

using std::string;

class Panel : public AbstractPanel 
{
public:
	string getLineText(int linenumber);
	string getStatusText();
	void setStatusText(string newtext);
	virtual void onCancel();
	virtual void onConfirm();
	void setConfirmText(string confirmtext);
	virtual void onLineClick(int linenumber);
	void setLine(string text, int linenumber);
	void setNumLines(int numlines);
	void setTitle(char newtitle[]);
	static void clean();
	Panel();
	virtual ~Panel();
   virtual void onDisplay(); // all setup is performed elsewheer, just draw 2d
   /* returns true if the panel is exiting */
   virtual bool onMouseDown(int button, int state, int x, int y);
   virtual bool onKeyboard(unsigned char key, int x, int y);
private:
   static Image * panelimage;
   static Rect exitrect;
   static Rect confirmrect;
   string title;
   string * items;
   string confirmtext;
   string statustext;
   int numitems;
   static Font * font;
   float lineincrement;
   float halfincrement;
};

#endif // !defined(AFX_PANEL_H__A12023A9_DFB3_4905_A33D_39BB80E4570B__INCLUDED_)
