// PeriodicForceEffect.cpp: implementation of the PeriodicForceEffect class.
//
//////////////////////////////////////////////////////////////////////

#include "PeriodicForceEffect.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PeriodicForceEffect::PeriodicForceEffect(IDirectInputEffect * newieffect)
: DirectionalForceEffect(newieffect)
{
  eff.lpvTypeSpecificParams = &diperiodic;
  eff.cbTypeSpecificParams = sizeof(diperiodic);

}

PeriodicForceEffect::~PeriodicForceEffect()
{

}

void PeriodicForceEffect::setMagnitude(int magnitude)
{
  diperiodic.dwMagnitude = magnitude;
}

void PeriodicForceEffect::setPhase(int phase)
{
  diperiodic.dwPhase = phase;
}

void PeriodicForceEffect::setOffset(int offset)
{
  diperiodic.lOffset = (LONG) offset;
}

void PeriodicForceEffect::setPeriod(int period)
{
  diperiodic.dwPeriod = period;
}
