// Physics.cpp: implementation of the Physics class.
//
//////////////////////////////////////////////////////////////////////

#include "Physics.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Physics::Physics()
{

}

Physics::~Physics()
{

}
// hi

/* Equations from Chris Heckbert's 3rd physics article */
bool Physics::collisionResponse(float mass1, float mass2, Coordinate pos1, Coordinate pos2, Coordinate velocity1, Coordinate velocity2, Coordinate & newvelocity1, Coordinate & newvelocity2)
{
  Coordinate normal;  // from mass2 to mass1
  Coordinate relative_initial_velocity;  // velocity1 - velocity2
  const float restitution_coefficient = .999f;  // 1 = perfectly elastic collision
  float impulse;

  normal =  pos1 - pos2;
//  normal =  pos2 - pos1;
  relative_initial_velocity = velocity1 - velocity2;

  if(relative_initial_velocity.dot(normal) >= 0.0f)
  { 
  // no collision
    newvelocity1 = velocity1;
    newvelocity2 = velocity2;
    return false;
  }

  // now find the new initial velocity in the direction of the collision
  impulse = -(1.0f + restitution_coefficient)*(relative_initial_velocity.dot(normal));
  impulse /= (normal.dot(normal) * (1.0f/mass1 + 1.0f/mass2));

  newvelocity1 = velocity1 +  normal * (impulse / mass1);
  newvelocity2 = velocity2 -  normal * (impulse / mass2);
  return true;
}
