// PlayerComm.cpp: implementation of the PlayerComm class.
//
//////////////////////////////////////////////////////////////////////

#include "PlayerComm.h"
#include <string>

using std::string;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PlayerComm::PlayerComm(char name[])
  : Comm(name, "", "", true)
{
  break_sound   = getSound((char *) (string(name) + "_breakandattack.wav").c_str());
  attack_sound = getSound((char *) (string(name) + "_attackmytarget.wav").c_str());
  help_sound = getSound((char *) (string(name) + "_help.wav").c_str());
  landing_sound = getSound((char *) (string(name) + "_requestland.wav").c_str());
  askstatus_sound = getSound((char *) (string(name) + "_askstatus.wav").c_str());
}

PlayerComm::~PlayerComm()
{

}

void PlayerComm::breakAndAttack()
{
  playNow(break_sound, NULL, "", true);
}

void PlayerComm::attackMyTarget()
{
  playNow(attack_sound, NULL, "", true);
}

void PlayerComm::help()
{
  playNow(help_sound, NULL, "", true);
}

void PlayerComm::requestLanding()
{
	playNow(landing_sound, NULL, "", true);

}

void PlayerComm::askStatus()
{
	playNow(askstatus_sound, NULL, "", true);
}
