// PngImage.cpp: implementation of the PngImage class.
//
//////////////////////////////////////////////////////////////////////

#include "glpng.h"
#include "PngImage.h"
#include <glut.h>
#include "TextureFactory.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PngImage::PngImage(char filename[])
{
  pngLoadRaw(filename, &pngdata);
  texture = TextureFactory::getTexture(filename);
}

PngImage::~PngImage()
{

}

int PngImage::getWidth()
{
  return pngdata.Width;
}

int PngImage::getHeight()
{
  return pngdata.Height;
}

void PngImage::render(float x, float y)
{
  glRasterPos2f(x, y);
  /*glDrawPixels(pngdata.Width, pngdata.Height, GL_RGB, GL_UNSIGNED_BYTE, pngdata.Data); */
     glEnable(GL_TEXTURE_2D);
   glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

  texture->render();
  glNormal3f(0.0f, 0.0f, 1.0f);
  glBegin(GL_QUADS);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(x, y);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(x + getWidth(), y);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(x + getWidth(), y + getHeight() );
    glTexCoord2f(0.0f, 1.0f);
	glVertex2f(x , y + getHeight() );
  glEnd();
  glDisable(GL_TEXTURE_2D);
  GLERRORCHECK

}
