// Pod.cpp: implementation of the Pod class.
//
//////////////////////////////////////////////////////////////////////

#include "Pod.h"
#include "mesh.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Pod::Pod(mesh * newmesh)
{
  mymesh = newmesh;
}

Pod::~Pod()
{

}

mesh * Pod::getMesh()
{
  return mymesh;
}

Pod::Pod(Pod & that)
{ 
  mymesh = that.mymesh;
  translation = that.translation;
}

void Pod::setTranslation(Coordinate newcoord)
{
  translation = newcoord;
}

Coordinate Pod::getTranslation()
{
  return translation;
}

Coordinate Pod::getMaxs()
{
  return mymesh->getMaxs() + translation;
}

Coordinate Pod::getMins()
{
  return mymesh->getMins() + translation;
}
