// PositionHistory.cpp: implementation of the PositionHistory class.
//
//////////////////////////////////////////////////////////////////////

#include "PositionHistory.h"
#include <iostream.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PositionHistory::PositionHistory(float newdistancebetween, int newsize)
: ringbuffer(newsize)
{
  maxhist = newsize;
  distancebetween = newdistancebetween * newdistancebetween;
}

PositionHistory::~PositionHistory()
{

}

void PositionHistory::update(Coordinate currentposition)
{
  float currentd2;


  currentd2 = lastposition.distanceSquared(currentposition);
  if(ringbuffer.getNumElements() == 0)
  {
    ringbuffer.addBack(currentposition);
	lastposition = currentposition;
  }
  else if(currentd2 >= distancebetween) 
  {
    if(ringbuffer.isFull() )
	{
	  ringbuffer.removeFront();
	}
	ringbuffer.addBack(currentposition);
	lastposition = currentposition;
  }

}

int PositionHistory::getNumElements()
{
  return ringbuffer.getNumElements();
}

Coordinate PositionHistory::getElement(int index)
{
  return ringbuffer.get(index);
}

int PositionHistory::getMaxElements()
{
  return maxhist;
}
