// PositionHistory.h: interface for the PositionHistory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POSITIONHISTORY_H__EB608920_F8ED_453F_92DE_AC55D7893C57__INCLUDED_)
#define AFX_POSITIONHISTORY_H__EB608920_F8ED_453F_92DE_AC55D7893C57__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "CircularBuffer.h"
#include "coord.h"


class PositionHistory  
{
public:
	int getMaxElements();
	Coordinate getElement(int index);
	int getNumElements();
	void update(Coordinate currentposition);
	PositionHistory(float distance, int maxhistory);
	virtual ~PositionHistory();
private:
	CircularBuffer<Coordinate> ringbuffer;
	float distancebetween;
	int maxhist;
	Coordinate lastposition;
};

#endif // !defined(AFX_POSITIONHISTORY_H__EB608920_F8ED_453F_92DE_AC55D7893C57__INCLUDED_)
