// PursueBehavior.cpp: implementation of the PursueBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "PursueBehavior.h"
#include "ship.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PursueBehavior::PursueBehavior()
{
  setoffset = false;
}

PursueBehavior::~PursueBehavior()
{
  
}

void PursueBehavior::move(Targetable * body, Targetable * target)
{
  steerTo(body, getSteeringVector(body, target) ); 
}

void PursueBehavior::setPursuitOffset(Coordinate newoffset)
{ 
  offset = newoffset;
  setoffset = true;
}


Coordinate PursueBehavior::getSteeringVector(Targetable * body, Targetable * target)
{
   float distance;
   float moves_ahead;
   Coordinate predicted_position;
   float targetvelocity;

   if(! setoffset)
   {
     offset =  target->getHeading() * (-1.0f *(target->getradius() + 2.0f * body->getradius()));
     setoffset = true;
   }
   targetvelocity = target->getVelocity();
   distance = body->getLocation().distance( target->getLocation() );
   if(targetvelocity == 0.0f)
     moves_ahead = 1.0f;
   else
     moves_ahead = distance / targetvelocity;

   if(moves_ahead < 1.0f)
     moves_ahead = 1.0f;

   predicted_position = target->getLocation() + target->getHeading() * (targetvelocity * moves_ahead);

   predicted_position = predicted_position + offset;
   
   return seek(body, predicted_position);  
}
