// PursueWhenStrongBehavior.cpp: implementation of the PursueWhenStrongBehavior class.
//
//////////////////////////////////////////////////////////////////////

//#include "SeekBehavior.h"
#include "PursueWhenStrongBehavior.h"
#include "FleeBehavior.h"
#include "shipareas.h"
#include "ship.h"
#include "WanderBehavior.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//PursueWhenStrongBehavior PursueWhenStrongBehavior::instance;

PursueWhenStrongBehavior::PursueWhenStrongBehavior()
{

}

PursueWhenStrongBehavior::~PursueWhenStrongBehavior()
{

}


void PursueWhenStrongBehavior::move(Targetable * body, Targetable * target)
{
  float distance;
  float gunpercent;
  float worstshieldpercent;
  float currentshieldpercent;

  const float shieldthreshold = .38f;
 // const float distancethreshold = 20.0;
  const float energythreshold = .05f;
  bool noshields;


  distance = body->getLocation().distance( target->getLocation() );
  worstshieldpercent = 1.0f;
  shipareas shields = body->getShields();

  currentshieldpercent = (float) shields.getCurrentValue(FRONT) / (float) shields.getMaximum(FRONT);
  if(currentshieldpercent < worstshieldpercent)
     worstshieldpercent = currentshieldpercent;

  currentshieldpercent = (float) shields.getCurrentValue(BACK) / (float) shields.getMaximum(BACK);
  if(currentshieldpercent < worstshieldpercent)
     worstshieldpercent = currentshieldpercent;

  currentshieldpercent = (float) shields.getCurrentValue(LEFT) / (float) shields.getMaximum(LEFT);
  if(currentshieldpercent < worstshieldpercent)
     worstshieldpercent = currentshieldpercent;

  currentshieldpercent = (float) shields.getCurrentValue(RIGHT) / (float) shields.getMaximum(RIGHT);
  if(currentshieldpercent < worstshieldpercent)
     worstshieldpercent = currentshieldpercent;

  if(body->instanceof(INST_SHIP) )
  {
      ship * myship = (ship *) body;

      gunpercent = ((float) myship->getCurrentEnergy() )/((float) myship->getMaxEnergy() ) ;

  }
  else
  {
     gunpercent = 1.0f;
  } 
  noshields = ! shields.hasAnyOriginally();

  if(gunpercent < energythreshold ||  
	  (worstshieldpercent < shieldthreshold &&  (! noshields   ) ) 
	)
  {
 //   FleeBehavior::instance.move(body, target);
     body->incrementVelocity();
     /* close range wander to get out, once long range run away */
     if(distance < 4.0f)
     {
       if(body->instanceof(INST_SHIP) )
	   {
         ship * myship = (ship *) body;
         myship->setAfterburner(false);
	   }
       wander.move(body, target);
     }
     else
     {
		 // run away quickly by afterburning
         if(body->instanceof(INST_SHIP) )
		 {
           ship * myship = (ship *) body;
           myship->setAfterburner(true);
		 }

         FleeBehavior::instance.move(body, target);
     }
  }
  else
  {
//    SeekBehavior::instance.move(body, target);
/* adjust speed to slower if we're really close */
    if(distance < 2.0f * body->getradius() && distance > .5f)
    {
       body->decrementVelocity();      
    }
    else
    {
       body->incrementVelocity();
    }
    if(body->instanceof(INST_SHIP) )
    {
       ship * myship = (ship *) body;
       myship->setAfterburner(false);
	}
    pursue.setPursuitOffset( getPursuitOffset(body, target) );
    pursue.move(body, target);
  }
}

Coordinate PursueWhenStrongBehavior::getPursuitOffset(Targetable * body, Targetable * target)
{
/*
  if we're farther away, don't aim for the center
  find the weakest area, and aim for that side
  if there's a tie for the weakest area, aim for the back

  if we're close, aim for the center, because movements will cause us to move too far

*/

  float worstshieldpercent = 1.0f;
  shipareas shields = target->getShields();
  areas worstarea;

  float currentshieldpercent = (float) shields.getCurrentValue(FRONT) / (float) shields.getMaximum(FRONT);
  if(currentshieldpercent < worstshieldpercent)
  {
     worstarea =  FRONT;
     worstshieldpercent = currentshieldpercent;
  }
  currentshieldpercent = (float) shields.getCurrentValue(BACK) / (float) shields.getMaximum(BACK);
  if(currentshieldpercent < worstshieldpercent)
  {
     worstarea =  BACK;
     worstshieldpercent = currentshieldpercent;
  }
  currentshieldpercent = (float) shields.getCurrentValue(LEFT) / (float) shields.getMaximum(LEFT);
  if(currentshieldpercent < worstshieldpercent)
  {
     worstarea =  LEFT;
     worstshieldpercent = currentshieldpercent;
  }
  currentshieldpercent = (float) shields.getCurrentValue(RIGHT) / (float) shields.getMaximum(RIGHT);
  if(currentshieldpercent < worstshieldpercent)
  {
     worstarea =  RIGHT;
     worstshieldpercent = currentshieldpercent;
  }
  if(worstshieldpercent == 1.0f)  // do damage, choose back
  {
    worstarea =  BACK;
  }

  float radius = target->getradius() + .5f;
  Coordinate zero;
  if(worstarea == BACK)
  {
     return zero - (target->getHeading() * radius);
  }
  else if(worstarea == FRONT)
  {
     return target->getHeading() * radius;
  }
  else if(worstarea == LEFT)
  {
     return target->getleft() * radius;
  }
  else if(worstarea == RIGHT)
  {
     return zero - (target->getleft() * radius);
  }
  return zero;
}
