// ReticleFactory.cpp: implementation of the ReticleFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "ReticleFactory.h"
#include "CenteredReticle.h"
#include "BorderingReticle.h"

using std::string;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ReticleFactory ReticleFactory::instance;

ReticleFactory::ReticleFactory()
: hashtable(50)
{

}

ReticleFactory::~ReticleFactory()
{

}

ReticleFactory * ReticleFactory::getInstance()
{
  return &instance;
}

Reticle * ReticleFactory::getReticle(std::string type, std::string imagename)
{
  if(hashtable.hasKey((char *)imagename.c_str() ) )
  {
    return (Reticle *) hashtable.getItem((char *) imagename.c_str() );
  }
  else
  {
    Reticle * newreticle;
	if(type == "border")
	{
       newreticle= new BorderingReticle((char *) imagename.c_str() );
	}
	else
	{
       newreticle= new CenteredReticle((char *) imagename.c_str() );
	}
    hashtable.addItem((char *)imagename.c_str(), newreticle);
	return newreticle;
  }
}

void ReticleFactory::clear()
{
  instance.hashtable.clear();
}
