// ReticleSquare.cpp: implementation of the ReticleSquare class.
//
//////////////////////////////////////////////////////////////////////

#include "ReticleSquare.h"

#include "stdlib.h"
#include <GL/glew.h>
#include "glut.h"
#include "glerr.h"

#include "Math.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ReticleSquare::ReticleSquare()
{
  valid = false;
}

ReticleSquare::~ReticleSquare()
{

}

void ReticleSquare::set(float newcenterx, float newcentery, 
						float newwidth, float newheight)
{
  centerx = newcenterx;
  centery = newcentery;
  width = newwidth;
  height = newheight;
  valid = true;
}

void ReticleSquare::render(float maxside, float minside, bool connected)
{ 
  if(! valid)
    return;

  float mycenterx = centerx;
  float mycentery = centery;
  float tempside = MAX(width, height);
  if(tempside <= maxside && tempside >= minside)
  {
     side = tempside;
  }
  else if(tempside < minside)
  {
     side = minside;
  }
  else
  {
      side = maxside;
  }
  float side_2 = side * .5;

  float x0, x1;
  float y0, y1;

  x0 = mycenterx - side_2;
  x1 = mycenterx + side_2;
  y0 = mycentery - side_2;
  y1 = mycentery + side_2;

    
  glLineWidth( 2.0f); 
 


  if(connected)
  {

    glBegin(GL_LINE_LOOP);
      glVertex2f(x0, y0);
      glVertex2f(x0, y1);
      glVertex2f(x1, y1);
      glVertex2f(x1, y0);
    glEnd();
  }
  else
  {
	  float fraction = side * .25;
	  glBegin(GL_LINE_STRIP);
        glVertex2f(x0, y0 + fraction);
        glVertex2f(x0, y0);
        glVertex2f(x0 + fraction, y0);
	  glEnd();

	  glBegin(GL_LINE_STRIP);
        glVertex2f(x1 - fraction, y0);
        glVertex2f(x1, y0);
        glVertex2f(x1, y0 + fraction);
	  glEnd();

	  glBegin(GL_LINE_STRIP);
        glVertex2f(x0 , y1 - fraction);
        glVertex2f(x0, y1);
        glVertex2f(x0 + fraction, y1);
	  glEnd();

	  glBegin(GL_LINE_STRIP);
        glVertex2f(x1 - fraction , y1 );
        glVertex2f(x1, y1);
        glVertex2f(x1, y1 - fraction);
	  glEnd();

  }
  glLineWidth( 1.0f); 
  GLERRORCHECK
}


Rect ReticleSquare::toRect()
{
  return Rect(centerx - side/2, centery - side/2, side, side);
}

void ReticleSquare::setInvalid()
{
  valid = false;
}

bool ReticleSquare::isValid()
{
  return valid;
}
