// RightCamera.cpp: implementation of the RightCamera class.
//
//////////////////////////////////////////////////////////////////////

#include "RightCamera.h"
#include "ship.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RightCamera RightCamera::me;

RightCamera::RightCamera()
{

}

RightCamera::~RightCamera()
{

}


Coordinate RightCamera::getHeading()
{
  Coordinate zero;

  return zero - Camera::getFocusObject()->getleft();
}


void RightCamera::render()
{
  Coordinate lookat;
  Object3d * myfocus = Camera::getFocusObject();

  myfocus->setrenderingenabled(false);
  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  Coordinate heading = myship->getleft();
  Coordinate up = myship->getUp();

  lookat = cockpit - (heading * CAMERA_VIEW_RADIUS);

  gluLookAt((GLdouble) cockpit.x, (GLdouble) cockpit.y, (GLdouble) cockpit.z, 
            (GLdouble) lookat.x, (GLdouble) lookat.y, (GLdouble) lookat.z,             
            (GLdouble) up.x, (GLdouble) up.y, (GLdouble) up.z);
}

Camera * RightCamera::getInstance()
{
  return & me;
}

Coordinate RightCamera::getLocation()
{
  Coordinate lookat;
  Object3d * myfocus = Camera::getFocusObject();
  ship * myship = (ship *) myfocus;
  Coordinate cockpit = myship->getCockpitLocation();// + myship->getLocation();
  return cockpit;
}
