// SaveGameXmlAdapter.cpp: implementation of the SaveGameXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#include "SaveGameXmlAdapter.h"
#include "saxexpat.h"
#include "InputSource.h"
#include "AttributeList.h"
#include "ErrorHandlerE.h"
#include <ctype.h>


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SaveGameXmlAdapter::SaveGameXmlAdapter(char xmlfilename[])
{
	expat myParser;

   lastname=0;
   lastmission=0;
   lastcampaign=0;

   campaigns = NULL;
   missions = NULL;
   names = NULL;
   numsaves = 0;
   ErrorHandlerE::checkFile(xmlfilename);
 	myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse(* (new SAX::InputSource(xmlfilename)));
}

SaveGameXmlAdapter::~SaveGameXmlAdapter()
{
  if(campaigns != NULL)
     delete [] campaigns;
  if(missions != NULL)
     delete [] missions;
  if(names != NULL)
     delete [] names;

}


void SaveGameXmlAdapter::startDocument()
{

}

void SaveGameXmlAdapter::endDocument()
{

}

void SaveGameXmlAdapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
  int i;

  if(name == "savegames")
  {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);

         if(currentname == "numsaves")
         {
            numsaves = atoi((char *) currentvalue.c_str());
            missions = new string[numsaves];
            names = new string[numsaves];
            campaigns = new string[numsaves];
         }         
      }
  }
  else if(name == "save")
  {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);

         if(currentname == "name")
         {
            names[lastname] = currentvalue;
            lastname++;
         }         
         else if(currentname == "campaign")
         {
            campaigns[lastcampaign] = currentvalue;
            lastcampaign++;
         }
         else if(currentname == "mission")
         {
            missions[lastmission] = currentvalue;
            lastmission++;
         }       
      }
  }
}


void SaveGameXmlAdapter::endElement(const std::string& name)
{

}

void SaveGameXmlAdapter::characters(const std::string& ch)
{

}

int SaveGameXmlAdapter::getNumSaves()
{
  return numsaves;
}

string * SaveGameXmlAdapter::getNames()
{
  return names;
}

string * SaveGameXmlAdapter::getMissions()
{
  return missions;
}

string * SaveGameXmlAdapter::getCampaigns()
{
  return campaigns;
}
