// SectorXmlAdapter.h: interface for the SectorXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SECTORXMLADAPTER_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_)
#define AFX_SECTORXMLADAPTER_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>

using namespace SAX;
using std::string;
#include <GL/glew.h>
#include "Texture.h"
#include "WorldOrientedBillboard.h"
#include "coord.h"
#include "Light.h"
#include "Color.h"

class SectorXmlAdapter : public HandlerBase  
{
public:
	Light * * getLights();
	int getNumLights();
	bool showStars();
	int getNumPlanets();
	Texture * getBackgroundTexture();
	WorldOrientedBillboard * * getPlanets();
	SectorXmlAdapter(char filename[]);
	virtual ~SectorXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   Texture * background;
   WorldOrientedBillboard * * planets; // array of billboard pointers
   Light * * lights;
   int numplanets;
   int numlights;
   Coordinate currentpoint;
   Color currentcolor;
   string texturename;
   int currentplanet;
   int currentlight;
   bool show_stars;
   float currentwidth;
   float currentheight;
};

#endif // !defined(AFX_SECTORXMLADAPTER_H__398A3BEE_5841_4164_92C1_48CDF0343B1D__INCLUDED_)
