// SeekBehavior.cpp: implementation of the SeekBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "SeekBehavior.h"
#include "CapitalShip.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
SeekBehavior SeekBehavior::instance;

SeekBehavior::SeekBehavior()
{

}

SeekBehavior::~SeekBehavior()
{

}

void SeekBehavior::move(Targetable * body, Targetable * target)
{
//  seek(body, target->getLocation() );

  steerTo(body, getSteeringVector(body, target) ); 
}

Coordinate SeekBehavior::seek(Targetable * body, Coordinate location)
{
  Coordinate desiredheading;

  desiredheading = location - body->getLocation();
  desiredheading.normalize();
  return desiredheading - body->getHeading();
}

Coordinate SeekBehavior::getSteeringVector(Targetable * body, Targetable *  target)
{
  Coordinate location; 

  if(target->instanceof(INST_CAPITALSHIP) )
  {
	int index;
	CapitalShip * capship = (CapitalShip *) target;
	index = body->getTargetedCapshipComponentIndex();
    location =  capship->getComponentLocation(index);
  }
  else
  {
    location = target->getLocation();
  }

  return seek(body,  location);
}
