// Settings.h: interface for the Settings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGS_H__8F96466F_885C_4902_8686_FFD1DBEF8ADA__INCLUDED_)
#define AFX_SETTINGS_H__8F96466F_885C_4902_8686_FFD1DBEF8ADA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class SettingsXmlAdapter;

#include <string>
using std::string;
#include "DisplayMode.h"

class Settings  
{
public:
	void setReflections(bool newreflect);
	bool getReflections();
	void setVSync(bool newsync);
	bool getVSync();
	void setAnisotropy(int newanisotropy);
	int getAnisotropy();
	void setTextureCompression(int newcompression);
	int getTextureCompression();
	bool getDynamicLights();
	void setDynamicLights(bool on);
	DisplayMode getDisplayMode();
	void forceSoundDisable();
	void setCockpitDetails(bool value);
	bool getCockpitDetails();
	void setShowCollisionSpheres(bool collision);
	bool getShowCollisionSpheres();
	void setNebula(bool newnebula);
	bool getNebula();
	void setMipMap(bool newmipmap);
	bool getMipMap();
	void setSound(bool newsound);
	bool getSound();
	void setMusic(bool newmusic);
	bool getMusic();
	void write();
	void setResolutionString(string newresolution);
	void setSmooth(bool newvalue);
	bool smooth();
	static Settings * getSettings();
	string getResolutionString();
	virtual ~Settings();
private:
	void computeDisplayMode();
   static Settings * settings;
	Settings();

   string resolution;
   bool shouldsmooth;
   bool music;
   bool sound;
   bool mipmap;
   bool nebula;
   bool collision_spheres;
   bool cockpitdetails;
   bool forcenosound;
   bool dynamiclights;
   DisplayMode displaymode;
   int texturecompression;
   int anisotropy;
   bool vsync;
   bool reflections;
};

#endif // !defined(AFX_SETTINGS_H__8F96466F_885C_4902_8686_FFD1DBEF8ADA__INCLUDED_)
