// SettingsPanel.h: interface for the SettingsPanel class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGSPANEL_H__66E74B7D_4083_402B_BC7F_1DC7F8FFF7F8__INCLUDED_)
#define AFX_SETTINGSPANEL_H__66E74B7D_4083_402B_BC7F_1DC7F8FFF7F8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Panel.h"
#include <string>
#include <vector>
#include "DisplayMode.h"

using std::string;

class SettingsPanel : public Panel  
{
public:
	virtual void onConfirm();
	virtual void onCancel();
	virtual void onLineClick(int linenumber);
	SettingsPanel();
	virtual ~SettingsPanel();
private:
	void reset();
   bool usettfont;
   bool smooth;
   bool music;
   bool sound;
   bool mipmap;
   bool nebula;
   string resolution;
   int displayindex;
   string joystick;
   string force;
   std::vector<DisplayMode> modes;
   bool cockpitdetails;
   bool dynamiclights;
   int texturecompression;
   int anisotropy;
   bool vsync;
   bool reflections;

};

#endif // !defined(AFX_SETTINGSPANEL_H__66E74B7D_4083_402B_BC7F_1DC7F8FFF7F8__INCLUDED_)
