// SettingsXmlAdapter.cpp: implementation of the SettingsXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#include "SettingsXmlAdapter.h"
#include "saxexpat.h"
#include "InputSource.h"
#include "AttributeList.h"
#include "ErrorHandlerE.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SettingsXmlAdapter::SettingsXmlAdapter(char xmlfilename[])
{
	expat myParser;

   ErrorHandlerE::checkFile(xmlfilename);
   smooth = true;
   nebula = true;
	myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse(* (new SAX::InputSource(xmlfilename)));

}

SettingsXmlAdapter::~SettingsXmlAdapter()
{

}

void SettingsXmlAdapter::startDocument()
{

}

void SettingsXmlAdapter::endDocument()
{

}

void SettingsXmlAdapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
  int i;

  if(name == "settings")
  {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         
         if(currentname == "resolution")
         {
           resolution = currentvalue;
         }
         else if(currentname == "smooth")
         {
            if(currentvalue == "true")
            {
              smooth = true;
            }
            else
            {
              smooth = false;
            }
         }
         else if(currentname == "music")
         {
            if(currentvalue == "true")
            {
              music = true;
            }
            else
            {
              music = false;
            }       

         }
         else if(currentname == "sound")
         {
            if(currentvalue == "true")
            {
              sound = true;
            }
            else
            {
              sound = false;
            }       

         }
         else if(currentname == "vsync")
         {
            if(currentvalue == "true")
            {
              vsync = true;
            }
            else
            {
              vsync = false;
            }       

         }
         else if(currentname == "reflections")
         {
            if(currentvalue == "true")
            {
              reflections = true;
            }
            else
            {
              reflections = false;
            }       

         }
         else if(currentname == "mipmap")
         {
            if(currentvalue == "true")
            {
              mipmap = true;
            }
            else
            {
              mipmap = false;
            }       

         }
         else if(currentname == "nebula")
         {
            if(currentvalue == "true")
            {
              nebula = true;
            }
            else
            {
              nebula = false;
            }       

         }
         else if(currentname == "cockpitdetails")
         {
            if(currentvalue == "true")
            {
              cockpitdetails = true;
            }
            else
            {
              cockpitdetails = false;
            }       

         }
         else if(currentname == "dynamiclights")
         {
            if(currentvalue == "true")
            {
              dynamiclights = true;
            }
            else
            {
              dynamiclights = false;
            }       
         }         
		 else if(currentname == "texturecompression")
		 {
		    texturecompression = atoi(currentvalue.c_str() );	
		 }
		 else if(currentname == "anisotropy")
		 {
		    anisotropy = atoi(currentvalue.c_str() );	
		 }
		 
      }
  }
}


void SettingsXmlAdapter::endElement(const std::string& name)
{

}

void SettingsXmlAdapter::characters(const std::string& ch)
{

}

string SettingsXmlAdapter::getResolution()
{
  return resolution;
}

bool SettingsXmlAdapter::shouldSmooth()
{
  return smooth;
}

bool SettingsXmlAdapter::getMusic()
{
  return music;
}

bool SettingsXmlAdapter::getSound()
{
  return sound;
}

bool SettingsXmlAdapter::getMipMap()
{
  return mipmap;
}

bool SettingsXmlAdapter::getNebula()
{
  return nebula;
}

bool SettingsXmlAdapter::getCockpitDetails()
{
  return cockpitdetails;
}

bool SettingsXmlAdapter::getDynamicLights()
{
  return dynamiclights;
}

int SettingsXmlAdapter::getTextureCompression()
{
  return texturecompression;
}

int SettingsXmlAdapter::getAnisotropy()
{
  return anisotropy;
}

bool SettingsXmlAdapter::getVSync()
{
  return vsync;
}

bool SettingsXmlAdapter::getReflections()
{
  return reflections;
}
