// SettingsXmlAdapter.h: interface for the SettingsXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGSXMLADAPTER_H__659F1113_1406_497F_9F94_959B2C2CF6C3__INCLUDED_)
#define AFX_SETTINGSXMLADAPTER_H__659F1113_1406_497F_9F94_959B2C2CF6C3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>

using namespace SAX;
using std::string;

class SettingsXmlAdapter  : public HandlerBase
{
public:
	bool getReflections();
	bool getVSync();
	int getAnisotropy();
	int getTextureCompression();
	bool getDynamicLights();
	bool getCockpitDetails();
	bool getNebula();
	bool getMipMap();
	bool getSound();
	bool getMusic();
	bool shouldSmooth();
	string getResolution();
	SettingsXmlAdapter(char filename[]);
	virtual ~SettingsXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   bool smooth;
	string resolution;
   bool music;
   bool sound;
   bool mipmap;
   bool nebula;
   bool cockpitdetails;
   bool dynamiclights;
   int texturecompression;
   int anisotropy;
   bool vsync;
   bool reflections;
};

#endif // !defined(AFX_SETTINGSXMLADAPTER_H__659F1113_1406_497F_9F94_959B2C2CF6C3__INCLUDED_)
