// Shader.h: interface for the Shader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHADER_H__3A9DA083_3A4B_4E4B_9707_585A47F6639A__INCLUDED_)
#define AFX_SHADER_H__3A9DA083_3A4B_4E4B_9707_585A47F6639A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
#include "gl/glew.h"

class Shader  
{
public:
	void sendUniform4f(char* varname, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
	void end();
	void begin();
	Shader(std::string vertexfile, std::string fragmentfile);
	virtual ~Shader();
private:
	std::string getCompileLog(GLhandleARB handle);
	void compile(GLhandleARB handle, std::string text);
	void fileToString(std::string filename, std::string & newstring);
    GLhandleARB vertexprogram;
	GLhandleARB fragmentprogram;
	GLenum my_program;
};

#endif // !defined(AFX_SHADER_H__3A9DA083_3A4B_4E4B_9707_585A47F6639A__INCLUDED_)
