// ShipInfo.cpp: implementation of the ShipInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "ShipInfo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ShipInfo::ShipInfo():
  survive(false),
  land(false),
  lastautopilotnav(-1)
{

}


ShipInfo::ShipInfo(string newfilename, string newpilot, bool newautopilot, IffCode newiffcode,
				   int newlastautopilot)
  : filename(newfilename),
    pilot(newpilot),
    autopilot(newautopilot),
    iffcode(newiffcode),
    survive(false),
    land(false),
	lastautopilotnav(newlastautopilot)

{

}

ShipInfo::~ShipInfo()
{

}

string ShipInfo::getPilot()
{
  return pilot;
}

string ShipInfo::getFileName()
{
  return filename;
}

IffCode ShipInfo::getIffCode()
{
  return iffcode;
}

Coordinate ShipInfo::getStartingLocation()
{
  return startinglocation;
}

bool ShipInfo::getAutoPilot()
{
  return autopilot;
}

void ShipInfo::setStartingLocation(Coordinate location)
{
  startinglocation = location;
}

void ShipInfo::setAutoPilot(bool autop)
{
  autopilot = autop;
}


void ShipInfo::setPilot(string newpilot)
{
  pilot = newpilot;
}

void ShipInfo::setIffCode(IffCode newiff)
{
  iffcode = newiff;
}

void ShipInfo::setFileName(string newfilename)
{
   filename = newfilename + string(".ship.xml");
}

void ShipInfo::setLand(bool newland)
{
  land = newland;
}

bool ShipInfo::getLand()
{
  return land;
}

bool ShipInfo::getMustSurvive()
{
  return survive;
}

void ShipInfo::setMustSurvive(bool value)
{
  survive = value;
}

void ShipInfo::setComm(string newcomm)
{
  comm = newcomm;
}

string ShipInfo::getComm()
{
  return comm;
}

void ShipInfo::setVideo(string newvideo)
{
  video = newvideo;
}

string ShipInfo::getVideo()
{
  return video;
}

int ShipInfo::getLastAutopilot()
{
  return lastautopilotnav;
}

void ShipInfo::setLastAutopilotNav(int newlast)
{
	lastautopilotnav = newlast;
}
