// ShipInfo.h: interface for the ShipInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHIPINFO_H__B2378B62_D301_4C1A_B3A6_BF8ADD8755E2__INCLUDED_)
#define AFX_SHIPINFO_H__B2378B62_D301_4C1A_B3A6_BF8ADD8755E2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
#include "IffCode.h"
#include "coord.h"

using std::string;

class ShipInfo  
{
public:
	void setLastAutopilotNav(int newlast);
	int getLastAutopilot();
	string getVideo();
	void setVideo(string newvideo);
	string getComm();
	void setComm(string comm);
	void setMustSurvive(bool value);
	bool getMustSurvive();
	bool getLand();
	void setLand(bool newland);
	void setFileName(string filename);
	void setIffCode(IffCode newiff);
	void setPilot(string pilot);
	 ShipInfo();
	void setAutoPilot(bool auto);
	void setStartingLocation(Coordinate location);
	bool getAutoPilot();
	Coordinate getStartingLocation();
	IffCode getIffCode();
	string getFileName();
	string getPilot();
	ShipInfo(string newfilename, string newpilot, bool autopilot, IffCode newiffcode,
		int lastautopilotnav);
	virtual ~ShipInfo();
private:
   string filename;
   string comm;
   string video;
   bool autopilot;
   int lastautopilotnav;
   string pilot;
   IffCode iffcode;
   Coordinate startinglocation;
   bool land;
   bool survive;
};

#endif // !defined(AFX_SHIPINFO_H__B2378B62_D301_4C1A_B3A6_BF8ADD8755E2__INCLUDED_)
