// SoundEffect.h: interface for the SoundEffect class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDEFFECT_H__5862FED9_257C_4329_A28D_9D839EE75B05__INCLUDED_)
#define AFX_SOUNDEFFECT_H__5862FED9_257C_4329_A28D_9D839EE75B05__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifdef HAS_BASS
#include "bass.h"
#endif

#ifdef HAS_FMOD
#include "fmod.h"
#endif

class SoundEffect  
{
public:
	void setLoop(bool newloop);
	virtual void stop();
	bool isPlaying();
	virtual void play();
	SoundEffect(char filename[]);
	virtual ~SoundEffect();
protected:
	SoundEffect(){} // for null sound effect
private:
#ifdef HAS_BASS
   HSAMPLE sam;
   HCHANNEL channel;
#endif /* bass */
#ifdef HAS_FMOD
  FSOUND_SAMPLE * sam;
  int channel;
#endif
   bool loop;

};

#endif // !defined(AFX_SOUNDEFFECT_H__5862FED9_257C_4329_A28D_9D839EE75B05__INCLUDED_)
