// SoundFactory.h: interface for the SoundFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDFACTORY_H__79868138_9C9A_4DFD_AA45_54F58079084A__INCLUDED_)
#define AFX_SOUNDFACTORY_H__79868138_9C9A_4DFD_AA45_54F58079084A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "SoundEffect.h"
#include "PlayerComm.h"
#include "WingmanComm.h"
#include "HashTable.h"
#include "SoundObject3d.h"

#include <list>

class SoundEffect3d;
class SoundSample3d;

#define NUM_CHARGESOUNDS 4

class SoundFactory  
{
public:
	SoundEffect * getEjectAlertSound();
	SoundEffect * getTractorBeamSound();
	SoundEffect * getMissileAlertSound();
	SoundEffect3d * getDecoySound();
	SoundEffect * getChargeSound(int index);
	void clear();
	SoundEffect * getTakeoffSound();
	SoundEffect3d * getAfterburnerSound();
	void advance();
	SoundEffect * getBeepSound();
	SoundObject3d * getListener();
	SoundEffect3d * getMissileExplodeSound();
	PlayerComm * getPlayerComm(char name[]);
	SoundEffect * getMissileChangeSound();
	SoundEffect * getGunChangeSound();
	void refresh();
	SoundEffect * getLandingSound();
	SoundEffect * getLockSound();
	SoundEffect * getAutoPilotSound();
	SoundEffect3d * getMissileSound(int index);
	SoundEffect3d * getExplosionSound();
	SoundEffect3d * getArmorSound();
	SoundEffect3d * getShieldSound();
	SoundEffect3d * getWeaponSound(int index);
	static SoundFactory * getSoundFactory();

	virtual ~SoundFactory();
private:
	SoundEffect3d * createSoundEffect(SoundSample3d * soundsample);
	SoundFactory();
   static SoundFactory * factory;
   SoundSample3d * shieldsound;
   SoundSample3d * armorsound;
   int numweaponsounds;
   SoundSample3d * * weaponsounds;
   int nummissilesounds;
   SoundSample3d * * missilesounds;
   SoundSample3d * explosionsound;
   SoundSample3d * decoysound;
   SoundSample3d * afterburnersound;
   SoundEffect * autopilotsound;
   SoundEffect * locksound;
   SoundEffect * landingsound;
   SoundEffect * takeoffsound;
   SoundEffect * gunchange;
   SoundEffect * missilechange;
   SoundEffect * missilealert;
   SoundEffect * ejectalert;
   SoundSample3d * missile_explode;
   bool inited;
   SoundEffect * chargesounds[NUM_CHARGESOUNDS];
   SoundObject3d * listener;
   SoundEffect * beep;
   SoundEffect * tractorbeam;
   std::list<SoundEffect3d *>  * garbage;
   SoundEffect3d * regsiterEffect(SoundEffect3d * effect);
   bool sound3d;
};

#endif // !defined(AFX_SOUNDFACTORY_H__79868138_9C9A_4DFD_AA45_54F58079084A__INCLUDED_)
