// SoundObject3d.h: interface for the SoundObject3d class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDOBJECT3D_H__6259A226_4F37_47EE_9171_1CE343BC6548__INCLUDED_)
#define AFX_SOUNDOBJECT3D_H__6259A226_4F37_47EE_9171_1CE343BC6548__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "coord.h"
#ifdef HAS_BASS
#include "bass.h"
#endif

class SoundObject3d  
{
public:
	virtual void setPosition(Coordinate coord);
	virtual void setHeading(Coordinate coord);
	virtual void setVelocity(Coordinate coord);
	virtual void setUp(Coordinate coord);
	virtual void render()=0;
    virtual ~SoundObject3d();
protected:
#ifdef HAS_BASS
	BASS_3DVECTOR toBass(Coordinate coord);
    void fillInBass(BASS_3DVECTOR & basspos, BASS_3DVECTOR & bassheading, BASS_3DVECTOR & bassvel);
#endif /* bass */
    SoundObject3d();
    Coordinate position, velocity, heading, up;

	
};

#endif // !defined(AFX_SOUNDOBJECT3D_H__6259A226_4F37_47EE_9171_1CE343BC6548__INCLUDED_)
