// SoundSample3d.cpp: implementation of the SoundSample3d class.
//
//////////////////////////////////////////////////////////////////////

#include "SoundSample3d.h"
#include "Settings.h"
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SoundSample3d::SoundSample3d(char filename[], bool support3d)
{
#ifdef HAS_BASS
   const int num_simultaneous = 10;
   if(! Settings::getSettings()->getSound() )
   {
	  sam = NULL;
      return;
   }

   if(support3d)
   {
     sam= (HSAMPLE) BASS_SampleLoad(FALSE,filename,0,0,num_simultaneous,
	     BASS_SAMPLE_OVER_POS | BASS_SAMPLE_3D);
   }
   else
   {
     sam= (HSAMPLE) BASS_SampleLoad(FALSE,filename,0,0,num_simultaneous,
         BASS_SAMPLE_OVER_POS);
   }
   if(! sam)
   {
        cout << "Could not load sample " << filename << endl;
   }
#endif

#ifdef HAS_FMOD
   if(! Settings::getSettings()->getSound() )
   {
	  sample = NULL;
      return;
   }
   if(support3d)
   {
     sample = FSOUND_Sample_Load(FSOUND_FREE , filename, FSOUND_HW3D, 0, 0);	
   }
   else
   {
     sample = FSOUND_Sample_Load(FSOUND_FREE , filename, 0, 0, 0);	
   }

#endif

}

SoundSample3d::~SoundSample3d()
{
#ifdef HAS_BASS
  if(! Settings::getSettings()->getSound() )
  {
      return;
  }

  BASS_SampleFree(sam);
#endif
#ifdef HAS_FMOD
  FSOUND_Sample_Free(sample);
#endif

}

#ifdef HAS_BASS
HSAMPLE SoundSample3d::getHSAMPLE()
{
  return sam;
}

#endif

#ifdef HAS_FMOD
FSOUND_SAMPLE * SoundSample3d::getSample()
{
	return sample;
}

#endif
