// SoundsXmlAdapter.cpp: implementation of the SoundsXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#include "SoundsXmlAdapter.h"
#include "saxexpat.h"
#include "InputSource.h"
#include "AttributeList.h"
#include "ErrorHandlerE.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SoundsXmlAdapter::SoundsXmlAdapter()
  //: weaponsounds(NULL),
//    numweaponsounds(0),
//    currentweaponsound(0)
{
	expat myParser;
   char xmlfilename[] = "sounds.xml";
   inmissilesounds = false;
   inweaponsounds = false;


   ErrorHandlerE::checkFile(xmlfilename);
	myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse(*(new SAX::InputSource(xmlfilename)));
}

SoundsXmlAdapter::~SoundsXmlAdapter()
{
//  delete [] weaponsounds;
}

void SoundsXmlAdapter::startDocument()
{

}

void SoundsXmlAdapter::endDocument()
{

}

void SoundsXmlAdapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
   int i;

   if(name == "sound")
   {
      for(i=0; i < atts->getLength(); i++)
      {      
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "name")
         {
            currentsound = currentvalue;
            if(inweaponsounds)
            {
			   weaponsounds.push_back(currentsound);
            }
			else if(inmissilesounds)
			{
				missilesounds.push_back(currentsound);
			}
         }
      }
   }
   else if(name == "weaponsounds")
   {
	 inweaponsounds = true;
	 inmissilesounds = false;
   }
   else if(name == "missilesounds")
   {
	 inweaponsounds = false;
	 inmissilesounds = true;
   }

}

void SoundsXmlAdapter::endElement(const std::string& name)
{
   if(name == "armorsound")
   {
      armorsound = currentsound;
   }
   else if(name == "shieldsound")
   {
      shieldsound = currentsound;
   }
   else if(name == "explosionsound")
   {
      explosionsound = currentsound;
   }
}


void SoundsXmlAdapter::characters(const std::string& ch)
{

}

int SoundsXmlAdapter::getNumWeaponSounds()
{
  return weaponsounds.size();
}

string SoundsXmlAdapter::getWeaponSound(int number)
{
  return weaponsounds[number];
}

string SoundsXmlAdapter::getArmorSound()
{
  return armorsound;
}

string SoundsXmlAdapter::getShieldSound()
{
  return shieldsound;
}

string SoundsXmlAdapter::getExplosionSound()
{
  return explosionsound;
}

string SoundsXmlAdapter::getMissileSound(int index)
{
  return missilesounds[index];
}

int SoundsXmlAdapter::getNumMissileSounds()
{
  return missilesounds.size();
}
