// SoundsXmlAdapter.h: interface for the SoundsXmlAdapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDSXMLADAPTER_H__5D4D0B64_6C9F_4480_BD17_8B3214712FD2__INCLUDED_)
#define AFX_SOUNDSXMLADAPTER_H__5D4D0B64_6C9F_4480_BD17_8B3214712FD2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include <string>
#include <vector>

using std::string;
using namespace SAX;

#pragma warning( disable : 4786)

class SoundsXmlAdapter  : public HandlerBase
{
public:
	int getNumMissileSounds();
	string getMissileSound(int index);
	string getExplosionSound();
	string getShieldSound();
	string getArmorSound();
	string getWeaponSound(int number);
	int getNumWeaponSounds();
	SoundsXmlAdapter();
	virtual ~SoundsXmlAdapter();
   virtual void startDocument();
	virtual void endDocument();

	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   string armorsound;
   string shieldsound;
   bool inweaponsounds;
   bool inmissilesounds;
   string currentsound;
   string explosionsound;
   std::vector<std::string> weaponsounds;
   std::vector<std::string> missilesounds;
};

#endif // !defined(AFX_SOUNDSXMLADAPTER_H__5D4D0B64_6C9F_4480_BD17_8B3214712FD2__INCLUDED_)
