// SplashScreen.cpp: implementation of the SplashScreen class.
//
//////////////////////////////////////////////////////////////////////

#include <GL/glew.h>
#include "SplashScreen.h"
#include "glut.h"
#include "ImageFactory.h"
#include "Image.h"
#include "GameFlow.h"
#include "MusicFactory.h"
#include "TextToSpeech.h"
#include "SoundFactory.h"
#include "glerr.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SplashScreen::SplashScreen()
{
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  glDisable(GL_LIGHTING);

//  image = ImageFactory::getImage("splashscreen.bmp", 640, 480);
  image = ImageFactory::getImage("splashscreen.jpg", 640, 480);
  // pre allocate gameflow
  gameflow = new GameFlow();

  SoundFactory::getSoundFactory();
  music = MusicFactory::getMusicFactory()->getMusic("openingtheme.mp3", false);
  music->play();


}

SplashScreen::~SplashScreen()
{

}

void SplashScreen::onDisplay()
{
   float 	winWidth ,winHeight;

	winWidth = 640;
	winHeight = 480;

    glMatrixMode (GL_PROJECTION);
    glPushMatrix();//1
    glLoadIdentity ();
	  
    gluOrtho2D(-0.01f, winWidth + 0.01f, 0.0f, winHeight);

    glMatrixMode (GL_MODELVIEW);
    glPushMatrix();//2
    glLoadIdentity ();

    image->render(0.0f, 0.0f);

	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
    glFlush ();
    glutSwapBuffers();
	GLERRORCHECK
}

void SplashScreen::onKeyboard(unsigned char key, int x, int y)
{
  if(music->isPlaying() )
  {
    music->stop();
  }
  delete music;
  delete image;
  setEventListener(gameflow );
}

void SplashScreen::onMouseDown(int button, int state, int x, int y)
{
  if(state == GLUT_UP)
  {
	if(music->isPlaying() )
	{
	  music->stop();
	}
	delete music;
	delete image;
	setEventListener(gameflow );
  }
}
