// StarField.h: interface for the StarField class.
//
//////////////////////////////////////////////////////////////////////

#ifndef STARFIELD_H
#define STARFIELD_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "coord.h"
#include "Object3d.h"

class mesh;
class Texture;

class StarField  : public Object3d
{
public:
	virtual void advance();
	virtual void render();
	StarField(int nnumstars, Texture * backgroundtexture, bool new_show_stars);
	virtual ~StarField();
private:
   bool show_stars;
   float advancez;
	void fillrandom();
	int numstars;
   float viewradius;
   Coordinate * coords;
   Texture * planet;
   GLUquadricObj * quadric;
   Texture * nebula;
   float sizemultiplier;
};

#endif // !defined(AFX_STARFIELD_H__F900E341_1B8D_11D3_922B_58B502C10627__INCLUDED_)
