// Targetable.h: interface for the Targetable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TARGETABLE_H__D14B2018_58A3_463C_BDE6_17FE937C86E5__INCLUDED_)
#define AFX_TARGETABLE_H__D14B2018_58A3_463C_BDE6_17FE937C86E5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Object3d.h"
#include "shipareas.h"	// Added by ClassView
#include <string>
#include "Image.h"
#include "shipareas.h"
#include "Color.h"	// Added by ClassView
#include "ReticleSquare.h"
using std::string;
#include "coord.h"

class ship;
class AIBehavior;
class PositionHistory;

class Targetable : public Object3d  
{
public:
	virtual bool instanceof(InstanceT it);
	void setTargetedComponent(int index);
	virtual void setTarget(Targetable * targetable);
	int getTargetedCapshipComponentIndex();
	ReticleSquare getReticleSquare();
	virtual void targetDestroyed()=0;
	virtual void render();
	 Targetable(Targetable & that);
	bool hasAI();
	virtual Targetable * getTarget()=0;
	void setAI(AIBehavior * ai);
	virtual bool instanceof(char classname[]);
	virtual void advance();
//	virtual bool isShip();
	virtual Color getRadarColor(ship * player)=0;
	string getName();
	Image * getImage();
	shipareas getShields();
	shipareas getArmor();
   Targetable(mesh * newmesh,  
        shipareas newshields, shipareas newarmor,
        float newvelocity, float newroll, float newpitch, float newyaw, 
	    float newacceleration, float newangular_acceleration,
        Image * newimage, string newname);

   Targetable(mesh * newmesh,  Coordinate location, Coordinate heading, Coordinate up, Coordinate left,
        shipareas newshields, shipareas newarmor,
        float newvelocity, float newroll, float newpitch, float newyaw, 
	    float newacceleration, float newangular_acceleration,
        Image * newimage, string newname);


	virtual ~Targetable();
protected:
	ReticleSquare calculateRectangle(Coordinate center, Coordinate extents);
    shipareas shields;
    shipareas armor;
	virtual void calculateRectangle();
    int targeted_component;
    Targetable * target;
	PositionHistory * history;
private:
	void drawHistory();
	void initHistory();
	void advancePositionRecord();
	void renderSphere();
    void renderBox();
    Image * image;
    string name;
    AIBehavior * ai;
    ReticleSquare square;
};

#endif // !defined(AFX_TARGETABLE_H__D14B2018_58A3_463C_BDE6_17FE937C86E5__INCLUDED_)
