// TextOverlay.cpp: implementation of the TextOverlay class.
//
//////////////////////////////////////////////////////////////////////

#include <GL/glew.h>
#include "glut.h"
#include "TextOverlay.h"
#include "Color.h"
#include "Font.h"
#include "FontFactory.h"
#include "glerr.h"



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TextOverlay * TextOverlay::instance = NULL;

TextOverlay::TextOverlay()
{
  enabled = false;
}

TextOverlay::~TextOverlay()
{

}

void TextOverlay::render()
{
   float winWidth, winHeight;
   Font * font;
   float charwidth, charheight;
   float bordersizex, bordersizey;

   glDisable(GL_TEXTURE_2D);
   glDisable(GL_DEPTH_TEST);
   glDisable(GL_CULL_FACE);
   glDisable(GL_LIGHTING);

//	float radarWidth;
//	float radarHeight;

//   glClear (GL_DEPTH_BUFFER_BIT);
	winWidth = glutGet(GLUT_WINDOW_WIDTH);
	winHeight = glutGet(GLUT_WINDOW_HEIGHT);
	bordersizex = winWidth * .05f;
	bordersizey = winHeight * .05f;

    glMatrixMode (GL_PROJECTION);
    glPushMatrix();//1
    glLoadIdentity ();

    gluOrtho2D(-0.01f, winWidth + 0.01f, 0.0f, winHeight);

    glMatrixMode (GL_MODELVIEW);
	 glPushMatrix();//2
    glLoadIdentity ();

   if(winWidth > 800.0f)
   {
     font = FontFactory::getInstance().getLargeFont();
   }
   else
   {
     font = FontFactory::getInstance().getFont();
   }
   charheight = font->getHeight("JMI");
   charwidth = font->getWidth("W");


/// do rendefing
   glEnable(GL_BLEND);
   
   glColor4f(0.2f, 0.0f, .8f, .5f);
   glRectf(bordersizex, bordersizey, winWidth - bordersizex,  5.5f * charheight);  

   glDisable(GL_BLEND);


   glColor3f(1.0f, 1.0f, 1.0f);
   
//   text[1] = "line 1";
//   text[2] = "line 2";
   // fix a coloring bug. Apparently the second print works fine 
   font->print(bordersizex + charwidth, bordersizey + charheight * .5f, " " );
   font->print(bordersizex + charwidth, bordersizey + charheight * .5f, (char *) text[2].c_str() );
   font->print(bordersizex + charwidth, bordersizey + charheight * 1.5f, (char *) text[1].c_str() );
   font->print(bordersizex + charwidth, bordersizey + charheight * 2.5f, (char *) text[0].c_str() );


   // clean up
   glPopMatrix();
   glMatrixMode(GL_PROJECTION);
   glPopMatrix();
   glMatrixMode(GL_MODELVIEW);
   glEnable(GL_TEXTURE_2D);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_CULL_FACE);
   glEnable(GL_LIGHTING);
   GLERRORCHECK


}

void TextOverlay::setText(std::string newtext)
{
  char * temp;
  temp = new char[newtext.length() + 1];
  char * token;
  int i;

  strcpy(temp, (char *) newtext.c_str() );
  token = strtok( temp, "\n");

  i=0;
  while( token != NULL && i < TEXTOVERLAY_NUMLINES)
  {
    text[i] = token;
	i++;
    token = strtok(NULL, "\n");
  }
  for(; i < 3; i++)
  {
	text[i] = "";
  }
  delete temp;
}

TextOverlay * TextOverlay::getInstance()
{
   if(instance == NULL)
   {
	  instance = new TextOverlay();
   }
   return instance;
}

bool TextOverlay::isEnabled()
{
  return enabled;
}

void TextOverlay::setEnabled(bool newenabled)
{
  enabled = newenabled;
}
