// TextPanel.cpp: implementation of the TextPanel class.
//
//////////////////////////////////////////////////////////////////////

#include "TextPanel.h"
#include "ImageFactory.h"
#include "FontFactory.h"
#include "Image.h"
#include "Font.h"
#include <vector>
#include <string>
#include "MessageXmlAdapter.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TextPanel::TextPanel()
{
  messageadapter = NULL;
  bgimage = ImageFactory::getImage("computerscreen.jpg", 640, 480);
  font = FontFactory::getInstance().getFont();
  exitrect = Rect(567, 436, 54, 29);
  nextrect = Rect(41, 447, 17, 17);
  prevrect = Rect(22, 447, 16, 16);
  currentmessage = 0;
}

TextPanel::~TextPanel()
{

}


void TextPanel::onDisplay()
{
  float rasterx = 25.0f;
  float rastery = 30.0f;
  int i;

  bgimage->render(0.0f, 0.0f);
  int height = font->getHeight("WJ");
  if(messageadapter->messages.size() == 0)
  {
    font->print((float)(rasterx), (float) (480 - rastery), (char *) "No messages");  
  }
  else
  {
    Message mymessage = messageadapter->messages[currentmessage];
    for(i=0; i < mymessage.lines.size() ; i++)
	{
    	if(mymessage.colored[i])
		{
			glColor3f(.18f, .71f, .69f);
		}
		else
		{
			glColor3f(1.0f, 1.0f, 1.0f);
		}	
		font->print((float)(rasterx), (float) (480 - rastery), (char *) mymessage.lines[i].c_str() );  
		rastery += height ;
	}

    rasterx = 62.0f;
	rastery = 460.0f;
	glColor3f(.18f, .71f, .69f);
	char buffer[100];

    sprintf(buffer, "Message %d of %d", currentmessage + 1, messageadapter->messages.size() );
	font->print((float)(rasterx), (float) (480 - rastery), buffer );  
  }
  
}



bool TextPanel::onMouseDown(int button, int state, int x, int y)
{
	if(exitrect.inside(x, y) )
	{
	  return true;
	}
	else if(nextrect.inside(x, y) )
	{
		currentmessage ++;
		if(currentmessage >= messageadapter->messages.size() )
		{
		  currentmessage = 0;
		}
	}
	else if(prevrect.inside(x, y) )
	{
		currentmessage --;
		if(currentmessage < 0 )
		{
		  currentmessage = messageadapter->messages.size() - 1;
		}
	}
	return false;

}


bool TextPanel::onKeyboard(unsigned char key, int x, int y)
{
  return false;
}

void TextPanel::setMessageFile(char filename [ ])
{
  if(messageadapter != NULL)
  {
	delete messageadapter;
  }
  messageadapter = new MessageXmlAdapter(filename);
  currentmessage = 0;

}
