// TextToSpeech.cpp: implementation of the TextToSpeech class.
//
//////////////////////////////////////////////////////////////////////

#include "TextToSpeech.h"
//#include <stdlib.h>
#ifdef WIN32
#include <process.h>
#endif
#include <string>
#include "SoundFactory.h"
#include <stdio.h>
#include "NullSoundEffect.h"
#include <iostream.h>


TextToSpeech TextToSpeech::instance;

using std::string;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TextToSpeech::TextToSpeech()
{
  ispossible = true; // for createFile
  ispossible = isPossibleTest();
  if(ispossible)
  {
	 cout << "Text to speech engine found." << endl;
  }
  else
  {
	 cout << "Text to speech not available" << endl;
  }
}

TextToSpeech::~TextToSpeech()
{

}

TextToSpeech * TextToSpeech::getInstance()
{
  return & instance;
}

void TextToSpeech::createFile(char filename [ ], char text [ ])
{
  if(ispossible)
  {
#ifdef WIN32
	string newstring = string("\"") + string(text) + string("\"");
	int result =  _spawnl(_P_WAIT, "t2w", "t2w", filename, newstring.c_str() , NULL );
#endif
  }

}

SoundEffect * TextToSpeech::synthesizeAndPlay(char text [ ])
{
  if(ispossible)
  {
    createFile("speechout.wav", text);
    SoundFactory::getSoundFactory();
    SoundEffect * effect = new SoundEffect("speechout.wav");
    effect->play();
    return effect;
  }
  else
  {
	  return & NullSoundEffect::instance;
  }
}

SoundEffect * TextToSpeech::synthesize(char text [ ], char filename [ ])
{
  if(ispossible)
  {
    createFile(filename, text);
    SoundFactory::getSoundFactory();
    SoundEffect * effect = new SoundEffect(filename);
    return effect;
  }
  else
  {
    return & NullSoundEffect::instance;
  }
}

bool TextToSpeech::isPossibleTest()
{
  bool result;
  createFile("temp.wav", "text");

  FILE * testfile = fopen("temp.wav", "rb");
  result =  testfile != NULL;
  if(testfile != NULL)
  {
    fclose(testfile);
#ifdef WIN32
	DeleteFile("temp.wav");
#endif
  }
  return result;
}
