// TextureFactory.h: interface for the TextureFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TEXTUREFACTORY_H__CDA89EAF_11F0_4FF5_82E5_CBD9BEC520E3__INCLUDED_)
#define AFX_TEXTUREFACTORY_H__CDA89EAF_11F0_4FF5_82E5_CBD9BEC520E3__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Texture.h"
#include "Color.h"
#include "HashTable.h"

class BMPFile;

class TextureFactory  
{
public:
	static int getMaxAnisotropy();
	static int getMaxTextureCompression();
	static Texture * getTransparentTextureAveraged(char filename[]);
	static Texture * getTransparentTexture(char filename[]);
	/** if the image already has an alpha channel, ignore transparentcolor, and use the alpha channel */
	static Texture * getTransparentTexture(char filename[], Color transparentcolor);
	static void clear();
	static Texture * getTexture(char filename[]);
private:
   static int numtextures;
   static int maxcompression;
   static int maxanisotropy;
   static Texture * garbage[800];
   static HashTable hashtable;
};

#endif // !defined(AFX_TEXTUREFACTORY_H__CDA89EAF_11F0_4FF5_82E5_CBD9BEC520E3__INCLUDED_)
