// TextureImpl.h: interface for the TextureImpl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TEXTUREIMPL_H__65813883_6CCC_4E8D_AAFF_9049E9B0C387__INCLUDED_)
#define AFX_TEXTUREIMPL_H__65813883_6CCC_4E8D_AAFF_9049E9B0C387__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Texture.h"
#include <GL/glew.h>


class TextureImpl  : public Texture
{
public:
	virtual int getHeight();
	virtual int getWidth();
	void recycle(GLubyte * bits, int width, int height);
	 TextureImpl(GLuint display_list);
	TextureImpl(GLubyte * bits, int width, int height);
	virtual ~TextureImpl();
   virtual void render();
protected:
	TextureImpl(int nwidth, int nheight);
    GLuint mydisplaylist;
	void checkPowerOfTwo(int number);
    void create(GLubyte * bits, int width, int height, GLenum format, 
		GLenum compressedformat, GLenum s3tccompressedformat, int channels);
	GLenum selectInternalFormat(GLenum format,  GLenum compressedformat, GLenum s3tccompressedformat);
private:

    void create(GLubyte * bits, int width, int height);
	int width, height;


};


#endif // !defined(AFX_TEXTUREIMPL_H__65813883_6CCC_4E8D_AAFF_9049E9B0C387__INCLUDED_)
