// TextureMovieImpl.cpp: implementation of the TextureMovieImpl class.
//
//////////////////////////////////////////////////////////////////////

#include "Time.h"
#include "TextureMovieImpl.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TextureMovieImpl::TextureMovieImpl(Texture ** newtextures, int newnumframes, float newframe_per_second)
{
  textures = newtextures;
  numframes = newnumframes;
  framespersecond = newframe_per_second;
  starttime = 0;
}

TextureMovieImpl::~TextureMovieImpl()
{

}

void TextureMovieImpl::start()
{
	starttime = Time::getCurrentTime();
}

void TextureMovieImpl::render()
{
  TimeValue now = Time::getCurrentTime();
  TimeValue elapsed = now - starttime;
  
  // frames / second * 1 second / 1000 millseconds * elapsed milliseconds = frame
  int index = (framespersecond * .001f) * elapsed; 
  index = (index >= numframes) ? numframes - 1 : index;
  textures[index]->render();
}

bool TextureMovieImpl::isFinished()
{
  return false;
}
