// Thruster.cpp: implementation of the Thruster class.
//
//////////////////////////////////////////////////////////////////////

#include "Thruster.h"
#include <glut.h>
#include "TextureFactory.h"
#include <stdlib.h>
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Texture * Thruster::texture = NULL;
Texture * Thruster::texture2 = NULL;

Thruster::Thruster(Coordinate newlocation, float newradius, float newlength)
  : location(newlocation), 
    radius(newradius),
    length(newlength)
{
  if(texture == NULL)
  {
     texture = TextureFactory::getTexture("thruster.bmp");
	 texture2 = TextureFactory::getTexture("thrusterp.bmp");
  }
  quadric = gluNewQuadric();
  gluQuadricDrawStyle(quadric, GLU_FILL);
  gluQuadricOrientation(quadric, GLU_OUTSIDE);
   glEnable(GL_TEXTURE_2D);
   glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);

  gluQuadricTexture(quadric, GL_TRUE);
}

Thruster::~Thruster()
{
  gluDeleteQuadric(quadric);
}

void Thruster::render(float speed, bool afterburn)
{
   if(speed == 0.0f)
      return;

   glTranslatef(location.x, location.y, location.z);
   glRotatef(180.0, 0.0f, 1.0f, 0.0f);
   gluQuadricDrawStyle(quadric, GLU_FILL);
   gluQuadricNormals(quadric, GLU_SMOOTH);
   gluQuadricOrientation(quadric, GLU_OUTSIDE);
   glEnable(GL_TEXTURE_2D);
//   glDisable(GL_COLOR_MATERIAL);
			glEnable(GL_COLOR_MATERIAL);
          glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
          glEnable(GL_BLEND);
		  glColor4f(1.0f, 1.0f, 1.0f, .97f);
		  texture->render();
  	gluCylinder(quadric, radius,  0.0f, radius*3.75f* speed, 13, 3);

		  glColor4f(1.0f, 1.0f, 1.0f, .7f);


		  texture2->render();
   gluCylinder(quadric, radius, 0.0f, radius*6.0f* speed, 13, 3);

		glDisable(GL_BLEND);


   glDisable(GL_TEXTURE_2D);
  // glEnable(GL_COLOR_MATERIAL);
   GLERRORCHECK
}

Coordinate Thruster::getLocation()
{
  return location;
}

void Thruster::clear()
{
//  delete texture;
  texture = NULL;
}
