// Time.cpp: implementation of the Time class.
//
//////////////////////////////////////////////////////////////////////

#include "Time.h"
#include <iostream.h>
#include "Constants.h"
#ifdef WIN32
#include <windows.h>
#else
#include <sys/time.h>
#include <time.h>
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TimeValue Time::lasttime = 0;
TimeValue Time::currenttime = 0;
int Time::ticks = 0;
float Time::scalefactor = 1.0f;
TimeValue Time::lastsecond = 0;
int Time::framecount = 0;
int Time::lastframecount = 0;


TimeValue Time::getCurrentTime()
{
  return currenttime;
}

void Time::advance()
{
  TimeValue temptime;

  if(lasttime == 0)
  {
//	 currenttime = GetTickCount();
    currenttime = getCurrentTimeImmediately();
     lasttime =  currenttime - 1;
	 lastsecond = currenttime;
     
  }

  framecount ++;
  if(currenttime - lastsecond > 1000)
  {
	lastframecount = framecount;
    framecount = 0;
	lastsecond = currenttime;
  }

//  temptime = GetTickCount();  
  temptime = getCurrentTimeImmediately();
//  if(temptime - lasttime < 5)
//  {
//    scalefactor = 0;

//  }
  //else
  {
    scalefactor = ((float) (getCurrentTime() - lasttime) ) * Constants::getTimeFactor();
    lasttime = currenttime;
	currenttime = temptime;
  }
}

float Time::getTimeScale()
{

  return scalefactor;
}

void Time::clear()
{
   lasttime = 0;
   ticks = 0;
   scalefactor = 1.0f;
#ifdef WIN32
   timeEndPeriod(1);
#endif
}

void Time::init()
{
#ifdef WIN32
  MMRESULT result;

  result = timeBeginPeriod(1);
  if(result != TIMERR_NOERROR )
  {
     cout << "Bad timer" << endl;

  }
#endif
  lastsecond = 0;


}

TimeValue Time::getCurrentTimeImmediately()
{
#ifdef WIN32
  return timeGetTime();
#else
  struct timeval tv;

  gettimeofday(&tv, NULL);
  return tv.tv_sec * 1000 + tv.tv_usec / 1000;
#endif
}

int Time::getFramesPerSecond()
{
  return lastframecount;
}
