// Time.h: interface for the Time class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TIME_H__756BD41D_FE33_4CEB_BEB3_4AC82C9A82A1__INCLUDED_)
#define AFX_TIME_H__756BD41D_FE33_4CEB_BEB3_4AC82C9A82A1__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef unsigned int TimeValue;

class Time  
{
public:
	static int getFramesPerSecond();
	static TimeValue getCurrentTimeImmediately();
	static void init();
	static void clear();
	/* returns the delta t since the last interval, multiplied by a scale factor */
	static float getTimeScale();
	static void advance();
	/** returned value is in millseconds, using the system ticker */
	static TimeValue getCurrentTime();
private:
	static float scalefactor;
	static int ticks;
   static TimeValue lasttime;
   static TimeValue currenttime;
   static int framecount;
   static int lastframecount;
   static TimeValue lastsecond;

};

#endif // !defined(AFX_TIME_H__756BD41D_FE33_4CEB_BEB3_4AC82C9A82A1__INCLUDED_)
