// TrackerMusic.cpp: implementation of the TrackerMusic class.
//
//////////////////////////////////////////////////////////////////////

#include "TrackerMusic.h"
#include "Settings.h"
#include "MusicManager.h"
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#ifdef HAS_BASS
void __stdcall sync_callback(HSYNC handle, DWORD channel, DWORD data, DWORD user)
{
  MusicManager::getInstance()->onMusicFinish();
}
#endif

TrackerMusic::TrackerMusic(char filename[], bool repeat)
{

#ifdef HAS_BASS
   int flags=BASS_MUSIC_RAMPS;

   if(Settings::getSettings()->getMusic() )
   {
     if(repeat)
       flags |= BASS_MUSIC_LOOP;         
     mymusic = BASS_MusicLoad(FALSE, filename, 0, 0, flags, 0);
     BASS_ChannelSetSync(mymusic, BASS_SYNC_END, 0, sync_callback, (DWORD)this);
     BASS_MusicSetAmplify(mymusic, 65);
     isplaying = true;
   }
#endif
}


TrackerMusic::~TrackerMusic()
{
#ifdef HAS_BASS
   if(Settings::getSettings()->getMusic() || isplaying)
      BASS_MusicFree(mymusic);
#endif
}

void TrackerMusic::play()
{
#ifdef HAS_BASS
   if(Settings::getSettings()->getMusic() )
      BASS_MusicPlay(mymusic);
#endif
}

void TrackerMusic::stop()
{
#ifdef HAS_BASS
   if(Settings::getSettings()->getMusic() || isplaying)
   {
     BASS_ChannelStop(mymusic);
     BASS_ChannelSetPosition(mymusic, 0);
   }
#endif
}

bool TrackerMusic::isPlaying()
{
#ifdef HAS_BASS
  return BASS_ChannelIsActive(mymusic);
#else
  return false;
#endif
}
