// TransparentImage.cpp: implementation of the TransparentImage class.
//
//////////////////////////////////////////////////////////////////////

#include "TransparentImage.h"
#include "TextureFactory.h"
#include <stdlib.h>
#include "glut.h"
#include "glerr.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TransparentImage::TransparentImage(char file[], Color transparent)
{
   texture = TextureFactory::getTransparentTexture(file, transparent);      
   width = texture->getWidth();
   height = texture->getHeight();
}

TransparentImage::~TransparentImage()
{

}

int TransparentImage::getHeight()
{
  return height * scale;
}


int TransparentImage::getWidth()
{
  return width * scale;
}


void TransparentImage::render(float x, float y)
{
  int oldmode;

  glPushMatrix();
  glTranslatef(x, y, 0.0f);
  if(rotationvalid)
  {
    glTranslatef(.5f * getWidth() , .5f * getHeight() , 0.0f);
    glRotatef(rotation, 0.0f, 0.0, 1.0f);
    glTranslatef(- getWidth() * .5f, -getHeight() * .5f, 0.0f);
  }

  color.render();
  GLERRORCHECK
  glEnable(GL_TEXTURE_2D);
  GLERRORCHECK
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  GLERRORCHECK
  texture->render();
  GLERRORCHECK
  glNormal3f(0.0f, 0.0f, 1.0f);
  glBegin(GL_QUADS);
    glTexCoord2f(0.0f, 0.0f);
    glVertex2f(0.0f, 0.0f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(getWidth(), 0.0f);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(getWidth() , getHeight() );
    glTexCoord2f(0.0f, 1.0f);
	glVertex2f(0.0f, getHeight() );
  glEnd();
  GLERRORCHECK
  glDisable(GL_TEXTURE_2D);
  GLERRORCHECK
  glPopMatrix();
}

void TransparentImage::recycle(GLubyte * bits, int width, int height)
{
  texture->recycle(bits, width, height);

}

TransparentImage::TransparentImage(char file [ ])
{
   texture = TextureFactory::getTransparentTexture(file);      
   width = texture->getWidth();
   height = texture->getHeight();

}
