// Turret.h: interface for the Turret class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TURRET_H__281CB064_59B7_4DEB_91BB_E0E8514DFA57__INCLUDED_)
#define AFX_TURRET_H__281CB064_59B7_4DEB_91BB_E0E8514DFA57__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Component.h"
#include "coord.h"
#include "coldet.h"
#include "mount.h"
#include <vector>
#include "Time.h"

class Turret : public Component  
{
public:
	virtual void advance();
	virtual bool instanceof(InstanceT it);
	void fire();
	virtual void rotateUp(float percent)=0;
	virtual void rotateSide(float percent)=0;
	CollisionModel3D * getBarrelCollisionModel();
	void getBarrelMatrix(float matrix[16]);
	void setBarrelMatrix(float newmatrix[16]);
	virtual bool instanceof(char name[]);
	bool isInited();
	virtual void render();
	virtual ~Turret();
	virtual void pushBarrelTransform()=0;
	virtual void setMatrix(float newmatrix [ 16 ]);
protected: 
	Object3d * getBarrelObject();
	Turret(std::string name, mesh * undamaged, mesh * damaged, mesh * barrel, int hitpoints,
		Coordinate translation, Coordinate heading, Coordinate up, Coordinate side,
		Coordinate bartranslation, Coordinate barnewheading, Coordinate barnewup, Coordinate barnewside,
		std::vector<mount *> * turretmounts);
    Turret(Turret & copy);
private:
	float barrelmatrix[16];
	bool initialized;
	mesh * barrel;
	Object3d * barrelobj;
	std::vector<mount *> * mounts;
	TimeValue firetime;
	TimeValue delay;
// save originals in case copied later
	Coordinate barheadingo;
	Coordinate barupo;
	Coordinate barsideo;


};

#endif // !defined(AFX_TURRET_H__281CB064_59B7_4DEB_91BB_E0E8514DFA57__INCLUDED_)
