// VFormationBehavior.cpp: implementation of the VFormationBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "VFormationBehavior.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

VFormationBehavior::VFormationBehavior()
{
  align.setAlignRoll(true);
//  align.setMatchSpeed(true);
}

VFormationBehavior::~VFormationBehavior()
{

}

void VFormationBehavior::setLeft(bool newleft)
{
  left = newleft;
}


void  VFormationBehavior::move(Targetable * body, Targetable * target)
{
  steerTo(body, getSteeringVector(body, target) );
}

Coordinate VFormationBehavior::getSteeringVector(Targetable * body, Targetable *  target)
{
  Coordinate offset;
  Coordinate zero;
  float radius;
  float distance;

//  align.setMatchSpeed(false);

  radius = body->getradius() + target->getradius() * 4.0f;

  if(left)
  {
      Coordinate left = target->getleft();
      Coordinate back = zero - target->getHeading();

      offset = left.average(back) * radius;

  }
  else
  {
      Coordinate right = zero - target->getleft();
      Coordinate back = zero - target->getHeading();

      offset = right.average(back) * radius;
  }

  distance = body->getLocation().distance( target->getLocation() + offset );
  pursue.setPursuitOffset(offset);
  if(distance > 2.0f *body->getradius() + body->getVelocity() )
  {
    body->incrementVelocity();
    return pursue.getSteeringVector(body, target);
  }
  else //if(distance > 1.0f)
  {
    float end = 2.0f *body->getradius() + body->getVelocity();
    float s = (distance ) / (end);


    if(distance < 2.0f * body->getradius() && distance > .5f)
    {
       body->decrementVelocity();      
    }
    else
    {
      matchSpeed(body, target);
    }

    return pursue.getSteeringVector(body, target) * ((s + .9f) * 5.0f )   + align.getSteeringVector(body, target) * (1.0f - s);

  }
/*  else
  {
    if(distance < 2.0f * body->getradius() && distance > .5f)
    {
       body->decrementVelocity();      
    }
    else
    {
      matchSpeed(body, target);
    }
    return (align.getSteeringVector(body, target));


  }*/
}

void VFormationBehavior::matchSpeed(Targetable * body, Targetable * target)
{
  if(body->getVelocity() < target->getVelocity() )
    body->incrementVelocity();
  else if(body->getVelocity() > target->getVelocity() )
  {
    body->decrementVelocity();
  }
}
