// WanderBehavior.cpp: implementation of the WanderBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "coord.h"
#include "WanderBehavior.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//WanderBehavior WanderBehavior::instance;

WanderBehavior::WanderBehavior()
{
  last_steering.x = 0.0f;
  last_steering.y = 0.0f;
  last_steering.z = 0.0f;
  endtime = 0;
}

WanderBehavior::~WanderBehavior()
{

}

void WanderBehavior::move(Targetable * body, Targetable * target)
{
/*  const float ship_to_circle = 2.0f;
  const float circle_radius = 30.0f;
  Coordinate mylocation = body->getLocation();
  Coordinate myheading = body->getHeading();
  
  Coordinate circle_center = mylocation + myheading * (ship_to_circle + circle_radius);  
  Coordinate spherepoint;

  spherepoint.x = (float) rand() / RAND_MAX;
  spherepoint.y = (float) rand() / RAND_MAX;
  spherepoint.z = (float) rand() / RAND_MAX;

  spherepoint.normalize();

  spherepoint.x *= circle_radius;
  spherepoint.y *= circle_radius;
  spherepoint.z *= circle_radius;

  spherepoint = spherepoint + circle_center;

  Coordinate steeringvector = spherepoint - mylocation;
  steerTo(body, steeringvector);
*/
  if(  last_steering.x == 0.0f && last_steering.y == 0.0f &&  last_steering.z == 0.0f)
  {
     last_steering = body->getHeading();
  }
  TimeValue  now = Time::getCurrentTime();
  if(now >= endtime)
  {
     endtime = now + 1500 + (int) (rand() * 2000.0f / RAND_MAX) - 1000 ;

    Coordinate randomoffset;  
    randomoffset.x = (float) rand()  / RAND_MAX;
    randomoffset.y = (float) rand() / RAND_MAX;
    randomoffset.z = (float) rand() / RAND_MAX;
    last_steering = randomoffset;
  }
  if(last_steering.x < .1f)
  {
    body->rotateleft();
  }
  else if(last_steering.x < .2f)
  {
    body->rotateright();
  }
  else if(last_steering.x < .3f)
  {
    body->rotateup();
  }
  else if(last_steering.x < .4f)
  {
    body->rotatedown();
  }
  else if(last_steering.x < .5f)
  {
    body->bankleft();
  }
  else if(last_steering.x < .6f)
  {
    body->bankleft();
  }
  else if(last_steering.x < .7f)
  {
    body->rotateleft();
    body->bankleft();
  }
  else if(last_steering.x < .8f)
  {
    body->rotateright();
    body->bankright();
  }
  else if(last_steering.x < .9f)
  {
    body->rotateleft();
    body->rotateup();
  }
  else if(last_steering.x < 1.0f)
  {
    body->rotateright();
    body->rotatedown();
  }

 
  //last_steering.normalize();
//  steerTo(body,last_steering);
}
