// XmlMeshFile.h: interface for the XmlMeshFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLMESHFILE_H__74DC77EA_6569_48CE_8FA5_70BF6F27D621__INCLUDED_)
#define AFX_XMLMESHFILE_H__74DC77EA_6569_48CE_8FA5_70BF6F27D621__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "HandlerBase.h"
#include <string>
#include "AbstractMeshFile.h"
#include "coord.h"
#include "Texture.h"
#include "Texel.h"

using namespace SAX;
using std::string;

class XmlMeshFile  : public AbstractMeshFile, public HandlerBase
{
public:
	XmlMeshFile(char filename[]);
	virtual ~XmlMeshFile();
	virtual Coordinate getExtents();
	virtual Coordinate getcenter();
	virtual float getradius();
	virtual void render();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
   Texture * * textures;
   Texel * texels;
   Coordinate * points;
   Coordinate * normals;
   int numfaces;
   int numtextures;
   int currentface;
   int currentpoint;
   int currenttexture;
   int   * pointsinface;
   int   * whichtexture;
   Coordinate extents;
   float radius;
   Coordinate center;
   Coordinate coord;
   string * texturefiles;
};

#endif // !defined(AFX_XMLMESHFILE_H__74DC77EA_6569_48CE_8FA5_70BF6F27D621__INCLUDED_)
