// XmlOutput.cpp: implementation of the XmlOutput class.
//
//////////////////////////////////////////////////////////////////////

#include "XmlOutput.h"
#include <iostream.h>
#include <fstream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XmlOutput::XmlOutput(ostream & newout)
  : out(newout)
{
  indentlevel = 0;
}

XmlOutput::~XmlOutput()
{

}


void XmlOutput::attribute(char name [ ], char value [ ])
{
  out << " " << name << "=\"" << value << "\"";
}


void XmlOutput::endAttributes()
{
  out << ">" << endl;
}

void XmlOutput::beginElement(char name [ ], bool hasattributes)
{
  indent();
  out << "<" << name;
  if(! hasattributes)
    out << ">" << endl;    
  indentlevel++;
}

void XmlOutput::endElement(char name [ ])
{
  indentlevel--;
  indent();
  out << "</" << name << ">" << endl;
}

void XmlOutput::endElement()
{
  indentlevel--;
  out << "/>" << endl;
}

void XmlOutput::header(char doctype [ ])
{
  out << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" << endl;
  out << "<!DOCTYPE " << doctype << " >" << endl;
}

void XmlOutput::indent()
{
  int i;

  for(i=0; i < indentlevel; i++)
  {
     out << "   ";
  }
}

void XmlOutput::attribute(char name [ ], int value)
{
  out << " " << name << " = \"" << value << "\" ";
}

void XmlOutput::attribute(char name [ ], float value)
{
  out << " " << name << " = \"" << value << "\" ";
}

void XmlOutput::attribute(char name [ ], bool value)
{

  out << " " << name << " = \"" ;
  if(value)
    out << "true" ;
  else
    out << "false";
  out << "\" ";
}
