#ifndef COORD_H
#define COORD_H

#include <math.h>
#include "Math.h"


class Coordinate {
public:
	float distanceSquared(Coordinate right);
	void print();
	Coordinate interpolate(Coordinate to, double t);
	Coordinate abs();
	Coordinate average(Coordinate other);
    bool operator<(Coordinate  coord);
//	bool operator==(Coordinate  coord);
	Coordinate operator*(float value);
	 inline Coordinate()
	 {
        x =0.0f;
		y = 0.0f;
		z = 0.0f;
	 }
	 inline Coordinate(float newx, float newy, float newz)
	 {
		 x = newx;
		 y = newy;
		 z = newz;
	 }
	Coordinate multiplybyglmatrix(float matrix[16]);   
	Coordinate operator+(Coordinate  coord);
	//   Coordinate operator-(Coordinate & coord);
   Coordinate operator-(Coordinate coord);
	Coordinate rotatearoundaxis(Coordinate axis, float theta);
  float x, y, z;
  float dot(Coordinate right);
  Coordinate cross(Coordinate right);
  inline float getlength()
  {
    return fastsqrt( x * x + y * y + z * z);
  }

  inline void normalize()
  {
    float length;

    length = getlength();
    x /= length;
    y /= length;
    z /= length;
  }

  float angle(Coordinate right);
  float distance(Coordinate right);
  Coordinate maxPairwise(Coordinate other);
  Coordinate minPairwise(Coordinate other);

private:
	Coordinate matrixmult(float m[4][4], Coordinate point);
};



bool operator<(const Coordinate lhs, const Coordinate rhs);

bool operator==(const Coordinate lhs, const Coordinate rhs);


#endif
