// mesh.h: interface for the mesh class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MESH_H__B6C5BAC9_588E_46D4_8DF5_8D6DB01AA5BE__INCLUDED_)
#define AFX_MESH_H__B6C5BAC9_588E_46D4_8DF5_8D6DB01AA5BE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "coord.h"
#include <GL/glew.h>
#include "Color.h"
#include "coldet.h"
#include <vector>

class AbstractMeshFile;

class mesh  
{
public:
	void setDefaultColor(Color newcolor);
	 mesh(char filename[], Color enemycolor, bool wireframe);
	Coordinate getMins();
	Coordinate getMaxs();
	CollisionModel3D * getCollisionModel();
	 mesh(char filename[], Color transparent);
	static void clear();
	Coordinate getExtents();
	Coordinate getcenter();
	float getradius();
	void render();
   mesh(char filename[]);
	virtual ~mesh();
private:
	static std::vector<mesh *> garbage;
	AbstractMeshFile * file;
//	static int nextdisplaylist;
	GLuint mydisplaylist;
   Coordinate center, extents;
   Coordinate max, min;
   float radius;
   CollisionModel3D * collision_model;
   bool istransparent;
   Color defaultcolor;
};

#endif // !defined(AFX_MESH_H__B6C5BAC9_588E_46D4_8DF5_8D6DB01AA5BE__INCLUDED_)
