// meshfile.cpp: implementation of the meshfile class.
//
//////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include "meshfile.h"
#include <glut.h>
#include <math.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

meshfile::meshfile(char filename[])
{

   
  trianglesFunct.storeData(filename);
  mesh = trianglesFunct.returnArray();
  ntriangles = trianglesFunct.getNumVectors() ;
  //printf("the max %e", *(trianglesFunct.triangleCoord).maxX);
  trianglesFunct.createCollsionStruct();

}

meshfile::~meshfile()
{
  delete mesh;
}

void meshfile::render()
{
    int i;    
    Coordinate lastcolor, thiscolor;

   glDisable(GL_TEXTURE_2D);

    glBegin(GL_TRIANGLES);
	   glColor3f(mesh[0].RGB.x, mesh[0].RGB.y, mesh[0].RGB.z);
      lastcolor = mesh[0].RGB;
	   for ( i=0; i<ntriangles; i++) 
      {
        thiscolor = mesh[i].RGB;
        if((thiscolor.x != lastcolor.x) ||  (thiscolor.y != lastcolor.y) || (thiscolor.z != lastcolor.z))
        {
          glColor3f(thiscolor.x, thiscolor.y, thiscolor.z);
        }
	     glNormal3f(mesh[i].normal1.x, mesh[i].normal1.y, mesh[i].normal1.z);
        glVertex3f(mesh[i].point1.x , mesh[i].point1.y , mesh[i].point1.z);
	     glNormal3f(mesh[i].normal2.x, mesh[i].normal2.y, mesh[i].normal2.z);
        glVertex3f(mesh[i].point2.x , mesh[i].point2.y , mesh[i].point2.z);
	     glNormal3f(mesh[i].normal3.x, mesh[i].normal3.y, mesh[i].normal3.z);
        glVertex3f(mesh[i].point3.x , mesh[i].point3.y , mesh[i].point3.z);
        lastcolor = thiscolor;
      }
    glEnd();
 	 glColor3f(1.0f, 0.0f, 0.0f);
    // render the bouding box


  struct collisionStruct collision;
  collision = trianglesFunct.returnCollisionStruct();
  glBegin(GL_LINES);
      glVertex3f(collision.maxX, collision.maxY, collision.maxZ);
      glVertex3f(collision.maxX, collision.maxY, collision.minZ);
      glVertex3f(collision.maxX, collision.maxY, collision.maxZ);
      glVertex3f(collision.maxX, collision.minY, collision.maxZ);
      glVertex3f(collision.maxX, collision.maxY, collision.maxZ);      
      glVertex3f(collision.minX, collision.maxY, collision.maxZ);

      glVertex3f(collision.minX, collision.minY, collision.minZ);
      glVertex3f(collision.minX, collision.maxY, collision.minZ);
      glVertex3f(collision.minX, collision.minY, collision.minZ);
      glVertex3f(collision.maxX, collision.minY, collision.minZ);
      glVertex3f(collision.minX, collision.minY, collision.minZ);
      glVertex3f(collision.minX, collision.minY, collision.maxZ);

      glVertex3f(collision.maxX, collision.minY, collision.maxZ);
      glVertex3f(collision.minX, collision.minY, collision.maxZ);
      glVertex3f(collision.maxX, collision.minY, collision.maxZ);
      glVertex3f(collision.maxX, collision.minY, collision.minZ);

      glVertex3f(collision.minX, collision.maxY, collision.maxZ);
      glVertex3f(collision.minX, collision.minY, collision.maxZ);
      glVertex3f(collision.minX, collision.maxY, collision.maxZ);
      glVertex3f(collision.minX, collision.maxY, collision.minZ);

      glVertex3f(collision.maxX, collision.minY, collision.minZ);
      glVertex3f(collision.minX, collision.minY, collision.minZ);
      glVertex3f(collision.maxX, collision.minY, collision.minZ);
      glVertex3f(collision.maxX, collision.maxY, collision.minZ);

      glVertex3f(collision.maxX, collision.maxY, collision.minZ);
      glVertex3f(collision.minX, collision.maxY, collision.minZ);
  glEnd();
  glEnable(GL_TEXTURE_2D);
}

float meshfile::getradius()
{
   return trianglesFunct.returnCollisionStruct().radius;
}

Coordinate meshfile::getcenter()
{
  Coordinate center;
  struct collisionStruct collision;
  
  collision = trianglesFunct.returnCollisionStruct();
  center.x = collision.centerX;
  center.y = collision.centerY;
  center.z = collision.centerZ;

  return center;
}

Coordinate meshfile::getExtents()
{
  struct collisionStruct collision;
  collision = trianglesFunct.returnCollisionStruct();
  float xext, yext, zext;

  xext = fabs(collision.maxX - collision.minX);
  yext = fabs(collision.maxY - collision.minY);
  zext = fabs(collision.maxZ - collision.minZ);
  return Coordinate(xext, yext, zext);
}
