#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "playerObj.h"
#include "collisionD.h"
#include <glut.h>

#define VIEWRADIUS 6.0

playerObj::playerObj() {
  collisionObj.minX=0;
  collisionObj.maxX=0;
  collisionObj.minY=0;
  collisionObj.maxY=0;
  collisionObj.minZ=0;
  collisionObj.maxZ=0;
  collisionObj.radius=3;
  speed=0;
  degreeOfRotation[0]=0;
  degreeOfRotation[1]=0;
  degreeOfRotation[2]=0;
  location.x = 0.0;
  location.y = 0.0;
  location.z = 2.0 * VIEWRADIUS;
  lookat.x = 0;
  lookat.y = 0.0 ;
  lookat.z = VIEWRADIUS;
  collisionObj.centerX=viewChange[0];
  collisionObj.centerY=viewChange[1];
  collisionObj.centerZ=viewChange[2];
  createCollsionStruct();
}

double playerObj::radian(double tmp) {
  return (tmp*3.14159)/180;
}

void playerObj::viewChangeTranslate (double difference[]) { 
  viewChange[3]-=difference[0];
  viewChange[4]-=difference[1];
  viewChange[5]-=difference[2];
}

void playerObj::Rotate(int degree, char* name) {
		double tmpVector[3];
		
    tmpVector[0]=viewChange[0];
    tmpVector[1]=viewChange[1];
    tmpVector[2]=viewChange[2];

    viewChangeTranslate(tmpVector);

	  if ( strcmp(name, "y") == 0) {
			viewChange[4]=viewChange[4]*cos(radian(degree))+viewChange[5]*-sin(radian(degree));
			viewChange[5]=viewChange[4]*sin(radian(degree))+viewChange[5]*cos(radian(degree));
		}
		else if ( strcmp(name, "x") == 0) {
			viewChange[3]=viewChange[3]*cos(radian(degree))+viewChange[5]*sin(radian(degree));
			viewChange[5]=viewChange[3]*-sin(radian(degree))+viewChange[5]*cos(radian(degree));
		}
		else {
			printf("incorrect axis name\n");
			exit(1);
		}
    tmpVector[0]=-viewChange[0];
    tmpVector[1]=-viewChange[1];
    tmpVector[2]=-viewChange[2];

    viewChangeTranslate(tmpVector);
}

void playerObj::update() {
  collisionObj.centerX=viewChange[0];
  collisionObj.centerY=viewChange[1];
  collisionObj.centerZ=viewChange[2];
}

void playerObj::forward() {

}

void playerObj::createVector(double vector[],double vector2[],double resultVector[],int length) {
		for (int i=0; i<length; i++)
			resultVector[i]=vector2[i]-vector[i];
}

double playerObj::createVectorLength(double vector[], int length) {
double result=0;
		
		for (int i=0; i<length; i++)
			result+=vector[i]*vector[i];
		
		result=sqrt(result);
		return result;
}

void playerObj::createCollsionStruct() {
}

struct collisionStruct* playerObj::returnCollisionStruct() {
  return &collisionObj;
}

void playerObj::advance()
{
//  forward();
   location.x += speed * heading.x;
   location.y += speed * heading.y;
   location.z += speed * heading.z;  

	collisionObj.centerX = location.x;
   collisionObj.centerY = location.y;
   collisionObj.centerZ = location.z;
}

void playerObj::bankleft()
{
  Object3d::bankleft();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;

}

void playerObj::bankright()
{
  Object3d::bankright();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;

}

void playerObj::rotateup()
{
  Object3d::rotateup();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;

//  Rotate(-4,"y");
}

void playerObj::rotatedown()
{
  Object3d::rotatedown();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;

//  Rotate(4, "y");
}

void playerObj::rotateleft()
{
  Object3d::rotateleft();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;

//  Rotate(4, "x");
}

void playerObj::rotateright()
{
  Object3d::rotateright();
  lookat.x = heading.x * VIEWRADIUS;
  lookat.y = heading.y * VIEWRADIUS;
  lookat.z = heading.z * VIEWRADIUS;
//  Rotate(-4, "x");
}

void playerObj::render()
{
   gluLookAt (location.x, location.y, location.z, location.x + lookat.x, location.y + lookat.y, location.z + lookat.z, up.x, up.y, up.z);
}

void playerObj::setVelocity(float v)
{
  speed = v;
}


void playerObj::incVelocity()
{
 if ( speed<10 ) 
    speed+=0.1;
}

void playerObj::decVelocity()
{
  if (speed>0.1)
     speed-=0.1;
  else speed=0;
}

struct collisionStruct* playerObj::getCollision()
{
  return &collisionObj;
}

Coordinate playerObj::getLocation()
{
  Coordinate c;


  c= Object3d::getLocation();
 // c.x = -c.x;
 // c.y = -c.y;
//  c.z = -c.z;
  return c;
}
