#ifndef QUATERNION_H
#define QUATERNION_H

#include "coord.h"

class quaternion
{
  public: 
	   quaternion();
     /* angle must be in radians */          
     virtual ~quaternion();
	  quaternion(Coordinate axis, float angle);
	  quaternion(float newx, float newy, float newz, float w);
     void tomatrix(float matrix[4][4]);


  private:    
     float x;
     float y;
     float z;
     float w;

};


/*
void EulerToQuat(float roll, float pitch, float yaw, QUAT * quat)
{
	float cr, cp, cy, sr, sp, sy, cpcy, spsy;

// calculate trig identities
   cr = cos(roll/2);
	cp = cos(pitch/2);
	cy = cos(yaw/2);

	sr = sin(roll/2);
	sp = sin(pitch/2);
	sy = sin(yaw/2);
	
	cpcy = cp * cy;
	spsy = sp * sy;

	quat->w = cr * cpcy + sr * spsy;
	quat->x = sr * cpcy - cr * spsy;
	quat->y = cr * sp * cy + sr * cp * sy;
	quat->z = cr * cp * sy - sr * sp * cy;
}

void QuatRotAxis(QUAT * q, float x, float y, float z, float angle)
{
  float sine, cosine;


  sine = sin(angle / 2);
  cosine = cos(angle/2);

  q->x = x * sine;
  q->y = y * sine;
  q->z = z * sine;
  q->w = cosine;


}


void QuatToMatrix(QUAT * quat, float m[4][4])
{
  float wx, wy, wz, xx, yy, yz, xy, xz, zz, x2, y2, z2;
  // calculate coefficients

  x2 = quat->x + quat->x; y2 = quat->y + quat->y; 
  z2 = quat->z + quat->z;
  xx = quat->x * x2;   xy = quat->x * y2;   xz = quat->x * z2;
  yy = quat->y * y2;   yz = quat->y * z2;   zz = quat->z * z2;
  wx = quat->w * x2;   wy = quat->w * y2;   wz = quat->w * z2;

  m[0][0] = 1.0 - (yy + zz);    m[0][1] = xy - wz;
  m[0][2] = xz + wy;            m[0][3] = 0.0;
                    
  m[1][0] = xy + wz;            m[1][1] = 1.0 - (xx + zz);
  m[1][2] = yz - wx;            m[1][3] = 0.0;

  m[2][0] = xz - wy;            m[2][1] = yz + wx;
  m[2][2] = 1.0 - (xx + yy);    m[2][3] = 0.0;

  m[3][0] = 0;                  m[3][1] = 0;
  m[3][2] = 0;                  m[3][3] = 1;
}
*/

/*class quaternion  
{
public:
	quaternion();
	virtual ~quaternion();

};
*/

#endif