// shipareas.cpp: implementation of the shipareas class.
//
//////////////////////////////////////////////////////////////////////


#include "shipareas.h"
#include "Time.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

shipareas::shipareas(int newfront, int newback, int newleft, int newright)
  : front(newfront), back(newback), left(newleft), right(newright), rechargerate(0),
    currentfront(newfront), currentback(newback), currentleft(newleft), currentright(newright)
{

}
shipareas::shipareas(int newfront, int newback, int newleft, int newright, int newrecharge)
  : front(newfront), back(newback), left(newleft), right(newright), rechargerate(newrecharge),
    currentfront(newfront), currentback(newback), currentleft(newleft), currentright(newright)
{

}
shipareas::~shipareas()
{

}

void shipareas::recharge()
{
  float rate = rechargerate * Time::getTimeScale();
  if(currentfront + rate > front)
    currentfront = front;
  else 
    currentfront += rate;
  if(currentback + rate > back)
    currentback = back;
  else 
    currentback += rate;
  if(currentright + rate > right)
    currentright = right;
  else 
    currentright += rate;
  if(currentleft + rate > left)
    currentleft = left;
  else 
    currentleft += rate;
}

int shipareas::damage(areas whicharea, int amount)
{
  int armordamage;

  armordamage = 0;
  switch(whicharea)
  {
     case FRONT:
       if( currentfront - amount < 0)
       {
         armordamage = amount - currentfront;
         currentfront = 0;
       }
       else 
       {
         currentfront -= amount;
       }
       break;
     case BACK:
       if(currentback - amount < 0)
       {
         armordamage = amount - currentback;
         currentback = 0;
       }
       else 
       {
         currentback -= amount;
       }
       break;
     case LEFT:
       if(currentleft - amount < 0)
       {
         armordamage = amount - currentleft;
         currentleft = 0;
       }
       else 
       {
         currentleft -= amount;
       }
       break;
     case RIGHT:
       if(currentright - amount < 0)
       {
         armordamage = amount - currentright;
         currentright = 0;
       }
       else 
       {
         currentright -= amount;
       }
       break;

  };
  return armordamage;
}

int shipareas::getMaximum(areas whicharea)
{
  switch(whicharea)
  {
     case FRONT:
       return  front;
       break;
     case BACK:
       return  back;       
       break;
     case LEFT:
       return  left;            
       break;
     case RIGHT:
       return  right;       
       break;

  };
  return 0;
}

int shipareas::getCurrentValue(areas whicharea)
{
  switch(whicharea)
  {
     case FRONT:
       return  currentfront;
       break;
     case BACK:
       return  currentback;       
       break;
     case LEFT:
       return  currentleft;            
       break;
     case RIGHT:
       return  currentright;       
       break;

  };
  return 0;
}

bool shipareas::lessThanPercent(float percent)
{
  if( (float)currentfront/ (float)front < percent)
    return true;
  if( (float)currentleft/ (float)left < percent)
    return true;
  if( (float)currentback/ (float)back < percent)
    return true;
  if( (float)currentright/ (float)right < percent)
    return true;
  return false;
}

bool shipareas::hasAnyOriginally()
{
  return back > 0 || front > 0 || left > 0 || right > 0;
}
