// shipxmladapter.h: interface for the shipxmladapter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHIPXMLADAPTER_H__203EDF97_5D0E_492E_A562_8BF34C732552__INCLUDED_)
#define AFX_SHIPXMLADAPTER_H__203EDF97_5D0E_492E_A562_8BF34C732552__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "HandlerBase.h"
#include "coord.h"	// Added by ClassView
#include "shipareas.h"
#include <string>
#include <vector>
class Thruster;
class ship;
class mount;
class Component;
class Pod;
class Turret;

using namespace SAX;
using std::string;

class shipxmladapter  : public HandlerBase
{
public:
	ship * getship();



	shipxmladapter(char xmlfilename[]);
	virtual ~shipxmladapter();
   virtual void startDocument();
	virtual void endDocument();
	virtual void startElement(const std::string& name, const SAX::AttributeList* atts);
	virtual void endElement(const std::string& name);
	virtual void characters(const std::string& ch);
private:
	int weaponnumber;
   shipareas currentshipareas;
   shipareas armor;
   shipareas shields;
	Coordinate currentcoordinate;
   Coordinate cockpitlocation;
   Coordinate constraint;
   bool jointconstraint;
   float cone;
   Coordinate turretlocation;
   Coordinate barrellocation;
 	string meshfilename;
 	mount **  mounts; /*  array of mount pointers */
   int nummounts;
   int currentmount;
   float roll, pitch, yaw, velocity;
   float acceleration, angular_acceleration;
   float afterburner_velocity, afterburner_acceleration;
   float fuel;
   float radius, length;
   int numthrusters;
   Thruster ** thrusters;
   int currentthruster;
   string imagename;
   string shipname;
   int numshots;
   int totalenergy;
   int energy_recharge_rate;
   float mass;
   bool iscapship;
   // for compontns
   string component_name;
   string component_mesh;
   string component_damaged_mesh;
   string cockpit_mesh;
   string barrelmesh;
   int component_hitpoints;
   int num_components;
   int current_component;
   Component ** components;
   int numpods;
   int currentpod;
   Pod ** pods;
   std::vector<Turret *> * turrets;
   float rotation[9];
   float turretrotation[9];
   float barrelrotation[9];
   std::vector<Coordinate> enginelocations;
   std::vector<Coordinate> explosionlocations;
   int numdecoys;
   int hitpoints;
};

#endif // !defined(AFX_SHIPXMLADAPTER_H__203EDF97_5D0E_492E_A562_8BF34C732552__INCLUDED_)
