#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "triangleObj.h"
#include "OpenFile.h"
#include "collisionD.h"

triangleObj::triangleObj() {
  collisionObj.minX=0;
  collisionObj.maxX=0;
  collisionObj.minY=0;
  collisionObj.maxY=0;
  collisionObj.minZ=0;
  collisionObj.maxZ=0;
  collisionObj.centerX=0;
  collisionObj.centerY=0;
  collisionObj.centerZ=0;
  collisionObj.radius=0;
}

void triangleObj::printData(triangleStruct dataArray) {
  cout<<dataArray.point1.x<<" ";
  cout<<dataArray.point1.y<<" ";
  cout<<dataArray.point1.z<<", ";

  cout<<dataArray.normal1.x<<" ";
  cout<<dataArray.normal1.y<<" ";
  cout<<dataArray.normal1.z<<", ";

  cout<<dataArray.point2.x<<" ";
  cout<<dataArray.point2.y<<" ";
  cout<<dataArray.point2.z<<", ";

  cout<<dataArray.normal2.x<<" ";
  cout<<dataArray.normal2.y<<" ";
  cout<<dataArray.normal2.z<<", ";

  cout<<dataArray.point3.x<<" ";
  cout<<dataArray.point3.y<<" ";
  cout<<dataArray.point3.z<<", ";

  cout<<dataArray.normal3.x<<" ";
  cout<<dataArray.normal3.y<<" ";
  cout<<dataArray.normal3.z<<", ";

  cout<<dataArray.RGB.x<<" ";
  cout<<dataArray.RGB.y<<" ";
  cout<<dataArray.RGB.z<<endl;
}

void triangleObj::boundingBox(char *direction, double coord) {
  if (strcmp(direction, "x") == 0) {
    if (coord<collisionObj.minX)
      collisionObj.minX=coord;
    else if (coord>collisionObj.maxX)
      collisionObj.maxX=coord;
    return;
  } else if (strcmp(direction, "y")==0) {
    if (coord<collisionObj.minY)
      collisionObj.minY=coord;
    else if (coord>collisionObj.maxY)
      collisionObj.maxY=coord;
    return;
  } else if (strcmp(direction, "z")==0) {
    if (coord<collisionObj.minZ)
      collisionObj.minZ=coord;
    else if (coord>collisionObj.maxZ)
      collisionObj.maxZ=coord;
    return;
  }
}


void triangleObj::inputData(char* readLine, triangleStruct & dataArray) {
  char seps[]=" ,\t\n";
  double tmpDouble=0;
  char* token;

  token = strtok(readLine, seps);
  dataArray.point1.x=atof(token);
  boundingBox("x", dataArray.point1.x);
  token = strtok(NULL, seps);
  dataArray.point1.y=atof(token);
  boundingBox("y", dataArray.point1.y);
  token = strtok(NULL, seps);
  dataArray.point1.z=atof(token);
  boundingBox("z", dataArray.point1.z);

  token = strtok(NULL, seps);
  dataArray.normal1.x=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal1.y=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal1.z=atof(token);

  token = strtok(NULL, seps);
  dataArray.point2.x=atof(token);
  boundingBox("x", dataArray.point2.x);
  token = strtok(NULL, seps);
  dataArray.point2.y=atof(token);
  boundingBox("y", dataArray.point2.y);
  token = strtok(NULL, seps);
  dataArray.point2.z=atof(token);
  boundingBox("z", dataArray.point2.z);

  token = strtok(NULL, seps);
  dataArray.normal2.x=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal2.y=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal2.z=atof(token);

  token = strtok(NULL, seps);
  dataArray.point3.x=atof(token);
  boundingBox("x", dataArray.point3.x);
  token = strtok(NULL, seps);
  dataArray.point3.y=atof(token);
  boundingBox("y", dataArray.point3.y);
  token = strtok(NULL, seps);
  dataArray.point3.z=atof(token);
  boundingBox("z", dataArray.point3.z);

  token = strtok(NULL, seps);
  dataArray.normal3.x=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal3.y=atof(token);
  token = strtok(NULL, seps);
  dataArray.normal3.z=atof(token);

  token = strtok(NULL, seps);
  dataArray.RGB.x=atof(token);
  token = strtok(NULL, seps);
  dataArray.RGB.y=atof(token);
  token = strtok(NULL, seps);
  dataArray.RGB.z=atof(token);
}

void triangleObj::storeData(char argv[]) {
  OpenFile inputFile;
  char* token;
  char readLine[LINE_LENGTH];
  char seps[]=" ,\t\n";

  inputFile.createFile(argv);
  inputFile.readFile(readLine); 
  token=strtok(readLine, seps);
  if ((vectorlength=atoi(token))==0) {
    cerr<<"can't not get the number of coord in the file"<<endl;
    exit(1);
  }

  triangleCoord=new triangleStruct[vectorlength];
  for (int x=0; x<vectorlength; x++) {
    inputFile.readFile(readLine);
    inputData(readLine, triangleCoord[x]);
  }
}

triangleStruct* triangleObj::returnArray() {
	return triangleCoord;
}

int triangleObj::getNumVectors() {
  return vectorlength;
}

void triangleObj::createCollsionStruct() {
  collisionD tmpCollisionObj;

  tmpCollisionObj.centerObj(collisionObj);
  tmpCollisionObj.radObj(collisionObj);
}

struct collisionStruct triangleObj::returnCollisionStruct() {
  return collisionObj;
}