// weapon.h: interface for the weapon class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEAPON_H__5E55CA66_F6CE_45F3_A36D_2FED4186DABA__INCLUDED_)
#define AFX_WEAPON_H__5E55CA66_F6CE_45F3_A36D_2FED4186DABA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Object3d.h"
#include "coord.h"	// Added by ClassView
#include "GunDescription.h"
#include "SoundEffect3d.h"
#include "DiffuseLight.h"


class weapon : public Object3d  
{
public:
	void setDamagePercent(float percent);
	virtual bool instanceof(InstanceT it);
	virtual void  render();
	virtual void advance();
	void setFiredByPlayer();
	virtual bool instanceof(char classname [ ]);
	void setcanthit(Object3d * obj);
	virtual bool cantHit(Object3d * other);
	virtual void damage(int amount, Coordinate fromlocation);
	virtual void onCollisionWith(Object3d * newobject);
//	virtual bool isdestroyed();
	weapon(GunDescription * description, Coordinate position, Coordinate newheading, 
		Coordinate newup, Coordinate newleft,
		SoundEffect3d * neweffect);
	virtual ~weapon();
private:
	bool canDamage(Object3d * newobject);
	Coordinate getoffset(mesh * newmesh, Coordinate pheading);
   GunDescription * description;
   Object3d * canthit;
   bool fired_by_player;
   SoundEffect3d * effect;
   DiffuseLight light;
   float damagepercent;
};

#endif // !defined(AFX_WEAPON_H__5E55CA66_F6CE_45F3_A36D_2FED4186DABA__INCLUDED_)
