// weapondescription.h: interface for the weapondescription class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEAPONDESCRIPTION_H__B6EC8C1D_B7D3_4344_A75B_15469CE537CC__INCLUDED_)
#define AFX_WEAPONDESCRIPTION_H__B6EC8C1D_B7D3_4344_A75B_15469CE537CC__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>

class mesh;
class Image;

using std::string;

class weapondescription  
{
public:
	float getRangeSquared();
	int getSoundIndex();
	bool canDamageTurrets();
	bool canDamageCapships();
	virtual void load();
	Image * getIcon();

	float getAcceleration();
	int getRefireDelay();
	virtual bool isMissile();
	string getName();
	mesh * getmesh();
	int getdamage();
	float getrange();
   float getRoll(){return roll;}
   float getPitch(){return pitch;}
   float getYaw(){return yaw;}
   float getVelocity(){return velocity;}
   weapondescription(float newrange, int newdamage, std::string newmesh, 
	   float velocity, float roll, float pitch, float yaw, std::string name, 
		int new_refire_delay, float acceleration,
		std::string newicon, bool transparentmesh,
		bool newdamagecapships, bool newdamageturrets,
		int soundindex);
	virtual ~weapondescription();

private:
   bool loaded;
   int refiredelay;
   float range;
   float rangesquared;
   int damage;
   mesh * mymesh;
   float roll, pitch, yaw, velocity, acceleration;
   string name;
   Image * image;
   std::string imagename;
   std::string meshname;
   bool transparentmesh;
   bool damage_capships;
   bool damage_turrets;
   int soundindex;

};

#endif // !defined(AFX_WEAPONDESCRIPTION_H__B6EC8C1D_B7D3_4344_A75B_15469CE537CC__INCLUDED_)
