// weaponsxmladapter.cpp: implementation of the weaponsxmladapter class.
//
//////////////////////////////////////////////////////////////////////

#include "weaponsxmladapter.h"
#include "AttributeList.h"
//#include <iostream.h>
#include <ctype.h>
#include "MissileDescription.h"
#include "GunDescription.h"
#include "ErrorHandlerE.h"
#include "OutOfBoundsException.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "saxexpat.h"
#include "InputSource.h"
#include "Constants.h"

weaponsxmladapter::weaponsxmladapter(char xmlfilename[])
  : descriptions(NULL)
{
	expat myParser;

   tracking = false;
   billboard = "";
   damage_capships = false;
   damage_turrets = false;
   currentweapon = 0;
   velocity = roll = pitch = yaw = 0.0f;
   chargetime = 0;
   reticlename = "";
	myParser.setDocumentHandler(*this);
   myParser.setErrorHandler(ErrorHandlerE::getInstance() );
   myParser.parse(* (new SAX::InputSource(xmlfilename)));
 
}

/* the getter class must free */
weaponsxmladapter::~weaponsxmladapter()
{
}


void weaponsxmladapter::startDocument()
{

}

void weaponsxmladapter::endDocument()
{

}

void weaponsxmladapter::startElement(const std::string& name, const SAX::AttributeList* atts)
{
   int i;
   //cout << name.c_str() << endl;
   if(name == "weaponsfile")
   {

      for(i=0; i < atts->getLength(); i++)
      {
        std::string  currentname = atts->getName(i);
        std::string  currentvalue = atts->getValue(i);

         if(currentname == "numweapons")
         {
            numweapons =  atoi( currentvalue.c_str() );        
            descriptions = new weapondescription *[numweapons];
         }
      }

   }
   else if(name == "gun")
   {  
      for(i=0; i < atts->getLength(); i++)
      {
      
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "mesh")
         {
            currentmesh = currentvalue.c_str();
         }
         else if(currentname == "range")
         {
            currentrange =  atof(currentvalue.c_str() ) * Constants::getDistanceFactor();        
         }
         else if(currentname == "damage")
         {
            currentdamage =  atoi(currentvalue.c_str() );        
         }
         else if(currentname == "charge_time")
         {
            chargetime =  atoi(currentvalue.c_str() );        
         }
         else if(currentname == "name")
         {
            this->currentname =  currentvalue;        
         }
         else if(currentname == "refire_delay")
         {
            refiredelay =  atoi(currentvalue.c_str() );        
         }
         else if(currentname == "energy")
         {
            energy =  atoi(currentvalue.c_str() );        
         }
         else if(currentname == "sound")
         {
            soundindex =  atoi(currentvalue.c_str() );        
         }
		 else if(currentname == "icon")
		 {
            currenticon =  currentvalue;
		 }
		 else if(currentname == "damage_turrets")
		 {
            damage_turrets = (currentvalue == "true");
		 }
		 else if(currentname == "damage_capships")
		 {
            damage_capships = (currentvalue == "true");
		 }

      }
   }
   else if(name == "speeds")
   {
      for(i=0; i < atts->getLength(); i++)
      {
      
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "velocity")
         {
            velocity = atof(currentvalue.c_str() ) * Constants::getDistanceFactor();
         }
         else if(currentname == "roll")
         {
            roll = atof(currentvalue.c_str() ) * Constants::getAngleFactor();
         }
         else if(currentname == "pitch")
         {
            pitch = atof(currentvalue.c_str() )* Constants::getAngleFactor();
         }
         else if(currentname == "yaw")
         {
            yaw = atof(currentvalue.c_str() )* Constants::getAngleFactor();
         }
         else if(currentname == "acceleration")
         {
			 //is this factor right
            acceleration = atof(currentvalue.c_str() )* Constants::getDistanceFactor();
         }
      }
   }
   else if(name == "missile")
   {
      for(i=0; i < atts->getLength(); i++)
      {
      
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "mesh")
         {
            currentmesh = currentvalue;
         }
         else if(currentname == "range")
         {
            currentrange =  atof(currentvalue.c_str() )* Constants::getDistanceFactor();        
         }
         else if(currentname == "damage")
         {
            currentdamage =  atoi(currentvalue.c_str() );        
         }
         else if(currentname == "name")
         {
            this->currentname =  currentvalue;        
         }
         else if(currentname == "image")
         {
            currentimage = currentvalue;
         }
		 else if(currentname == "icon")
		 {
            currenticon = currentvalue;
		 }
         else if(currentname == "locktime")
         {
            locktime = atoi(currentvalue.c_str() );        
         }
         else if(currentname == "tracking")
         {
           if(currentvalue == "true")
             tracking = true;
         }
         else if(currentname == "refire_delay")
         {
            refiredelay =  atoi(currentvalue.c_str() );        
         }
		 else if(currentname == "damage_turrets")
		 {
            damage_turrets = (currentvalue == "true");
		 }
		 else if(currentname == "damage_capships")
		 {
            damage_capships = (currentvalue == "true");
		 }
		 else if(currentname == "exhaust")
		 {
			exhaust = currentvalue;
		 }
         else if(currentname == "spoof")
         {
            spoof =  atof(currentvalue.c_str() );        
         }
         else if(currentname == "sound")
         {
            soundindex =  atoi(currentvalue.c_str() );        
         }
      }
   }
   else if(name == "armor")
   {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "front")
         {
            front = atoi(currentvalue.c_str() );
         }
         else if (currentname == "rear")
         {
            rear = atoi(currentvalue.c_str() );
         }
         else if(currentname == "left")
         {
            left = atoi(currentvalue.c_str() );
         }
         else if(currentname == "right")
         {
            right = atoi(currentvalue.c_str() );
         }
      }
   }
   else if(name == "color")
   {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "r")
         {
            lightcolor.r = atof(currentvalue.c_str() );
         }
         else if (currentname == "g")
         {
            lightcolor.g = atof(currentvalue.c_str() );
         }
         else if(currentname == "b")
         {
            lightcolor.b = atof(currentvalue.c_str() );
         }
      }
   }

   else if(name == "reticle")
   {
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "name")
         {
            reticlename = currentvalue;
         }
         else if (currentname == "type")
         {
            reticletype = currentvalue;
         }
      }
   }
   else if(name == "billboard")
   {
	  string texture;
      for(i=0; i < atts->getLength(); i++)
      {
         std::string  currentname = atts->getName(i);
         std::string  currentvalue = atts->getValue(i);
         if(currentname == "texture")
         {
            texture = currentvalue;
         }
         else if (currentname == "width")
         {
            width = atof( (char *)currentvalue.c_str() );
         }
         else if (currentname == "height")
         {
            height = atof( (char *)currentvalue.c_str() );
         }

      }
      billboard = texture;

   }

}

void weaponsxmladapter::endElement(const std::string& name)
{

   if(name == "gun")
   {
     if(currentweapon >= numweapons)
     {
  
       throw OutOfBoundsException("weapons.xml");
       return;
     }

      descriptions[currentweapon] = new GunDescription(
		  currentrange,currentdamage,  currentmesh, velocity, roll, pitch, yaw, 
		  currentname, energy, refiredelay, soundindex, billboard, width, height, 
		  currenticon,
		  damage_capships,
		  damage_turrets,
		  lightcolor,
		  chargetime);
      currentweapon++;
	  billboard = "";
	  damage_capships = false;
	  damage_turrets = false;
	  chargetime = 0;
	  currenticon = "";
   }      
   else if(name == "missile")
   {
     if(currentweapon >= numweapons)
     {
  
       throw OutOfBoundsException("weapons.xml");
       return;
     }

      descriptions[currentweapon] = new MissileDescription(
		  currentrange,currentdamage,  currentmesh, velocity, roll, pitch, yaw, 
		  acceleration, currentname, currentimage, 
		  shipareas(front, rear, left, right), locktime, tracking, 
		  damage_capships, damage_turrets,
		  refiredelay, spoof, soundindex,
		  reticlename, reticletype, currenticon, exhaust);
	  reticlename = "";
	  currenticon = "";
	  damage_capships = false;
	  damage_turrets = false;
      currentweapon++;
   }      

}

void weaponsxmladapter::characters(const std::string& ch)
{

}


int weaponsxmladapter::getnumweapons()
{
  return numweapons;
}

weapondescription * * weaponsxmladapter::getweapondescriptions()
{
   return descriptions;
}
