#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include "wepObj.h"
#include "triangleObj.h"
#include "collisionD.h"
#include <glut.h>

wepObj::wepObj(triangleStruct newmesh[],int numtriangle,struct collisionStruct bounds,Coordinate direction,Coordinate position) {
  mesh = newmesh;
  ntriangles = numtriangle;
  init();
  location=position;
  heading=direction;
  heading.x = -heading.x;
  heading.y = -heading.y;
  heading.z = -heading.z;
  collisionObj=bounds;
}

wepObj::wepObj(char filename[]) {
  triangleObj trianglesFunct;
   
  trianglesFunct.storeData(filename);
  mesh=trianglesFunct.returnArray();
  ntriangles=trianglesFunct.getNumVectors() ;
  trianglesFunct.createCollsionStruct();
  init();
  collisionObj = trianglesFunct.returnCollisionStruct(); 
}

void wepObj::resetheadings() {
  heading.x = 0.0;
  heading.y = 0.0;
  heading.z = 1.0;
  up.x = 0.0;
  up.y = 1.0;
  up.z = 0.0;
  left.x = 1.0;
  left.y = 0.0;
  left.z = 0.0;
}

void wepObj::printLocation() {

//cout << "the x,y,z location"<<location.x<<" "<<location.y<<" "<<location.z<<endl;
}
void wepObj::init() {
  collisionD tmpCollisionObj;

  location.x = 1.0f;
  location.y = 1.0f;
  location.z = 10.0f;
  forwardvelocity = 0.2f;
  leftrightangle = 0.0f;
  bankangle = 0.0f;
  updownangle = 0.0f;
  roll = 5.0;
  pitch = 5.0;
  yaw = 5.0;
  resetheadings();
  collisionObj.minX=0;
  collisionObj.maxX=0;
  collisionObj.minY=0;
  collisionObj.maxY=0;
  collisionObj.minZ=0;
  collisionObj.maxZ=0;
  collisionObj.centerX=0;
  collisionObj.centerY=0;
  collisionObj.centerZ=0;
  collisionObj.radius=0; 
}

void wepObj::weaponMove() {
  advance();
}

void wepObj::render()
{
   glPushMatrix();
   glScalef(6.0, 6.0, 6.0);
   Object3d::render();
   glPopMatrix();
   printLocation();
}
