#include "worldSpace.h"

worldSpace::worldSpace (int size) {
  maxSize=size;
  sizeWorldObjs=0;
  worldObjects=new struct worldObjs[size];

  for (int i=0;i<size;i++) {
    worldObjects[i].isfree=0;
    worldObjects[i].isPlayer=0;
  }
}

void worldSpace::addObj(Object3d *obj) {

  for (int i=0;i<maxSize;i++) {
    if (worldObjects[i].isfree==0) {
		worldObjects[i].objPointer=obj;
      worldObjects[i].isfree=1;
		worldObjects[i].collisionObj=obj->getCollision();
      sizeWorldObjs++;
      return;
    }
  }
  //error report
}

int worldSpace::returnSizeWorldObjs() {
  return sizeWorldObjs;
}

int worldSpace::returnMaxSize() {
  return maxSize;
}

struct worldObjs* worldSpace::returnStruct() {
  return worldObjects;
}

void worldSpace::render() {
   for (int i=0;i<maxSize;i++) {
    if (worldObjects[i].isfree==1)
      worldObjects[i].objPointer->render();
   }
}

void worldSpace::advance() {
  for (int i=0;i<maxSize;i++) {
    if (worldObjects[i].isfree==1)
      worldObjects[i].objPointer->advance();
   } 
}